#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 505
#define LARGE_STATE_COUNT 88
#define SYMBOL_COUNT 243
#define ALIAS_COUNT 0
#define TOKEN_COUNT 108
#define EXTERNAL_TOKEN_COUNT 7
#define FIELD_COUNT 11
#define MAX_ALIAS_SEQUENCE_LENGTH 5
#define PRODUCTION_ID_COUNT 24

enum {
  anon_sym_DQUOTE = 1,
  aux_sym_legacy_quoted_stmt_token1 = 2,
  anon_sym_TILDE = 3,
  sym_grep_specifier_identifier = 4,
  aux_sym_grep_specifier_token1 = 5,
  anon_sym_PIPE = 6,
  anon_sym_PIPEH = 7,
  anon_sym_AT_AT_DOT = 8,
  anon_sym_AT_AT_EQ = 9,
  anon_sym_AT_AT_AT_EQ = 10,
  anon_sym_AT_AT = 11,
  anon_sym_AT_ATc_COLON = 12,
  anon_sym_AT_AT_ATc_COLON = 13,
  anon_sym_AT_ATC = 14,
  anon_sym_COLON = 15,
  anon_sym_AT_ATdbt = 16,
  anon_sym_AT_ATdbta = 17,
  anon_sym_AT_ATdbtb = 18,
  anon_sym_AT_ATdbts = 19,
  anon_sym_AT_ATt = 20,
  anon_sym_AT_ATb = 21,
  anon_sym_AT_ATi = 22,
  anon_sym_AT_ATii = 23,
  anon_sym_AT_ATiS = 24,
  anon_sym_AT_ATiSS = 25,
  anon_sym_AT_ATis = 26,
  anon_sym_AT_ATiz = 27,
  anon_sym_AT_ATf = 28,
  anon_sym_AT_ATF = 29,
  anon_sym_AT_ATom = 30,
  anon_sym_AT_ATdm = 31,
  anon_sym_AT_ATr = 32,
  anon_sym_AT_ATs_COLON = 33,
  anon_sym_AT = 34,
  anon_sym_AT_BANG = 35,
  anon_sym_AT_LPAREN = 36,
  anon_sym_RPAREN = 37,
  anon_sym_ATa_COLON = 38,
  anon_sym_ATb_COLON = 39,
  anon_sym_ATB_COLON = 40,
  anon_sym_ATe_COLON = 41,
  anon_sym_ATF_COLON = 42,
  anon_sym_ATi_COLON = 43,
  anon_sym_ATk_COLON = 44,
  anon_sym_ATo_COLON = 45,
  anon_sym_ATr_COLON = 46,
  anon_sym_ATf_COLON = 47,
  anon_sym_ATs_COLON = 48,
  anon_sym_ATv_COLON = 49,
  anon_sym_ATx_COLON = 50,
  anon_sym_SEMI = 51,
  sym_macro_name = 52,
  anon_sym_LPAREN = 53,
  anon_sym_LPAREN_DASH_STAR = 54,
  anon_sym_LPAREN_STAR = 55,
  anon_sym_LPAREN_DASH = 56,
  aux_sym__search_stmt_token1 = 57,
  anon_sym_DOT = 58,
  aux_sym__interpret_stmt_token1 = 59,
  aux_sym__interpret_stmt_token2 = 60,
  aux_sym__interpret_stmt_token3 = 61,
  aux_sym__interpret_stmt_token4 = 62,
  anon_sym_PIPE_DOT = 63,
  anon_sym_DOT_SLASH = 64,
  anon_sym_pfo = 65,
  anon_sym_Cf = 66,
  sym_pf_dot_cmd_identifier = 67,
  sym_pf_dot_full_cmd_identifier = 68,
  aux_sym_pf_cmd_token1 = 69,
  anon_sym_EQ = 70,
  aux_sym__pf_dot_arg_identifier_token1 = 71,
  anon_sym_DOLLAR = 72,
  aux_sym_pf_arg_identifier_token1 = 73,
  sym__env_stmt_identifier = 74,
  anon_sym_DOT_DOT_DOT = 75,
  sym_system_identifier = 76,
  sym_question_mark_identifier = 77,
  sym_pointer_identifier = 78,
  anon_sym_GT = 79,
  anon_sym_GT_GT = 80,
  sym_html_redirect_operator = 81,
  sym_html_append_operator = 82,
  anon_sym_COMMA = 83,
  aux_sym_tmp_eval_arg_token1 = 84,
  sym__eq_sep_key_identifier = 85,
  aux_sym_arg_identifier_token1 = 86,
  aux_sym_spec_arg_identifier_token1 = 87,
  aux_sym_double_quoted_arg_token1 = 88,
  aux_sym_double_quoted_arg_token2 = 89,
  aux_sym_double_quoted_arg_token3 = 90,
  anon_sym_SQUOTE = 91,
  aux_sym_single_quoted_arg_token1 = 92,
  aux_sym_single_quoted_arg_token2 = 93,
  anon_sym_DOLLAR_LPAREN = 94,
  anon_sym_BQUOTE = 95,
  aux_sym__dec_number_token1 = 96,
  aux_sym__dec_number_token2 = 97,
  sym__comment = 98,
  anon_sym_LF = 99,
  anon_sym_CR = 100,
  sym__cmd_identifier = 101,
  sym__help_stmt = 102,
  sym_file_descriptor = 103,
  sym__eq_sep_concat = 104,
  sym__concat = 105,
  sym__concat_pf_dot = 106,
  sym__spec_sep = 107,
  sym_statements = 108,
  sym__statements_singleline = 109,
  sym__statement = 110,
  sym_legacy_quoted_stmt = 111,
  sym__simple_stmt = 112,
  sym__tmp_stmt = 113,
  sym__iter_stmt = 114,
  sym__pipe_stmt = 115,
  sym_grep_stmt = 116,
  sym_grep_specifier = 117,
  sym_html_disable_stmt = 118,
  sym_html_enable_stmt = 119,
  sym_pipe_stmt = 120,
  sym_iter_file_lines_stmt = 121,
  sym_iter_offsets_stmt = 122,
  sym_iter_offsetssizes_stmt = 123,
  sym_iter_hit_stmt = 124,
  sym_iter_interpret_stmt = 125,
  sym_iter_interpret_offsetssizes_stmt = 126,
  sym_iter_comment_stmt = 127,
  sym_iter_dbta_stmt = 128,
  sym_iter_dbtb_stmt = 129,
  sym_iter_dbts_stmt = 130,
  sym_iter_threads_stmt = 131,
  sym_iter_bbs_stmt = 132,
  sym_iter_instrs_stmt = 133,
  sym_iter_import_stmt = 134,
  sym_iter_sections_stmt = 135,
  sym_iter_segments_stmt = 136,
  sym_iter_symbol_stmt = 137,
  sym_iter_string_stmt = 138,
  sym_iter_flags_stmt = 139,
  sym_iter_function_stmt = 140,
  sym_iter_iomap_stmt = 141,
  sym_iter_dbgmap_stmt = 142,
  sym_iter_register_stmt = 143,
  sym_iter_step_stmt = 144,
  sym_tmp_seek_stmt = 145,
  sym_tmp_blksz_stmt = 146,
  sym_tmp_fromto_stmt = 147,
  sym_tmp_arch_stmt = 148,
  sym_tmp_bits_stmt = 149,
  sym_tmp_nthi_stmt = 150,
  sym_tmp_eval_stmt = 151,
  sym_tmp_fs_stmt = 152,
  sym_tmp_reli_stmt = 153,
  sym_tmp_kuery_stmt = 154,
  sym_tmp_fd_stmt = 155,
  sym_tmp_reg_stmt = 156,
  sym_tmp_file_stmt = 157,
  sym_tmp_string_stmt = 158,
  sym_tmp_value_stmt = 159,
  sym_tmp_hex_stmt = 160,
  sym_help_stmt = 161,
  sym_macro_body = 162,
  sym_macro_content = 163,
  sym_macro_call = 164,
  sym_macro_stmt = 165,
  sym_arged_stmt = 166,
  sym__macro_arged_stmt = 167,
  sym__simple_arged_stmt_question = 168,
  sym__simple_arged_stmt = 169,
  sym__search_stmt = 170,
  sym__pointer_arged_stmt = 171,
  sym__system_stmt = 172,
  sym__interpret_stmt = 173,
  sym__interpret_search_identifier = 174,
  sym__pf_arged_stmt = 175,
  sym__pf_stmts = 176,
  sym_Cf_cmd = 177,
  sym__Cf_args = 178,
  sym_pf_new_cmd = 179,
  sym_pf_dot_cmd = 180,
  sym_pf_cmd = 181,
  sym_pf_new_args = 182,
  sym_pf_dot_cmd_args = 183,
  sym__pf_dot_arg_identifier = 184,
  sym__pf_arg_parentheses = 185,
  sym_pf_arg_identifier = 186,
  sym__pf_arg = 187,
  sym__pf_dot_arg = 188,
  sym_pf_concatenation = 189,
  sym_pf_dot_concatenation = 190,
  sym_pf_arg = 191,
  sym_pf_dot_arg = 192,
  sym_pf_args = 193,
  sym_pf_dot_args = 194,
  sym__env_stmt = 195,
  sym__last_stmt = 196,
  sym_last_stmt_identifier = 197,
  sym_repeat_stmt = 198,
  sym_eq_sep_args = 199,
  sym_redirect_stmt = 200,
  sym__redirect_operator = 201,
  sym_fdn_redirect_operator = 202,
  sym_fdn_append_operator = 203,
  sym__arg_with_paren = 204,
  sym__arg = 205,
  sym_arg = 206,
  sym_args = 207,
  sym_tmp_eval_args = 208,
  sym_tmp_eval_arg = 209,
  sym__eq_sep_key_single = 210,
  sym__eq_sep_key_concatenation = 211,
  sym__eq_sep_key = 212,
  sym__eq_sep_val_concatenation = 213,
  sym__eq_sep_val = 214,
  sym_arg_identifier = 215,
  sym_spec_arg_identifier = 216,
  sym_double_quoted_arg = 217,
  sym_single_quoted_arg = 218,
  sym_cmd_substitution_arg = 219,
  sym_concatenation = 220,
  sym__dec_number = 221,
  sym_specifiers = 222,
  sym_cmd_identifier = 223,
  aux_sym_statements_repeat1 = 224,
  aux_sym_statements_repeat2 = 225,
  aux_sym__statements_singleline_repeat1 = 226,
  aux_sym__statements_singleline_repeat2 = 227,
  aux_sym_grep_specifier_repeat1 = 228,
  aux_sym_macro_body_repeat1 = 229,
  aux_sym_pf_concatenation_repeat1 = 230,
  aux_sym_pf_dot_concatenation_repeat1 = 231,
  aux_sym_pf_args_repeat1 = 232,
  aux_sym_pf_dot_args_repeat1 = 233,
  aux_sym_args_repeat1 = 234,
  aux_sym_tmp_eval_args_repeat1 = 235,
  aux_sym_tmp_eval_arg_repeat1 = 236,
  aux_sym__eq_sep_key_concatenation_repeat1 = 237,
  aux_sym__eq_sep_val_concatenation_repeat1 = 238,
  aux_sym_double_quoted_arg_repeat1 = 239,
  aux_sym_single_quoted_arg_repeat1 = 240,
  aux_sym_concatenation_repeat1 = 241,
  aux_sym_specifiers_repeat1 = 242,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_legacy_quoted_stmt_token1] = "legacy_quoted_stmt_token1",
  [anon_sym_TILDE] = "~",
  [sym_grep_specifier_identifier] = "grep_specifier_identifier",
  [aux_sym_grep_specifier_token1] = "grep_specifier_identifier",
  [anon_sym_PIPE] = "|",
  [anon_sym_PIPEH] = "|H",
  [anon_sym_AT_AT_DOT] = "@@.",
  [anon_sym_AT_AT_EQ] = "@@=",
  [anon_sym_AT_AT_AT_EQ] = "@@@=",
  [anon_sym_AT_AT] = "@@",
  [anon_sym_AT_ATc_COLON] = "@@c:",
  [anon_sym_AT_AT_ATc_COLON] = "@@@c:",
  [anon_sym_AT_ATC] = "@@C",
  [anon_sym_COLON] = ":",
  [anon_sym_AT_ATdbt] = "@@dbt",
  [anon_sym_AT_ATdbta] = "@@dbta",
  [anon_sym_AT_ATdbtb] = "@@dbtb",
  [anon_sym_AT_ATdbts] = "@@dbts",
  [anon_sym_AT_ATt] = "@@t",
  [anon_sym_AT_ATb] = "@@b",
  [anon_sym_AT_ATi] = "@@i",
  [anon_sym_AT_ATii] = "@@ii",
  [anon_sym_AT_ATiS] = "@@iS",
  [anon_sym_AT_ATiSS] = "@@iSS",
  [anon_sym_AT_ATis] = "@@is",
  [anon_sym_AT_ATiz] = "@@iz",
  [anon_sym_AT_ATf] = "@@f",
  [anon_sym_AT_ATF] = "@@F",
  [anon_sym_AT_ATom] = "@@om",
  [anon_sym_AT_ATdm] = "@@dm",
  [anon_sym_AT_ATr] = "@@r",
  [anon_sym_AT_ATs_COLON] = "@@s:",
  [anon_sym_AT] = "@ ",
  [anon_sym_AT_BANG] = "@!",
  [anon_sym_AT_LPAREN] = "@(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_ATa_COLON] = "@a:",
  [anon_sym_ATb_COLON] = "@b:",
  [anon_sym_ATB_COLON] = "@B:",
  [anon_sym_ATe_COLON] = "@e:",
  [anon_sym_ATF_COLON] = "@F:",
  [anon_sym_ATi_COLON] = "@i:",
  [anon_sym_ATk_COLON] = "@k:",
  [anon_sym_ATo_COLON] = "@o:",
  [anon_sym_ATr_COLON] = "@r:",
  [anon_sym_ATf_COLON] = "@f:",
  [anon_sym_ATs_COLON] = "@s:",
  [anon_sym_ATv_COLON] = "@v:",
  [anon_sym_ATx_COLON] = "@x:",
  [anon_sym_SEMI] = ";",
  [sym_macro_name] = "macro_name",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LPAREN_DASH_STAR] = "cmd_identifier",
  [anon_sym_LPAREN_STAR] = "cmd_identifier",
  [anon_sym_LPAREN_DASH] = "cmd_identifier",
  [aux_sym__search_stmt_token1] = "cmd_identifier",
  [anon_sym_DOT] = ".",
  [aux_sym__interpret_stmt_token1] = "cmd_identifier",
  [aux_sym__interpret_stmt_token2] = "_interpret_stmt_token2",
  [aux_sym__interpret_stmt_token3] = "cmd_identifier",
  [aux_sym__interpret_stmt_token4] = "cmd_identifier",
  [anon_sym_PIPE_DOT] = "|.",
  [anon_sym_DOT_SLASH] = "./",
  [anon_sym_pfo] = "cmd_identifier",
  [anon_sym_Cf] = "cmd_identifier",
  [sym_pf_dot_cmd_identifier] = "cmd_identifier",
  [sym_pf_dot_full_cmd_identifier] = "cmd_identifier",
  [aux_sym_pf_cmd_token1] = "cmd_identifier",
  [anon_sym_EQ] = "=",
  [aux_sym__pf_dot_arg_identifier_token1] = "_pf_dot_arg_identifier_token1",
  [anon_sym_DOLLAR] = "$",
  [aux_sym_pf_arg_identifier_token1] = "pf_arg_identifier_token1",
  [sym__env_stmt_identifier] = "cmd_identifier",
  [anon_sym_DOT_DOT_DOT] = "...",
  [sym_system_identifier] = "system_identifier",
  [sym_question_mark_identifier] = "cmd_identifier",
  [sym_pointer_identifier] = "cmd_identifier",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [sym_html_redirect_operator] = "html_redirect_operator",
  [sym_html_append_operator] = "html_append_operator",
  [anon_sym_COMMA] = ",",
  [aux_sym_tmp_eval_arg_token1] = "tmp_eval_arg_token1",
  [sym__eq_sep_key_identifier] = "arg_identifier",
  [aux_sym_arg_identifier_token1] = "arg_identifier_token1",
  [aux_sym_spec_arg_identifier_token1] = "spec_arg_identifier_token1",
  [aux_sym_double_quoted_arg_token1] = "double_quoted_arg_token1",
  [aux_sym_double_quoted_arg_token2] = "double_quoted_arg_token2",
  [aux_sym_double_quoted_arg_token3] = "double_quoted_arg_token3",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_single_quoted_arg_token1] = "single_quoted_arg_token1",
  [aux_sym_single_quoted_arg_token2] = "single_quoted_arg_token2",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [aux_sym__dec_number_token1] = "_dec_number_token1",
  [aux_sym__dec_number_token2] = "_dec_number_token2",
  [sym__comment] = "_comment",
  [anon_sym_LF] = "\n",
  [anon_sym_CR] = "\r",
  [sym__cmd_identifier] = "_cmd_identifier",
  [sym__help_stmt] = "cmd_identifier",
  [sym_file_descriptor] = "file_descriptor",
  [sym__eq_sep_concat] = "_eq_sep_concat",
  [sym__concat] = "_concat",
  [sym__concat_pf_dot] = "_concat_pf_dot",
  [sym__spec_sep] = "_spec_sep",
  [sym_statements] = "statements",
  [sym__statements_singleline] = "_statements_singleline",
  [sym__statement] = "_statement",
  [sym_legacy_quoted_stmt] = "legacy_quoted_stmt",
  [sym__simple_stmt] = "_simple_stmt",
  [sym__tmp_stmt] = "_tmp_stmt",
  [sym__iter_stmt] = "_iter_stmt",
  [sym__pipe_stmt] = "_pipe_stmt",
  [sym_grep_stmt] = "grep_stmt",
  [sym_grep_specifier] = "grep_specifier",
  [sym_html_disable_stmt] = "html_disable_stmt",
  [sym_html_enable_stmt] = "html_enable_stmt",
  [sym_pipe_stmt] = "pipe_stmt",
  [sym_iter_file_lines_stmt] = "iter_file_lines_stmt",
  [sym_iter_offsets_stmt] = "iter_offsets_stmt",
  [sym_iter_offsetssizes_stmt] = "iter_offsetssizes_stmt",
  [sym_iter_hit_stmt] = "iter_hit_stmt",
  [sym_iter_interpret_stmt] = "iter_interpret_stmt",
  [sym_iter_interpret_offsetssizes_stmt] = "iter_interpret_offsetssizes_stmt",
  [sym_iter_comment_stmt] = "iter_comment_stmt",
  [sym_iter_dbta_stmt] = "iter_dbta_stmt",
  [sym_iter_dbtb_stmt] = "iter_dbtb_stmt",
  [sym_iter_dbts_stmt] = "iter_dbts_stmt",
  [sym_iter_threads_stmt] = "iter_threads_stmt",
  [sym_iter_bbs_stmt] = "iter_bbs_stmt",
  [sym_iter_instrs_stmt] = "iter_instrs_stmt",
  [sym_iter_import_stmt] = "iter_import_stmt",
  [sym_iter_sections_stmt] = "iter_sections_stmt",
  [sym_iter_segments_stmt] = "iter_segments_stmt",
  [sym_iter_symbol_stmt] = "iter_symbol_stmt",
  [sym_iter_string_stmt] = "iter_string_stmt",
  [sym_iter_flags_stmt] = "iter_flags_stmt",
  [sym_iter_function_stmt] = "iter_function_stmt",
  [sym_iter_iomap_stmt] = "iter_iomap_stmt",
  [sym_iter_dbgmap_stmt] = "iter_dbgmap_stmt",
  [sym_iter_register_stmt] = "iter_register_stmt",
  [sym_iter_step_stmt] = "iter_step_stmt",
  [sym_tmp_seek_stmt] = "tmp_seek_stmt",
  [sym_tmp_blksz_stmt] = "tmp_blksz_stmt",
  [sym_tmp_fromto_stmt] = "tmp_fromto_stmt",
  [sym_tmp_arch_stmt] = "tmp_arch_stmt",
  [sym_tmp_bits_stmt] = "tmp_bits_stmt",
  [sym_tmp_nthi_stmt] = "tmp_nthi_stmt",
  [sym_tmp_eval_stmt] = "tmp_eval_stmt",
  [sym_tmp_fs_stmt] = "tmp_fs_stmt",
  [sym_tmp_reli_stmt] = "tmp_reli_stmt",
  [sym_tmp_kuery_stmt] = "tmp_kuery_stmt",
  [sym_tmp_fd_stmt] = "tmp_fd_stmt",
  [sym_tmp_reg_stmt] = "tmp_reg_stmt",
  [sym_tmp_file_stmt] = "tmp_file_stmt",
  [sym_tmp_string_stmt] = "tmp_string_stmt",
  [sym_tmp_value_stmt] = "tmp_value_stmt",
  [sym_tmp_hex_stmt] = "tmp_hex_stmt",
  [sym_help_stmt] = "help_stmt",
  [sym_macro_body] = "macro_body",
  [sym_macro_content] = "macro_content",
  [sym_macro_call] = "macro_call",
  [sym_macro_stmt] = "macro_stmt",
  [sym_arged_stmt] = "arged_stmt",
  [sym__macro_arged_stmt] = "_macro_arged_stmt",
  [sym__simple_arged_stmt_question] = "_simple_arged_stmt_question",
  [sym__simple_arged_stmt] = "_simple_arged_stmt",
  [sym__search_stmt] = "arged_stmt",
  [sym__pointer_arged_stmt] = "_pointer_arged_stmt",
  [sym__system_stmt] = "_system_stmt",
  [sym__interpret_stmt] = "_interpret_stmt",
  [sym__interpret_search_identifier] = "cmd_identifier",
  [sym__pf_arged_stmt] = "_pf_arged_stmt",
  [sym__pf_stmts] = "_pf_stmts",
  [sym_Cf_cmd] = "arged_stmt",
  [sym__Cf_args] = "args",
  [sym_pf_new_cmd] = "arged_stmt",
  [sym_pf_dot_cmd] = "arged_stmt",
  [sym_pf_cmd] = "arged_stmt",
  [sym_pf_new_args] = "pf_new_args",
  [sym_pf_dot_cmd_args] = "pf_dot_cmd_args",
  [sym__pf_dot_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg_parentheses] = "_pf_arg_parentheses",
  [sym_pf_arg_identifier] = "pf_arg_identifier",
  [sym__pf_arg] = "_pf_arg",
  [sym__pf_dot_arg] = "_pf_dot_arg",
  [sym_pf_concatenation] = "pf_concatenation",
  [sym_pf_dot_concatenation] = "pf_concatenation",
  [sym_pf_arg] = "pf_arg",
  [sym_pf_dot_arg] = "pf_arg",
  [sym_pf_args] = "pf_args",
  [sym_pf_dot_args] = "pf_args",
  [sym__env_stmt] = "_env_stmt",
  [sym__last_stmt] = "_last_stmt",
  [sym_last_stmt_identifier] = "cmd_identifier",
  [sym_repeat_stmt] = "repeat_stmt",
  [sym_eq_sep_args] = "args",
  [sym_redirect_stmt] = "redirect_stmt",
  [sym__redirect_operator] = "_redirect_operator",
  [sym_fdn_redirect_operator] = "fdn_redirect_operator",
  [sym_fdn_append_operator] = "fdn_append_operator",
  [sym__arg_with_paren] = "args",
  [sym__arg] = "_arg",
  [sym_arg] = "arg",
  [sym_args] = "args",
  [sym_tmp_eval_args] = "args",
  [sym_tmp_eval_arg] = "arg",
  [sym__eq_sep_key_single] = "_eq_sep_key_single",
  [sym__eq_sep_key_concatenation] = "concatenation",
  [sym__eq_sep_key] = "arg",
  [sym__eq_sep_val_concatenation] = "concatenation",
  [sym__eq_sep_val] = "arg",
  [sym_arg_identifier] = "arg_identifier",
  [sym_spec_arg_identifier] = "arg_identifier",
  [sym_double_quoted_arg] = "double_quoted_arg",
  [sym_single_quoted_arg] = "single_quoted_arg",
  [sym_cmd_substitution_arg] = "cmd_substitution_arg",
  [sym_concatenation] = "concatenation",
  [sym__dec_number] = "number",
  [sym_specifiers] = "specifiers",
  [sym_cmd_identifier] = "cmd_identifier",
  [aux_sym_statements_repeat1] = "statements_repeat1",
  [aux_sym_statements_repeat2] = "statements_repeat2",
  [aux_sym__statements_singleline_repeat1] = "_statements_singleline_repeat1",
  [aux_sym__statements_singleline_repeat2] = "_statements_singleline_repeat2",
  [aux_sym_grep_specifier_repeat1] = "grep_specifier_repeat1",
  [aux_sym_macro_body_repeat1] = "macro_body_repeat1",
  [aux_sym_pf_concatenation_repeat1] = "pf_concatenation_repeat1",
  [aux_sym_pf_dot_concatenation_repeat1] = "pf_dot_concatenation_repeat1",
  [aux_sym_pf_args_repeat1] = "pf_args_repeat1",
  [aux_sym_pf_dot_args_repeat1] = "pf_dot_args_repeat1",
  [aux_sym_args_repeat1] = "args_repeat1",
  [aux_sym_tmp_eval_args_repeat1] = "tmp_eval_args_repeat1",
  [aux_sym_tmp_eval_arg_repeat1] = "tmp_eval_arg_repeat1",
  [aux_sym__eq_sep_key_concatenation_repeat1] = "_eq_sep_key_concatenation_repeat1",
  [aux_sym__eq_sep_val_concatenation_repeat1] = "_eq_sep_val_concatenation_repeat1",
  [aux_sym_double_quoted_arg_repeat1] = "double_quoted_arg_repeat1",
  [aux_sym_single_quoted_arg_repeat1] = "single_quoted_arg_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_specifiers_repeat1] = "specifiers_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_legacy_quoted_stmt_token1] = aux_sym_legacy_quoted_stmt_token1,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [sym_grep_specifier_identifier] = sym_grep_specifier_identifier,
  [aux_sym_grep_specifier_token1] = sym_grep_specifier_identifier,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_PIPEH] = anon_sym_PIPEH,
  [anon_sym_AT_AT_DOT] = anon_sym_AT_AT_DOT,
  [anon_sym_AT_AT_EQ] = anon_sym_AT_AT_EQ,
  [anon_sym_AT_AT_AT_EQ] = anon_sym_AT_AT_AT_EQ,
  [anon_sym_AT_AT] = anon_sym_AT_AT,
  [anon_sym_AT_ATc_COLON] = anon_sym_AT_ATc_COLON,
  [anon_sym_AT_AT_ATc_COLON] = anon_sym_AT_AT_ATc_COLON,
  [anon_sym_AT_ATC] = anon_sym_AT_ATC,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_AT_ATdbt] = anon_sym_AT_ATdbt,
  [anon_sym_AT_ATdbta] = anon_sym_AT_ATdbta,
  [anon_sym_AT_ATdbtb] = anon_sym_AT_ATdbtb,
  [anon_sym_AT_ATdbts] = anon_sym_AT_ATdbts,
  [anon_sym_AT_ATt] = anon_sym_AT_ATt,
  [anon_sym_AT_ATb] = anon_sym_AT_ATb,
  [anon_sym_AT_ATi] = anon_sym_AT_ATi,
  [anon_sym_AT_ATii] = anon_sym_AT_ATii,
  [anon_sym_AT_ATiS] = anon_sym_AT_ATiS,
  [anon_sym_AT_ATiSS] = anon_sym_AT_ATiSS,
  [anon_sym_AT_ATis] = anon_sym_AT_ATis,
  [anon_sym_AT_ATiz] = anon_sym_AT_ATiz,
  [anon_sym_AT_ATf] = anon_sym_AT_ATf,
  [anon_sym_AT_ATF] = anon_sym_AT_ATF,
  [anon_sym_AT_ATom] = anon_sym_AT_ATom,
  [anon_sym_AT_ATdm] = anon_sym_AT_ATdm,
  [anon_sym_AT_ATr] = anon_sym_AT_ATr,
  [anon_sym_AT_ATs_COLON] = anon_sym_AT_ATs_COLON,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_AT_BANG] = anon_sym_AT_BANG,
  [anon_sym_AT_LPAREN] = anon_sym_AT_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_ATa_COLON] = anon_sym_ATa_COLON,
  [anon_sym_ATb_COLON] = anon_sym_ATb_COLON,
  [anon_sym_ATB_COLON] = anon_sym_ATB_COLON,
  [anon_sym_ATe_COLON] = anon_sym_ATe_COLON,
  [anon_sym_ATF_COLON] = anon_sym_ATF_COLON,
  [anon_sym_ATi_COLON] = anon_sym_ATi_COLON,
  [anon_sym_ATk_COLON] = anon_sym_ATk_COLON,
  [anon_sym_ATo_COLON] = anon_sym_ATo_COLON,
  [anon_sym_ATr_COLON] = anon_sym_ATr_COLON,
  [anon_sym_ATf_COLON] = anon_sym_ATf_COLON,
  [anon_sym_ATs_COLON] = anon_sym_ATs_COLON,
  [anon_sym_ATv_COLON] = anon_sym_ATv_COLON,
  [anon_sym_ATx_COLON] = anon_sym_ATx_COLON,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [sym_macro_name] = sym_macro_name,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_LPAREN_DASH_STAR] = sym_cmd_identifier,
  [anon_sym_LPAREN_STAR] = sym_cmd_identifier,
  [anon_sym_LPAREN_DASH] = sym_cmd_identifier,
  [aux_sym__search_stmt_token1] = sym_cmd_identifier,
  [anon_sym_DOT] = anon_sym_DOT,
  [aux_sym__interpret_stmt_token1] = sym_cmd_identifier,
  [aux_sym__interpret_stmt_token2] = aux_sym__interpret_stmt_token2,
  [aux_sym__interpret_stmt_token3] = sym_cmd_identifier,
  [aux_sym__interpret_stmt_token4] = sym_cmd_identifier,
  [anon_sym_PIPE_DOT] = anon_sym_PIPE_DOT,
  [anon_sym_DOT_SLASH] = anon_sym_DOT_SLASH,
  [anon_sym_pfo] = sym_cmd_identifier,
  [anon_sym_Cf] = sym_cmd_identifier,
  [sym_pf_dot_cmd_identifier] = sym_cmd_identifier,
  [sym_pf_dot_full_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_pf_cmd_token1] = sym_cmd_identifier,
  [anon_sym_EQ] = anon_sym_EQ,
  [aux_sym__pf_dot_arg_identifier_token1] = aux_sym__pf_dot_arg_identifier_token1,
  [anon_sym_DOLLAR] = anon_sym_DOLLAR,
  [aux_sym_pf_arg_identifier_token1] = aux_sym_pf_arg_identifier_token1,
  [sym__env_stmt_identifier] = sym_cmd_identifier,
  [anon_sym_DOT_DOT_DOT] = anon_sym_DOT_DOT_DOT,
  [sym_system_identifier] = sym_system_identifier,
  [sym_question_mark_identifier] = sym_cmd_identifier,
  [sym_pointer_identifier] = sym_cmd_identifier,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [sym_html_redirect_operator] = sym_html_redirect_operator,
  [sym_html_append_operator] = sym_html_append_operator,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [aux_sym_tmp_eval_arg_token1] = aux_sym_tmp_eval_arg_token1,
  [sym__eq_sep_key_identifier] = sym_arg_identifier,
  [aux_sym_arg_identifier_token1] = aux_sym_arg_identifier_token1,
  [aux_sym_spec_arg_identifier_token1] = aux_sym_spec_arg_identifier_token1,
  [aux_sym_double_quoted_arg_token1] = aux_sym_double_quoted_arg_token1,
  [aux_sym_double_quoted_arg_token2] = aux_sym_double_quoted_arg_token2,
  [aux_sym_double_quoted_arg_token3] = aux_sym_double_quoted_arg_token3,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_single_quoted_arg_token1] = aux_sym_single_quoted_arg_token1,
  [aux_sym_single_quoted_arg_token2] = aux_sym_single_quoted_arg_token2,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [aux_sym__dec_number_token1] = aux_sym__dec_number_token1,
  [aux_sym__dec_number_token2] = aux_sym__dec_number_token2,
  [sym__comment] = sym__comment,
  [anon_sym_LF] = anon_sym_LF,
  [anon_sym_CR] = anon_sym_CR,
  [sym__cmd_identifier] = sym__cmd_identifier,
  [sym__help_stmt] = sym_cmd_identifier,
  [sym_file_descriptor] = sym_file_descriptor,
  [sym__eq_sep_concat] = sym__eq_sep_concat,
  [sym__concat] = sym__concat,
  [sym__concat_pf_dot] = sym__concat_pf_dot,
  [sym__spec_sep] = sym__spec_sep,
  [sym_statements] = sym_statements,
  [sym__statements_singleline] = sym__statements_singleline,
  [sym__statement] = sym__statement,
  [sym_legacy_quoted_stmt] = sym_legacy_quoted_stmt,
  [sym__simple_stmt] = sym__simple_stmt,
  [sym__tmp_stmt] = sym__tmp_stmt,
  [sym__iter_stmt] = sym__iter_stmt,
  [sym__pipe_stmt] = sym__pipe_stmt,
  [sym_grep_stmt] = sym_grep_stmt,
  [sym_grep_specifier] = sym_grep_specifier,
  [sym_html_disable_stmt] = sym_html_disable_stmt,
  [sym_html_enable_stmt] = sym_html_enable_stmt,
  [sym_pipe_stmt] = sym_pipe_stmt,
  [sym_iter_file_lines_stmt] = sym_iter_file_lines_stmt,
  [sym_iter_offsets_stmt] = sym_iter_offsets_stmt,
  [sym_iter_offsetssizes_stmt] = sym_iter_offsetssizes_stmt,
  [sym_iter_hit_stmt] = sym_iter_hit_stmt,
  [sym_iter_interpret_stmt] = sym_iter_interpret_stmt,
  [sym_iter_interpret_offsetssizes_stmt] = sym_iter_interpret_offsetssizes_stmt,
  [sym_iter_comment_stmt] = sym_iter_comment_stmt,
  [sym_iter_dbta_stmt] = sym_iter_dbta_stmt,
  [sym_iter_dbtb_stmt] = sym_iter_dbtb_stmt,
  [sym_iter_dbts_stmt] = sym_iter_dbts_stmt,
  [sym_iter_threads_stmt] = sym_iter_threads_stmt,
  [sym_iter_bbs_stmt] = sym_iter_bbs_stmt,
  [sym_iter_instrs_stmt] = sym_iter_instrs_stmt,
  [sym_iter_import_stmt] = sym_iter_import_stmt,
  [sym_iter_sections_stmt] = sym_iter_sections_stmt,
  [sym_iter_segments_stmt] = sym_iter_segments_stmt,
  [sym_iter_symbol_stmt] = sym_iter_symbol_stmt,
  [sym_iter_string_stmt] = sym_iter_string_stmt,
  [sym_iter_flags_stmt] = sym_iter_flags_stmt,
  [sym_iter_function_stmt] = sym_iter_function_stmt,
  [sym_iter_iomap_stmt] = sym_iter_iomap_stmt,
  [sym_iter_dbgmap_stmt] = sym_iter_dbgmap_stmt,
  [sym_iter_register_stmt] = sym_iter_register_stmt,
  [sym_iter_step_stmt] = sym_iter_step_stmt,
  [sym_tmp_seek_stmt] = sym_tmp_seek_stmt,
  [sym_tmp_blksz_stmt] = sym_tmp_blksz_stmt,
  [sym_tmp_fromto_stmt] = sym_tmp_fromto_stmt,
  [sym_tmp_arch_stmt] = sym_tmp_arch_stmt,
  [sym_tmp_bits_stmt] = sym_tmp_bits_stmt,
  [sym_tmp_nthi_stmt] = sym_tmp_nthi_stmt,
  [sym_tmp_eval_stmt] = sym_tmp_eval_stmt,
  [sym_tmp_fs_stmt] = sym_tmp_fs_stmt,
  [sym_tmp_reli_stmt] = sym_tmp_reli_stmt,
  [sym_tmp_kuery_stmt] = sym_tmp_kuery_stmt,
  [sym_tmp_fd_stmt] = sym_tmp_fd_stmt,
  [sym_tmp_reg_stmt] = sym_tmp_reg_stmt,
  [sym_tmp_file_stmt] = sym_tmp_file_stmt,
  [sym_tmp_string_stmt] = sym_tmp_string_stmt,
  [sym_tmp_value_stmt] = sym_tmp_value_stmt,
  [sym_tmp_hex_stmt] = sym_tmp_hex_stmt,
  [sym_help_stmt] = sym_help_stmt,
  [sym_macro_body] = sym_macro_body,
  [sym_macro_content] = sym_macro_content,
  [sym_macro_call] = sym_macro_call,
  [sym_macro_stmt] = sym_macro_stmt,
  [sym_arged_stmt] = sym_arged_stmt,
  [sym__macro_arged_stmt] = sym__macro_arged_stmt,
  [sym__simple_arged_stmt_question] = sym__simple_arged_stmt_question,
  [sym__simple_arged_stmt] = sym__simple_arged_stmt,
  [sym__search_stmt] = sym_arged_stmt,
  [sym__pointer_arged_stmt] = sym__pointer_arged_stmt,
  [sym__system_stmt] = sym__system_stmt,
  [sym__interpret_stmt] = sym__interpret_stmt,
  [sym__interpret_search_identifier] = sym_cmd_identifier,
  [sym__pf_arged_stmt] = sym__pf_arged_stmt,
  [sym__pf_stmts] = sym__pf_stmts,
  [sym_Cf_cmd] = sym_arged_stmt,
  [sym__Cf_args] = sym_args,
  [sym_pf_new_cmd] = sym_arged_stmt,
  [sym_pf_dot_cmd] = sym_arged_stmt,
  [sym_pf_cmd] = sym_arged_stmt,
  [sym_pf_new_args] = sym_pf_new_args,
  [sym_pf_dot_cmd_args] = sym_pf_dot_cmd_args,
  [sym__pf_dot_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg_parentheses] = sym__pf_arg_parentheses,
  [sym_pf_arg_identifier] = sym_pf_arg_identifier,
  [sym__pf_arg] = sym__pf_arg,
  [sym__pf_dot_arg] = sym__pf_dot_arg,
  [sym_pf_concatenation] = sym_pf_concatenation,
  [sym_pf_dot_concatenation] = sym_pf_concatenation,
  [sym_pf_arg] = sym_pf_arg,
  [sym_pf_dot_arg] = sym_pf_arg,
  [sym_pf_args] = sym_pf_args,
  [sym_pf_dot_args] = sym_pf_args,
  [sym__env_stmt] = sym__env_stmt,
  [sym__last_stmt] = sym__last_stmt,
  [sym_last_stmt_identifier] = sym_cmd_identifier,
  [sym_repeat_stmt] = sym_repeat_stmt,
  [sym_eq_sep_args] = sym_args,
  [sym_redirect_stmt] = sym_redirect_stmt,
  [sym__redirect_operator] = sym__redirect_operator,
  [sym_fdn_redirect_operator] = sym_fdn_redirect_operator,
  [sym_fdn_append_operator] = sym_fdn_append_operator,
  [sym__arg_with_paren] = sym_args,
  [sym__arg] = sym__arg,
  [sym_arg] = sym_arg,
  [sym_args] = sym_args,
  [sym_tmp_eval_args] = sym_args,
  [sym_tmp_eval_arg] = sym_arg,
  [sym__eq_sep_key_single] = sym__eq_sep_key_single,
  [sym__eq_sep_key_concatenation] = sym_concatenation,
  [sym__eq_sep_key] = sym_arg,
  [sym__eq_sep_val_concatenation] = sym_concatenation,
  [sym__eq_sep_val] = sym_arg,
  [sym_arg_identifier] = sym_arg_identifier,
  [sym_spec_arg_identifier] = sym_arg_identifier,
  [sym_double_quoted_arg] = sym_double_quoted_arg,
  [sym_single_quoted_arg] = sym_single_quoted_arg,
  [sym_cmd_substitution_arg] = sym_cmd_substitution_arg,
  [sym_concatenation] = sym_concatenation,
  [sym__dec_number] = sym__dec_number,
  [sym_specifiers] = sym_specifiers,
  [sym_cmd_identifier] = sym_cmd_identifier,
  [aux_sym_statements_repeat1] = aux_sym_statements_repeat1,
  [aux_sym_statements_repeat2] = aux_sym_statements_repeat2,
  [aux_sym__statements_singleline_repeat1] = aux_sym__statements_singleline_repeat1,
  [aux_sym__statements_singleline_repeat2] = aux_sym__statements_singleline_repeat2,
  [aux_sym_grep_specifier_repeat1] = aux_sym_grep_specifier_repeat1,
  [aux_sym_macro_body_repeat1] = aux_sym_macro_body_repeat1,
  [aux_sym_pf_concatenation_repeat1] = aux_sym_pf_concatenation_repeat1,
  [aux_sym_pf_dot_concatenation_repeat1] = aux_sym_pf_dot_concatenation_repeat1,
  [aux_sym_pf_args_repeat1] = aux_sym_pf_args_repeat1,
  [aux_sym_pf_dot_args_repeat1] = aux_sym_pf_dot_args_repeat1,
  [aux_sym_args_repeat1] = aux_sym_args_repeat1,
  [aux_sym_tmp_eval_args_repeat1] = aux_sym_tmp_eval_args_repeat1,
  [aux_sym_tmp_eval_arg_repeat1] = aux_sym_tmp_eval_arg_repeat1,
  [aux_sym__eq_sep_key_concatenation_repeat1] = aux_sym__eq_sep_key_concatenation_repeat1,
  [aux_sym__eq_sep_val_concatenation_repeat1] = aux_sym__eq_sep_val_concatenation_repeat1,
  [aux_sym_double_quoted_arg_repeat1] = aux_sym_double_quoted_arg_repeat1,
  [aux_sym_single_quoted_arg_repeat1] = aux_sym_single_quoted_arg_repeat1,
  [aux_sym_concatenation_repeat1] = aux_sym_concatenation_repeat1,
  [aux_sym_specifiers_repeat1] = aux_sym_specifiers_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_legacy_quoted_stmt_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_grep_specifier_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_grep_specifier_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPEH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_AT_ATc_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATC] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbta] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbtb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdbts] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATt] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATb] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATii] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiSS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATis] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATiz] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATf] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATom] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATdm] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATr] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATa_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATb_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATB_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATe_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATF_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATi_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATk_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATo_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATr_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATf_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATs_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATv_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ATx_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [sym_macro_name] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_DASH_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_DASH] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__search_stmt_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__interpret_stmt_token1] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpret_stmt_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__interpret_stmt_token3] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__interpret_stmt_token4] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PIPE_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pfo] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_Cf] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_full_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_pf_cmd_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__pf_dot_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_pf_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__env_stmt_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_system_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_question_mark_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_pointer_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_html_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_html_append_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [sym__eq_sep_key_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_spec_arg_identifier_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym__dec_number_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__dec_number_token2] = {
    .visible = false,
    .named = false,
  },
  [sym__comment] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CR] = {
    .visible = true,
    .named = false,
  },
  [sym__cmd_identifier] = {
    .visible = false,
    .named = true,
  },
  [sym__help_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym__concat_pf_dot] = {
    .visible = false,
    .named = true,
  },
  [sym__spec_sep] = {
    .visible = false,
    .named = true,
  },
  [sym_statements] = {
    .visible = true,
    .named = true,
  },
  [sym__statements_singleline] = {
    .visible = false,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_legacy_quoted_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__tmp_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__iter_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pipe_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_grep_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_grep_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_html_disable_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_html_enable_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_file_lines_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsets_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_offsetssizes_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_hit_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_interpret_offsetssizes_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_comment_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbta_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbtb_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbts_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_threads_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_bbs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_instrs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_import_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_sections_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_segments_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_symbol_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_string_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_flags_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_function_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_iomap_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_dbgmap_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_register_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_iter_step_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_seek_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_blksz_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fromto_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_arch_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_bits_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_nthi_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fs_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reli_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_kuery_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_fd_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_reg_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_file_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_string_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_value_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_hex_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_help_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_body] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_content] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_call] = {
    .visible = true,
    .named = true,
  },
  [sym_macro_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_arged_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__macro_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_arged_stmt_question] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__search_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__pointer_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__system_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__interpret_search_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arged_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_stmts] = {
    .visible = false,
    .named = true,
  },
  [sym_Cf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym__Cf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_cmd] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_new_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_cmd_args] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_dot_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg_parentheses] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__pf_arg] = {
    .visible = false,
    .named = true,
  },
  [sym__pf_dot_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_pf_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_args] = {
    .visible = true,
    .named = true,
  },
  [sym_pf_dot_args] = {
    .visible = true,
    .named = true,
  },
  [sym__env_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym__last_stmt] = {
    .visible = false,
    .named = true,
  },
  [sym_last_stmt_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_repeat_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym_eq_sep_args] = {
    .visible = true,
    .named = true,
  },
  [sym_redirect_stmt] = {
    .visible = true,
    .named = true,
  },
  [sym__redirect_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_fdn_redirect_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_fdn_append_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_with_paren] = {
    .visible = true,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_args] = {
    .visible = true,
    .named = true,
  },
  [sym_tmp_eval_arg] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key_single] = {
    .visible = false,
    .named = true,
  },
  [sym__eq_sep_key_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_key] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__eq_sep_val] = {
    .visible = true,
    .named = true,
  },
  [sym_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_spec_arg_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_double_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_single_quoted_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_substitution_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym__dec_number] = {
    .visible = true,
    .named = true,
  },
  [sym_specifiers] = {
    .visible = true,
    .named = true,
  },
  [sym_cmd_identifier] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_statements_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_singleline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__statements_singleline_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_grep_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_macro_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pf_dot_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_args_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tmp_eval_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_key_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__eq_sep_val_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_double_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_single_quoted_arg_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_specifiers_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum {
  field_arg = 1,
  field_args = 2,
  field_argv = 3,
  field_body = 4,
  field_command = 5,
  field_extra = 6,
  field_id = 7,
  field_name = 8,
  field_redirect_operator = 9,
  field_specifier = 10,
  field_string = 11,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_arg] = "arg",
  [field_args] = "args",
  [field_argv] = "argv",
  [field_body] = "body",
  [field_command] = "command",
  [field_extra] = "extra",
  [field_id] = "id",
  [field_name] = "name",
  [field_redirect_operator] = "redirect_operator",
  [field_specifier] = "specifier",
  [field_string] = "string",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 1, .length = 1},
  [4] = {.index = 2, .length = 2},
  [5] = {.index = 4, .length = 1},
  [6] = {.index = 5, .length = 2},
  [8] = {.index = 7, .length = 2},
  [9] = {.index = 7, .length = 2},
  [10] = {.index = 9, .length = 2},
  [11] = {.index = 11, .length = 2},
  [12] = {.index = 13, .length = 1},
  [13] = {.index = 14, .length = 2},
  [14] = {.index = 14, .length = 2},
  [15] = {.index = 16, .length = 2},
  [16] = {.index = 18, .length = 3},
  [18] = {.index = 21, .length = 2},
  [20] = {.index = 23, .length = 2},
  [21] = {.index = 25, .length = 3},
  [23] = {.index = 28, .length = 1},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_id, 0},
  [1] =
    {field_command, 0},
  [2] =
    {field_args, 0, .inherited = true},
    {field_command, 0, .inherited = true},
  [4] =
    {field_command, 0, .inherited = true},
  [5] =
    {field_extra, 1},
    {field_id, 0},
  [7] =
    {field_args, 1},
    {field_command, 0},
  [9] =
    {field_args, 0},
    {field_command, 1},
  [11] =
    {field_arg, 0},
    {field_command, 1},
  [13] =
    {field_string, 1},
  [14] =
    {field_args, 2},
    {field_command, 0},
  [16] =
    {field_command, 0},
    {field_specifier, 2},
  [18] =
    {field_arg, 2},
    {field_command, 0},
    {field_redirect_operator, 1},
  [21] =
    {field_body, 1},
    {field_name, 0},
  [23] =
    {field_args, 3, .inherited = true},
    {field_command, 3, .inherited = true},
  [25] =
    {field_args, 1},
    {field_body, 2},
    {field_name, 0},
  [28] =
    {field_argv, 1},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = sym_cmd_identifier,
  },
  [7] = {
    [0] = sym_arg_identifier,
  },
  [9] = {
    [0] = sym_cmd_identifier,
  },
  [13] = {
    [0] = sym_cmd_identifier,
  },
  [17] = {
    [0] = sym_arg_identifier,
    [2] = sym_arg_identifier,
  },
  [19] = {
    [0] = sym_pf_arg_identifier,
    [2] = sym_pf_arg_identifier,
  },
  [22] = {
    [1] = sym_pf_arg_identifier,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  aux_sym_tmp_eval_arg_repeat1, 2,
    aux_sym_tmp_eval_arg_repeat1,
    sym_arg_identifier,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 2,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 6,
  [9] = 7,
  [10] = 7,
  [11] = 6,
  [12] = 7,
  [13] = 6,
  [14] = 7,
  [15] = 7,
  [16] = 6,
  [17] = 7,
  [18] = 7,
  [19] = 6,
  [20] = 6,
  [21] = 7,
  [22] = 6,
  [23] = 6,
  [24] = 6,
  [25] = 7,
  [26] = 6,
  [27] = 7,
  [28] = 6,
  [29] = 7,
  [30] = 30,
  [31] = 30,
  [32] = 32,
  [33] = 32,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 36,
  [39] = 39,
  [40] = 39,
  [41] = 37,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 45,
  [56] = 44,
  [57] = 47,
  [58] = 42,
  [59] = 50,
  [60] = 43,
  [61] = 48,
  [62] = 49,
  [63] = 46,
  [64] = 52,
  [65] = 53,
  [66] = 66,
  [67] = 54,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 66,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 69,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 82,
  [99] = 99,
  [100] = 77,
  [101] = 101,
  [102] = 102,
  [103] = 82,
  [104] = 77,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 74,
  [116] = 116,
  [117] = 71,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 90,
  [122] = 94,
  [123] = 89,
  [124] = 124,
  [125] = 73,
  [126] = 86,
  [127] = 78,
  [128] = 87,
  [129] = 77,
  [130] = 130,
  [131] = 82,
  [132] = 132,
  [133] = 83,
  [134] = 134,
  [135] = 81,
  [136] = 136,
  [137] = 137,
  [138] = 77,
  [139] = 139,
  [140] = 95,
  [141] = 141,
  [142] = 102,
  [143] = 82,
  [144] = 108,
  [145] = 77,
  [146] = 110,
  [147] = 99,
  [148] = 148,
  [149] = 80,
  [150] = 79,
  [151] = 81,
  [152] = 87,
  [153] = 76,
  [154] = 78,
  [155] = 86,
  [156] = 156,
  [157] = 82,
  [158] = 77,
  [159] = 82,
  [160] = 108,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 164,
  [165] = 91,
  [166] = 166,
  [167] = 167,
  [168] = 168,
  [169] = 169,
  [170] = 170,
  [171] = 171,
  [172] = 172,
  [173] = 173,
  [174] = 174,
  [175] = 77,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 180,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 199,
  [200] = 200,
  [201] = 201,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 205,
  [206] = 206,
  [207] = 82,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 219,
  [220] = 220,
  [221] = 221,
  [222] = 222,
  [223] = 223,
  [224] = 224,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 169,
  [261] = 169,
  [262] = 262,
  [263] = 263,
  [264] = 178,
  [265] = 216,
  [266] = 214,
  [267] = 263,
  [268] = 262,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 51,
  [274] = 53,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 279,
  [282] = 278,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 283,
  [290] = 290,
  [291] = 277,
  [292] = 280,
  [293] = 279,
  [294] = 287,
  [295] = 279,
  [296] = 296,
  [297] = 290,
  [298] = 284,
  [299] = 279,
  [300] = 296,
  [301] = 285,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 315,
  [316] = 316,
  [317] = 74,
  [318] = 73,
  [319] = 71,
  [320] = 320,
  [321] = 78,
  [322] = 86,
  [323] = 76,
  [324] = 87,
  [325] = 77,
  [326] = 81,
  [327] = 82,
  [328] = 83,
  [329] = 320,
  [330] = 320,
  [331] = 320,
  [332] = 320,
  [333] = 79,
  [334] = 80,
  [335] = 335,
  [336] = 68,
  [337] = 337,
  [338] = 335,
  [339] = 337,
  [340] = 340,
  [341] = 69,
  [342] = 340,
  [343] = 343,
  [344] = 91,
  [345] = 343,
  [346] = 346,
  [347] = 347,
  [348] = 347,
  [349] = 349,
  [350] = 349,
  [351] = 351,
  [352] = 351,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 356,
  [359] = 96,
  [360] = 360,
  [361] = 357,
  [362] = 101,
  [363] = 356,
  [364] = 364,
  [365] = 356,
  [366] = 357,
  [367] = 97,
  [368] = 357,
  [369] = 357,
  [370] = 370,
  [371] = 356,
  [372] = 356,
  [373] = 373,
  [374] = 357,
  [375] = 375,
  [376] = 73,
  [377] = 377,
  [378] = 71,
  [379] = 82,
  [380] = 377,
  [381] = 105,
  [382] = 74,
  [383] = 383,
  [384] = 383,
  [385] = 107,
  [386] = 106,
  [387] = 383,
  [388] = 77,
  [389] = 109,
  [390] = 82,
  [391] = 78,
  [392] = 77,
  [393] = 83,
  [394] = 394,
  [395] = 80,
  [396] = 87,
  [397] = 81,
  [398] = 79,
  [399] = 76,
  [400] = 86,
  [401] = 401,
  [402] = 402,
  [403] = 91,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 408,
  [410] = 407,
  [411] = 411,
  [412] = 408,
  [413] = 407,
  [414] = 408,
  [415] = 415,
  [416] = 416,
  [417] = 407,
  [418] = 408,
  [419] = 408,
  [420] = 407,
  [421] = 407,
  [422] = 422,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 422,
  [433] = 431,
  [434] = 424,
  [435] = 426,
  [436] = 436,
  [437] = 427,
  [438] = 74,
  [439] = 71,
  [440] = 78,
  [441] = 87,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 83,
  [449] = 444,
  [450] = 80,
  [451] = 77,
  [452] = 79,
  [453] = 76,
  [454] = 82,
  [455] = 86,
  [456] = 81,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 459,
  [462] = 460,
  [463] = 459,
  [464] = 460,
  [465] = 459,
  [466] = 460,
  [467] = 459,
  [468] = 460,
  [469] = 459,
  [470] = 460,
  [471] = 459,
  [472] = 472,
  [473] = 460,
  [474] = 460,
  [475] = 459,
  [476] = 459,
  [477] = 472,
  [478] = 478,
  [479] = 479,
  [480] = 460,
  [481] = 460,
  [482] = 482,
  [483] = 459,
  [484] = 460,
  [485] = 472,
  [486] = 472,
  [487] = 487,
  [488] = 488,
  [489] = 91,
  [490] = 490,
  [491] = 491,
  [492] = 478,
  [493] = 493,
  [494] = 494,
  [495] = 459,
  [496] = 496,
  [497] = 497,
  [498] = 459,
  [499] = 499,
  [500] = 460,
  [501] = 491,
  [502] = 502,
  [503] = 472,
  [504] = 494,
};

static inline bool sym_grep_specifier_identifier_character_set_1(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= '(' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : c <= '>')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '('
        ? c == '#'
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool sym_grep_specifier_identifier_character_set_3(int32_t c) {
  return (c < '('
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || c == '#'))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || c == '|'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= ')')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < '.'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= '.' || (c < '`'
      ? (c < '='
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym__pf_dot_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == '.'))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '\''
        ? c == '"'
        : c <= '\'')))
    : (c <= ';' || (c < '|'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '|' || c == '~'))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_pf_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < '\''
    ? (c < '\r'
      ? (c < '\t'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < '"'
        ? c == ' '
        : c <= '#')))
    : (c <= ')' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_tmp_eval_arg_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '$' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < '\r'
      ? (c < '\n'
        ? c == 0
        : c <= '\n')
      : (c <= '\r' || (c < ','
        ? (c >= '(' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '\\'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : c <= '@')
      : (c <= '\\' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_2(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? (c >= '=' && c <= '>')
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool sym__eq_sep_key_identifier_character_set_3(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : (c <= ')' || c == ','))))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '='
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ';'
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : (c <= '@' || c == '\\'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '@'
        ? c == ';'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? c == ';'
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_arg_identifier_token1_character_set_4(int32_t c) {
  return (c < ';'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_1(int32_t c) {
  return (c < ':'
    ? (c < '"'
      ? (c < '\n'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= '"' || (c < ','
        ? (c >= '\'' && c <= ')')
        : c <= ',')))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_2(int32_t c) {
  return (c < ','
    ? (c < ' '
      ? (c < '\t'
        ? c == 0
        : (c <= '\n' || c == '\r'))
      : (c <= ' ' || (c < '\''
        ? (c >= '"' && c <= '#')
        : c <= ')')))
    : (c <= ',' || (c < '`'
      ? (c < '>'
        ? (c >= ':' && c <= ';')
        : (c <= '>' || c == '@'))
      : (c <= '`' || (c < '~'
        ? c == '|'
        : c <= '~')))));
}

static inline bool aux_sym_spec_arg_identifier_token1_character_set_3(int32_t c) {
  return (c < ':'
    ? (c < '\''
      ? (c < '"'
        ? c == '\t'
        : c <= '#')
      : (c <= ')' || c == ','))
    : (c <= ';' || (c < '`'
      ? (c < '@'
        ? c == '>'
        : c <= '@')
      : (c <= '`' || (c >= '|' && c <= '~')))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(167);
      if (lookahead == '\'') ADVANCE(206);
      if (lookahead == '(') ADVANCE(137);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == '*') ADVANCE(177);
      if (lookahead == ',') ADVANCE(182);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '=') ADVANCE(157);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(184);
      if (lookahead == '\\') ADVANCE(205);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(0)
      if (lookahead != 0) ADVANCE(183);
      END_STATE();
    case 1:
      if (lookahead == ' ') ADVANCE(117);
      if (lookahead == '!') ADVANCE(118);
      if (lookahead == '(') ADVANCE(119);
      if (lookahead == '@') ADVANCE(94);
      if (lookahead == 'B') ADVANCE(18);
      if (lookahead == 'F') ADVANCE(19);
      if (lookahead == 'a') ADVANCE(20);
      if (lookahead == 'b') ADVANCE(21);
      if (lookahead == 'e') ADVANCE(22);
      if (lookahead == 'f') ADVANCE(23);
      if (lookahead == 'i') ADVANCE(24);
      if (lookahead == 'k') ADVANCE(25);
      if (lookahead == 'o') ADVANCE(26);
      if (lookahead == 'r') ADVANCE(27);
      if (lookahead == 's') ADVANCE(28);
      if (lookahead == 'v') ADVANCE(29);
      if (lookahead == 'x') ADVANCE(30);
      END_STATE();
    case 2:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(16);
      if (lookahead == '%') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(206);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(2)
      if (!sym__eq_sep_key_identifier_character_set_1(lookahead)) ADVANCE(189);
      END_STATE();
    case 3:
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(199);
      if (lookahead == '$') ADVANCE(203);
      if (lookahead == '\\') ADVANCE(205);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(200);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(201);
      END_STATE();
    case 4:
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|') ADVANCE(83);
      END_STATE();
    case 5:
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(166);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(5)
      if (!aux_sym_spec_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(197);
      END_STATE();
    case 6:
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(164);
      if (lookahead == '(') ADVANCE(136);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(6)
      if (!aux_sym_pf_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(171);
      END_STATE();
    case 7:
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(165);
      if (lookahead == '.') ADVANCE(142);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(7)
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(161);
      END_STATE();
    case 8:
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(8)
      if (!aux_sym_tmp_eval_arg_token1_character_set_1(lookahead)) ADVANCE(183);
      END_STATE();
    case 9:
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(9)
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(135);
      END_STATE();
    case 10:
      if (lookahead == '#') ADVANCE(207);
      if (lookahead == '\'') ADVANCE(206);
      if (lookahead == '\\') ADVANCE(211);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(209);
      END_STATE();
    case 11:
      if (lookahead == '#') ADVANCE(216);
      if (lookahead == '\\') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(77);
      END_STATE();
    case 12:
      if (lookahead == '$') ADVANCE(194);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(191);
      END_STATE();
    case 13:
      if (lookahead == '$') ADVANCE(169);
      if (lookahead == '{') ADVANCE(56);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(171);
      END_STATE();
    case 14:
      if (lookahead == '$') ADVANCE(160);
      if (lookahead == '{') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(161);
      END_STATE();
    case 15:
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '{') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(197);
      END_STATE();
    case 16:
      if (lookahead == '(') ADVANCE(212);
      if (lookahead == '{') ADVANCE(57);
      if (lookahead != 0) ADVANCE(189);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(154);
      END_STATE();
    case 18:
      if (lookahead == ':') ADVANCE(123);
      END_STATE();
    case 19:
      if (lookahead == ':') ADVANCE(125);
      END_STATE();
    case 20:
      if (lookahead == ':') ADVANCE(121);
      END_STATE();
    case 21:
      if (lookahead == ':') ADVANCE(122);
      END_STATE();
    case 22:
      if (lookahead == ':') ADVANCE(124);
      END_STATE();
    case 23:
      if (lookahead == ':') ADVANCE(130);
      END_STATE();
    case 24:
      if (lookahead == ':') ADVANCE(126);
      END_STATE();
    case 25:
      if (lookahead == ':') ADVANCE(127);
      END_STATE();
    case 26:
      if (lookahead == ':') ADVANCE(128);
      END_STATE();
    case 27:
      if (lookahead == ':') ADVANCE(129);
      END_STATE();
    case 28:
      if (lookahead == ':') ADVANCE(131);
      END_STATE();
    case 29:
      if (lookahead == ':') ADVANCE(132);
      END_STATE();
    case 30:
      if (lookahead == ':') ADVANCE(133);
      END_STATE();
    case 31:
      if (lookahead == ':') ADVANCE(95);
      END_STATE();
    case 32:
      if (lookahead == ':') ADVANCE(116);
      END_STATE();
    case 33:
      if (lookahead == ':') ADVANCE(96);
      END_STATE();
    case 34:
      if (lookahead == '=') ADVANCE(93);
      if (lookahead == 'c') ADVANCE(33);
      END_STATE();
    case 35:
      if (lookahead == '>') ADVANCE(180);
      END_STATE();
    case 36:
      if (lookahead == 'b') ADVANCE(41);
      if (lookahead == 'm') ADVANCE(114);
      END_STATE();
    case 37:
      if (lookahead == 'f') ADVANCE(152);
      END_STATE();
    case 38:
      if (lookahead == 'f') ADVANCE(155);
      END_STATE();
    case 39:
      if (lookahead == 'm') ADVANCE(113);
      END_STATE();
    case 40:
      if (lookahead == 'n') ADVANCE(42);
      END_STATE();
    case 41:
      if (lookahead == 't') ADVANCE(99);
      END_STATE();
    case 42:
      if (lookahead == 'v') ADVANCE(173);
      END_STATE();
    case 43:
      if (lookahead == '{') ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(189);
      END_STATE();
    case 44:
      if (lookahead == '}') ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '}') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(45);
      END_STATE();
    case 46:
      if (lookahead == '}') ADVANCE(189);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(46);
      END_STATE();
    case 47:
      if (lookahead == '}') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(47);
      END_STATE();
    case 48:
      if (lookahead == '}') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$') ADVANCE(48);
      END_STATE();
    case 49:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(191);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(192);
      END_STATE();
    case 50:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(172);
      END_STATE();
    case 51:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(161);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(162);
      END_STATE();
    case 52:
      if (lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == '$' ||
          lookahead == '}') ADVANCE(197);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(198);
      END_STATE();
    case 53:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 54:
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 55:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(44);
      END_STATE();
    case 56:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(45);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(46);
      END_STATE();
    case 58:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(47);
      END_STATE();
    case 59:
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          lookahead != '$' &&
          lookahead != '}') ADVANCE(48);
      END_STATE();
    case 60:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(191);
      END_STATE();
    case 61:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(171);
      END_STATE();
    case 62:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(161);
      END_STATE();
    case 63:
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(197);
      END_STATE();
    case 64:
      if (lookahead != 0) ADVANCE(77);
      END_STATE();
    case 65:
      if (eof) ADVANCE(74);
      if (lookahead == '\t') SKIP(65)
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == ' ') ADVANCE(146);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(35);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      END_STATE();
    case 66:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '!') ADVANCE(175);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '(') ADVANCE(137);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == '*') ADVANCE(177);
      if (lookahead == '.') ADVANCE(143);
      if (lookahead == '/') ADVANCE(141);
      if (lookahead == '0') ADVANCE(53);
      if (lookahead == ':') ADVANCE(98);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '=') ADVANCE(157);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '?') ADVANCE(176);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'C') ADVANCE(37);
      if (lookahead == 'H') ADVANCE(35);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == 'e') ADVANCE(40);
      if (lookahead == 'p') ADVANCE(38);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(66)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(214);
      END_STATE();
    case 67:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(206);
      if (lookahead == '(') ADVANCE(136);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ',') ADVANCE(182);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(190);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(67)
      if (lookahead != 0) ADVANCE(191);
      END_STATE();
    case 68:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(163);
      if (lookahead == '\'') ADVANCE(206);
      if (lookahead == '(') ADVANCE(136);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ',') ADVANCE(182);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(68)
      if (lookahead != 0 &&
          lookahead != '>' &&
          lookahead != '@' &&
          lookahead != '|' &&
          lookahead != '~') ADVANCE(191);
      END_STATE();
    case 69:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '"') ADVANCE(75);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(16);
      if (lookahead == '%') ADVANCE(185);
      if (lookahead == '\'') ADVANCE(206);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(186);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(69)
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ',' &&
          lookahead != '=' &&
          lookahead != '\\') ADVANCE(189);
      END_STATE();
    case 70:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '(') ADVANCE(83);
      END_STATE();
    case 71:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(164);
      if (lookahead == '(') ADVANCE(136);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '=') ADVANCE(158);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(71)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 72:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == '$') ADVANCE(164);
      if (lookahead == '(') ADVANCE(136);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(72)
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '\'') ADVANCE(171);
      END_STATE();
    case 73:
      if (eof) ADVANCE(74);
      if (lookahead == '\n') ADVANCE(219);
      if (lookahead == '\r') ADVANCE(220);
      if (lookahead == '#') ADVANCE(217);
      if (lookahead == ')') ADVANCE(120);
      if (lookahead == ',') ADVANCE(182);
      if (lookahead == ';') ADVANCE(134);
      if (lookahead == '>') ADVANCE(178);
      if (lookahead == '@') ADVANCE(1);
      if (lookahead == 'H') ADVANCE(184);
      if (lookahead == '`') ADVANCE(213);
      if (lookahead == '|') ADVANCE(89);
      if (lookahead == '~') ADVANCE(78);
      if (lookahead == '\t' ||
          lookahead == ' ') SKIP(73)
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\'' &&
          lookahead != '(' &&
          lookahead != '\\') ADVANCE(183);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_stmt_token1);
      if (lookahead == '#') ADVANCE(216);
      if (lookahead == '\\') ADVANCE(64);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(76);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(77);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(aux_sym_legacy_quoted_stmt_token1);
      if (lookahead == '\\') ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(77);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_TILDE);
      if (lookahead == '$') ADVANCE(54);
      if (lookahead == '\\') ADVANCE(85);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == 'H') ADVANCE(82);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead == '~') ADVANCE(79);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(80);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(87);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(81);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(54);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '\\') ADVANCE(85);
      if (!sym_grep_specifier_identifier_character_set_3(lookahead)) ADVANCE(83);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(54);
      if (lookahead == '\\') ADVANCE(85);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead == ')' ||
          lookahead == '@') ADVANCE(83);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(84);
      if (lookahead == '\\') ADVANCE(85);
      if (lookahead == '\r' ||
          lookahead == '#' ||
          lookahead == '(' ||
          lookahead == ')' ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          lookahead == '|') ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(83);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_grep_specifier_identifier);
      if (lookahead == '$') ADVANCE(88);
      if (lookahead == '\\') ADVANCE(85);
      if (!sym_grep_specifier_identifier_character_set_2(lookahead)) ADVANCE(83);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(86);
      if (lookahead == '(') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '>' &&
          lookahead != '`' &&
          lookahead != '|') ADVANCE(83);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(aux_sym_grep_specifier_token1);
      if (lookahead == '$') ADVANCE(86);
      if (!sym_grep_specifier_identifier_character_set_1(lookahead)) ADVANCE(83);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '.') ADVANCE(149);
      if (lookahead == 'H') ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PIPEH);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_AT_AT_DOT);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_AT_AT_EQ);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_AT_AT_AT_EQ);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_AT_AT);
      if (lookahead == '.') ADVANCE(91);
      if (lookahead == '=') ADVANCE(92);
      if (lookahead == '@') ADVANCE(34);
      if (lookahead == 'C') ADVANCE(97);
      if (lookahead == 'F') ADVANCE(112);
      if (lookahead == 'b') ADVANCE(104);
      if (lookahead == 'c') ADVANCE(31);
      if (lookahead == 'd') ADVANCE(36);
      if (lookahead == 'f') ADVANCE(111);
      if (lookahead == 'i') ADVANCE(105);
      if (lookahead == 'o') ADVANCE(39);
      if (lookahead == 'r') ADVANCE(115);
      if (lookahead == 's') ADVANCE(32);
      if (lookahead == 't') ADVANCE(103);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AT_ATc_COLON);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AT_AT_ATc_COLON);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_AT_ATC);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_AT_ATdbt);
      if (lookahead == 'a') ADVANCE(100);
      if (lookahead == 'b') ADVANCE(101);
      if (lookahead == 's') ADVANCE(102);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_AT_ATdbta);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_AT_ATdbtb);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_AT_ATdbts);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_AT_ATt);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_AT_ATb);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_AT_ATi);
      if (lookahead == 'S') ADVANCE(107);
      if (lookahead == 'i') ADVANCE(106);
      if (lookahead == 's') ADVANCE(109);
      if (lookahead == 'z') ADVANCE(110);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AT_ATii);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_AT_ATiS);
      if (lookahead == 'S') ADVANCE(108);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_AT_ATiSS);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_AT_ATis);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AT_ATiz);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_AT_ATf);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_AT_ATF);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AT_ATom);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_AT_ATdm);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_AT_ATr);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_AT_ATs_COLON);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_AT_BANG);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_AT_LPAREN);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_ATa_COLON);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_ATb_COLON);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_ATB_COLON);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_ATe_COLON);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_ATF_COLON);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_ATi_COLON);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_ATk_COLON);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_ATo_COLON);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_ATr_COLON);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_ATf_COLON);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_ATs_COLON);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_ATv_COLON);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_ATx_COLON);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym_macro_name);
      if (lookahead == '-' ||
          lookahead == '.' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '-') ADVANCE(140);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_LPAREN_DASH_STAR);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_LPAREN_STAR);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(anon_sym_LPAREN_DASH);
      if (lookahead == '*') ADVANCE(138);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym__search_stmt_token1);
      if (lookahead == '!' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('/' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(141);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == ' ') ADVANCE(147);
      if (lookahead == '(') ADVANCE(148);
      if (lookahead == '.') ADVANCE(144);
      if (lookahead == '/') ADVANCE(150);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(145);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token1);
      if (lookahead == '(') ADVANCE(148);
      if (lookahead == '.') ADVANCE(174);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == ':') ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token1);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(145);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token2);
      if (lookahead == ' ') ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token3);
      if (lookahead == ' ') ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym__interpret_stmt_token4);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_PIPE_DOT);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_DOT_SLASH);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_pfo);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_Cf);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym_pf_dot_cmd_identifier);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_pf_dot_full_cmd_identifier);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(153);
      if (lookahead == 'o') ADVANCE(151);
      if (lookahead == 'v') ADVANCE(17);
      if (lookahead == '*' ||
          lookahead == 'c' ||
          lookahead == 'j' ||
          lookahead == 'q' ||
          lookahead == 's') ADVANCE(156);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(aux_sym_pf_cmd_token1);
      if (lookahead == '.') ADVANCE(154);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(171);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '\\') ADVANCE(62);
      if (lookahead == '{') ADVANCE(162);
      if (lookahead == '.' ||
          lookahead == '=') ADVANCE(161);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(161);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(159);
      if (lookahead == '\\') ADVANCE(62);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(161);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(62);
      if (!aux_sym__pf_dot_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(aux_sym__pf_dot_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(14);
      if (lookahead == '\\') ADVANCE(51);
      if (lookahead == '}') ADVANCE(161);
      if (aux_sym__pf_dot_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(194);
      if (lookahead == '(') ADVANCE(212);
      if (lookahead == '{') ADVANCE(55);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(191);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(169);
      if (lookahead == '(') ADVANCE(212);
      if (lookahead == '{') ADVANCE(56);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(171);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(160);
      if (lookahead == '(') ADVANCE(212);
      if (lookahead == '{') ADVANCE(58);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(161);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '$') ADVANCE(196);
      if (lookahead == '{') ADVANCE(59);
      if (!aux_sym_arg_identifier_token1_character_set_1(lookahead)) ADVANCE(197);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(') ADVANCE(212);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(61);
      if (lookahead == '{') ADVANCE(172);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(171);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(168);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(171);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym_pf_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(61);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(171);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(aux_sym_pf_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(13);
      if (lookahead == '\\') ADVANCE(50);
      if (lookahead == '}') ADVANCE(171);
      if (lookahead == '\t' ||
          lookahead == '"' ||
          lookahead == '#' ||
          ('\'' <= lookahead && lookahead <= ')') ||
          lookahead == ';' ||
          lookahead == '>' ||
          lookahead == '@' ||
          lookahead == '`' ||
          ('|' <= lookahead && lookahead <= '~')) ADVANCE(45);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__env_stmt_identifier);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      if (lookahead == '*' ||
          lookahead == '-' ||
          lookahead == '.' ||
          lookahead == ':') ADVANCE(145);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_system_identifier);
      if (('!' <= lookahead && lookahead <= '=')) ADVANCE(175);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_question_mark_identifier);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_pointer_identifier);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '>') ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym_html_redirect_operator);
      if (lookahead == '>') ADVANCE(181);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_html_append_operator);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(aux_sym_tmp_eval_arg_token1);
      if (lookahead == '>') ADVANCE(180);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(185);
      if (lookahead == '5') ADVANCE(187);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(185);
      if (lookahead == '>') ADVANCE(180);
      if (!sym__eq_sep_key_identifier_character_set_3(lookahead)) ADVANCE(189);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(185);
      if (lookahead == 'C') ADVANCE(188);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(185);
      if (lookahead == 's') ADVANCE(189);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym__eq_sep_key_identifier);
      if (lookahead == '$') ADVANCE(43);
      if (lookahead == '%') ADVANCE(185);
      if (!sym__eq_sep_key_identifier_character_set_2(lookahead)) ADVANCE(189);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '>') ADVANCE(180);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(191);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(12);
      if (lookahead == '\\') ADVANCE(49);
      if (lookahead == '}') ADVANCE(191);
      if (aux_sym_arg_identifier_token1_character_set_4(lookahead)) ADVANCE(44);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(192);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(193);
      if (lookahead == ',') ADVANCE(191);
      if (lookahead == '\\') ADVANCE(60);
      if (lookahead == '{') ADVANCE(192);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(191);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(aux_sym_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(193);
      if (lookahead == '\\') ADVANCE(60);
      if (!aux_sym_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(191);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(195);
      if (lookahead == '\\') ADVANCE(63);
      if (lookahead == '{') ADVANCE(198);
      if (lookahead == ',' ||
          lookahead == ':') ADVANCE(197);
      if (!aux_sym_pf_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(197);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(195);
      if (lookahead == '\\') ADVANCE(63);
      if (!aux_sym_spec_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(197);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(15);
      if (lookahead == '\\') ADVANCE(63);
      if (!aux_sym_spec_arg_identifier_token1_character_set_2(lookahead)) ADVANCE(197);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(aux_sym_spec_arg_identifier_token1);
      if (lookahead == '$') ADVANCE(15);
      if (lookahead == '\\') ADVANCE(52);
      if (lookahead == '}') ADVANCE(197);
      if (aux_sym_spec_arg_identifier_token1_character_set_3(lookahead)) ADVANCE(48);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ') ADVANCE(198);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(201);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(199);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(199);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(200);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          (lookahead < '"' || '$' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(201);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '\\' &&
          lookahead != '`') ADVANCE(201);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token2);
      if (lookahead == '(') ADVANCE(212);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(202);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(aux_sym_double_quoted_arg_token3);
      if (lookahead == '\n' ||
          lookahead == '"' ||
          lookahead == '$' ||
          lookahead == '\\' ||
          lookahead == '`') ADVANCE(204);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '\r') ADVANCE(209);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(207);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead == '#') ADVANCE(207);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(208);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(209);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\') ADVANCE(209);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(aux_sym_single_quoted_arg_token2);
      if (lookahead == '\n' ||
          lookahead == '\'' ||
          lookahead == '\\') ADVANCE(210);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(aux_sym__dec_number_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(214);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(aux_sym__dec_number_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(215);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead == '"') ADVANCE(217);
      if (lookahead == '\\') ADVANCE(218);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(216);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(217);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(sym__comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(216);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_CR);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 66, .external_lex_state = 2},
  [2] = {.lex_state = 66, .external_lex_state = 3},
  [3] = {.lex_state = 66, .external_lex_state = 3},
  [4] = {.lex_state = 66, .external_lex_state = 2},
  [5] = {.lex_state = 66, .external_lex_state = 2},
  [6] = {.lex_state = 66, .external_lex_state = 2},
  [7] = {.lex_state = 66, .external_lex_state = 2},
  [8] = {.lex_state = 66, .external_lex_state = 2},
  [9] = {.lex_state = 66, .external_lex_state = 2},
  [10] = {.lex_state = 66, .external_lex_state = 2},
  [11] = {.lex_state = 66, .external_lex_state = 2},
  [12] = {.lex_state = 66, .external_lex_state = 2},
  [13] = {.lex_state = 66, .external_lex_state = 2},
  [14] = {.lex_state = 66, .external_lex_state = 2},
  [15] = {.lex_state = 66, .external_lex_state = 2},
  [16] = {.lex_state = 66, .external_lex_state = 2},
  [17] = {.lex_state = 66, .external_lex_state = 2},
  [18] = {.lex_state = 66, .external_lex_state = 2},
  [19] = {.lex_state = 66, .external_lex_state = 2},
  [20] = {.lex_state = 66, .external_lex_state = 2},
  [21] = {.lex_state = 66, .external_lex_state = 2},
  [22] = {.lex_state = 66, .external_lex_state = 2},
  [23] = {.lex_state = 66, .external_lex_state = 2},
  [24] = {.lex_state = 66, .external_lex_state = 2},
  [25] = {.lex_state = 66, .external_lex_state = 2},
  [26] = {.lex_state = 66, .external_lex_state = 2},
  [27] = {.lex_state = 66, .external_lex_state = 2},
  [28] = {.lex_state = 66, .external_lex_state = 2},
  [29] = {.lex_state = 66, .external_lex_state = 2},
  [30] = {.lex_state = 66, .external_lex_state = 2},
  [31] = {.lex_state = 66, .external_lex_state = 2},
  [32] = {.lex_state = 66, .external_lex_state = 2},
  [33] = {.lex_state = 66, .external_lex_state = 2},
  [34] = {.lex_state = 66, .external_lex_state = 2},
  [35] = {.lex_state = 66, .external_lex_state = 2},
  [36] = {.lex_state = 66, .external_lex_state = 2},
  [37] = {.lex_state = 66, .external_lex_state = 2},
  [38] = {.lex_state = 66, .external_lex_state = 2},
  [39] = {.lex_state = 66, .external_lex_state = 2},
  [40] = {.lex_state = 66, .external_lex_state = 2},
  [41] = {.lex_state = 66, .external_lex_state = 2},
  [42] = {.lex_state = 67, .external_lex_state = 4},
  [43] = {.lex_state = 67, .external_lex_state = 4},
  [44] = {.lex_state = 67, .external_lex_state = 4},
  [45] = {.lex_state = 67, .external_lex_state = 4},
  [46] = {.lex_state = 67, .external_lex_state = 4},
  [47] = {.lex_state = 67, .external_lex_state = 4},
  [48] = {.lex_state = 67, .external_lex_state = 4},
  [49] = {.lex_state = 67, .external_lex_state = 4},
  [50] = {.lex_state = 67, .external_lex_state = 4},
  [51] = {.lex_state = 67, .external_lex_state = 4},
  [52] = {.lex_state = 67, .external_lex_state = 4},
  [53] = {.lex_state = 67, .external_lex_state = 4},
  [54] = {.lex_state = 71, .external_lex_state = 5},
  [55] = {.lex_state = 67, .external_lex_state = 4},
  [56] = {.lex_state = 67, .external_lex_state = 4},
  [57] = {.lex_state = 67, .external_lex_state = 4},
  [58] = {.lex_state = 67, .external_lex_state = 4},
  [59] = {.lex_state = 67, .external_lex_state = 4},
  [60] = {.lex_state = 67, .external_lex_state = 4},
  [61] = {.lex_state = 67, .external_lex_state = 4},
  [62] = {.lex_state = 67, .external_lex_state = 4},
  [63] = {.lex_state = 67, .external_lex_state = 4},
  [64] = {.lex_state = 67, .external_lex_state = 4},
  [65] = {.lex_state = 67, .external_lex_state = 4},
  [66] = {.lex_state = 69, .external_lex_state = 4},
  [67] = {.lex_state = 71, .external_lex_state = 5},
  [68] = {.lex_state = 72, .external_lex_state = 4},
  [69] = {.lex_state = 72, .external_lex_state = 4},
  [70] = {.lex_state = 67, .external_lex_state = 6},
  [71] = {.lex_state = 67, .external_lex_state = 7},
  [72] = {.lex_state = 67, .external_lex_state = 6},
  [73] = {.lex_state = 67, .external_lex_state = 7},
  [74] = {.lex_state = 67, .external_lex_state = 7},
  [75] = {.lex_state = 67, .external_lex_state = 6},
  [76] = {.lex_state = 67, .external_lex_state = 7},
  [77] = {.lex_state = 67, .external_lex_state = 7},
  [78] = {.lex_state = 67, .external_lex_state = 7},
  [79] = {.lex_state = 67, .external_lex_state = 7},
  [80] = {.lex_state = 67, .external_lex_state = 7},
  [81] = {.lex_state = 67, .external_lex_state = 7},
  [82] = {.lex_state = 67, .external_lex_state = 7},
  [83] = {.lex_state = 67, .external_lex_state = 7},
  [84] = {.lex_state = 67, .external_lex_state = 6},
  [85] = {.lex_state = 67, .external_lex_state = 6},
  [86] = {.lex_state = 67, .external_lex_state = 7},
  [87] = {.lex_state = 67, .external_lex_state = 7},
  [88] = {.lex_state = 69, .external_lex_state = 4},
  [89] = {.lex_state = 71, .external_lex_state = 5},
  [90] = {.lex_state = 71, .external_lex_state = 5},
  [91] = {.lex_state = 67, .external_lex_state = 4},
  [92] = {.lex_state = 67, .external_lex_state = 4},
  [93] = {.lex_state = 72, .external_lex_state = 4},
  [94] = {.lex_state = 71, .external_lex_state = 5},
  [95] = {.lex_state = 71, .external_lex_state = 5},
  [96] = {.lex_state = 72, .external_lex_state = 7},
  [97] = {.lex_state = 72, .external_lex_state = 7},
  [98] = {.lex_state = 71, .external_lex_state = 5},
  [99] = {.lex_state = 71, .external_lex_state = 5},
  [100] = {.lex_state = 71, .external_lex_state = 5},
  [101] = {.lex_state = 72, .external_lex_state = 7},
  [102] = {.lex_state = 71, .external_lex_state = 5},
  [103] = {.lex_state = 72, .external_lex_state = 7},
  [104] = {.lex_state = 72, .external_lex_state = 7},
  [105] = {.lex_state = 72, .external_lex_state = 7},
  [106] = {.lex_state = 72, .external_lex_state = 7},
  [107] = {.lex_state = 72, .external_lex_state = 7},
  [108] = {.lex_state = 70, .external_lex_state = 4},
  [109] = {.lex_state = 72, .external_lex_state = 4},
  [110] = {.lex_state = 70, .external_lex_state = 4},
  [111] = {.lex_state = 0, .external_lex_state = 8},
  [112] = {.lex_state = 73, .external_lex_state = 4},
  [113] = {.lex_state = 66, .external_lex_state = 9},
  [114] = {.lex_state = 66, .external_lex_state = 5},
  [115] = {.lex_state = 0, .external_lex_state = 8},
  [116] = {.lex_state = 66, .external_lex_state = 5},
  [117] = {.lex_state = 0, .external_lex_state = 8},
  [118] = {.lex_state = 66, .external_lex_state = 9},
  [119] = {.lex_state = 73, .external_lex_state = 4},
  [120] = {.lex_state = 66, .external_lex_state = 9},
  [121] = {.lex_state = 66, .external_lex_state = 5},
  [122] = {.lex_state = 66, .external_lex_state = 5},
  [123] = {.lex_state = 66, .external_lex_state = 5},
  [124] = {.lex_state = 66, .external_lex_state = 5},
  [125] = {.lex_state = 0, .external_lex_state = 8},
  [126] = {.lex_state = 0, .external_lex_state = 8},
  [127] = {.lex_state = 66, .external_lex_state = 9},
  [128] = {.lex_state = 0, .external_lex_state = 8},
  [129] = {.lex_state = 66, .external_lex_state = 9},
  [130] = {.lex_state = 0, .external_lex_state = 9},
  [131] = {.lex_state = 66, .external_lex_state = 9},
  [132] = {.lex_state = 0, .external_lex_state = 4},
  [133] = {.lex_state = 0, .external_lex_state = 8},
  [134] = {.lex_state = 0, .external_lex_state = 9},
  [135] = {.lex_state = 66, .external_lex_state = 9},
  [136] = {.lex_state = 73, .external_lex_state = 4},
  [137] = {.lex_state = 0, .external_lex_state = 4},
  [138] = {.lex_state = 66, .external_lex_state = 5},
  [139] = {.lex_state = 66, .external_lex_state = 9},
  [140] = {.lex_state = 66, .external_lex_state = 5},
  [141] = {.lex_state = 67, .external_lex_state = 4},
  [142] = {.lex_state = 66, .external_lex_state = 5},
  [143] = {.lex_state = 66, .external_lex_state = 5},
  [144] = {.lex_state = 70, .external_lex_state = 4},
  [145] = {.lex_state = 70, .external_lex_state = 4},
  [146] = {.lex_state = 70, .external_lex_state = 4},
  [147] = {.lex_state = 66, .external_lex_state = 5},
  [148] = {.lex_state = 66, .external_lex_state = 5},
  [149] = {.lex_state = 0, .external_lex_state = 8},
  [150] = {.lex_state = 0, .external_lex_state = 8},
  [151] = {.lex_state = 0, .external_lex_state = 8},
  [152] = {.lex_state = 66, .external_lex_state = 9},
  [153] = {.lex_state = 0, .external_lex_state = 8},
  [154] = {.lex_state = 0, .external_lex_state = 8},
  [155] = {.lex_state = 66, .external_lex_state = 9},
  [156] = {.lex_state = 0, .external_lex_state = 4},
  [157] = {.lex_state = 0, .external_lex_state = 8},
  [158] = {.lex_state = 0, .external_lex_state = 8},
  [159] = {.lex_state = 70, .external_lex_state = 4},
  [160] = {.lex_state = 70, .external_lex_state = 4},
  [161] = {.lex_state = 66, .external_lex_state = 4},
  [162] = {.lex_state = 66, .external_lex_state = 4},
  [163] = {.lex_state = 66, .external_lex_state = 4},
  [164] = {.lex_state = 66, .external_lex_state = 4},
  [165] = {.lex_state = 0, .external_lex_state = 9},
  [166] = {.lex_state = 66, .external_lex_state = 4},
  [167] = {.lex_state = 0, .external_lex_state = 4},
  [168] = {.lex_state = 0, .external_lex_state = 9},
  [169] = {.lex_state = 0, .external_lex_state = 4},
  [170] = {.lex_state = 0, .external_lex_state = 7},
  [171] = {.lex_state = 0, .external_lex_state = 4},
  [172] = {.lex_state = 0, .external_lex_state = 4},
  [173] = {.lex_state = 0, .external_lex_state = 4},
  [174] = {.lex_state = 0, .external_lex_state = 4},
  [175] = {.lex_state = 70, .external_lex_state = 4},
  [176] = {.lex_state = 0, .external_lex_state = 4},
  [177] = {.lex_state = 0, .external_lex_state = 4},
  [178] = {.lex_state = 66, .external_lex_state = 4},
  [179] = {.lex_state = 0, .external_lex_state = 4},
  [180] = {.lex_state = 0, .external_lex_state = 4},
  [181] = {.lex_state = 0, .external_lex_state = 4},
  [182] = {.lex_state = 0, .external_lex_state = 4},
  [183] = {.lex_state = 0, .external_lex_state = 4},
  [184] = {.lex_state = 0, .external_lex_state = 4},
  [185] = {.lex_state = 0, .external_lex_state = 4},
  [186] = {.lex_state = 0, .external_lex_state = 4},
  [187] = {.lex_state = 0, .external_lex_state = 4},
  [188] = {.lex_state = 0, .external_lex_state = 4},
  [189] = {.lex_state = 0, .external_lex_state = 4},
  [190] = {.lex_state = 0, .external_lex_state = 4},
  [191] = {.lex_state = 0, .external_lex_state = 4},
  [192] = {.lex_state = 0, .external_lex_state = 4},
  [193] = {.lex_state = 0, .external_lex_state = 4},
  [194] = {.lex_state = 0, .external_lex_state = 4},
  [195] = {.lex_state = 0, .external_lex_state = 4},
  [196] = {.lex_state = 0, .external_lex_state = 4},
  [197] = {.lex_state = 0, .external_lex_state = 4},
  [198] = {.lex_state = 0, .external_lex_state = 4},
  [199] = {.lex_state = 0, .external_lex_state = 4},
  [200] = {.lex_state = 0, .external_lex_state = 4},
  [201] = {.lex_state = 0, .external_lex_state = 4},
  [202] = {.lex_state = 0, .external_lex_state = 4},
  [203] = {.lex_state = 0, .external_lex_state = 4},
  [204] = {.lex_state = 0, .external_lex_state = 4},
  [205] = {.lex_state = 0, .external_lex_state = 4},
  [206] = {.lex_state = 0, .external_lex_state = 4},
  [207] = {.lex_state = 70, .external_lex_state = 4},
  [208] = {.lex_state = 0, .external_lex_state = 4},
  [209] = {.lex_state = 0, .external_lex_state = 4},
  [210] = {.lex_state = 0, .external_lex_state = 4},
  [211] = {.lex_state = 0, .external_lex_state = 4},
  [212] = {.lex_state = 0, .external_lex_state = 4},
  [213] = {.lex_state = 0, .external_lex_state = 4},
  [214] = {.lex_state = 65, .external_lex_state = 4},
  [215] = {.lex_state = 0, .external_lex_state = 4},
  [216] = {.lex_state = 0, .external_lex_state = 5},
  [217] = {.lex_state = 0, .external_lex_state = 4},
  [218] = {.lex_state = 0, .external_lex_state = 4},
  [219] = {.lex_state = 0, .external_lex_state = 4},
  [220] = {.lex_state = 0, .external_lex_state = 4},
  [221] = {.lex_state = 0, .external_lex_state = 4},
  [222] = {.lex_state = 0, .external_lex_state = 4},
  [223] = {.lex_state = 0, .external_lex_state = 4},
  [224] = {.lex_state = 0, .external_lex_state = 4},
  [225] = {.lex_state = 0, .external_lex_state = 4},
  [226] = {.lex_state = 0, .external_lex_state = 4},
  [227] = {.lex_state = 0, .external_lex_state = 4},
  [228] = {.lex_state = 0, .external_lex_state = 4},
  [229] = {.lex_state = 0, .external_lex_state = 4},
  [230] = {.lex_state = 0, .external_lex_state = 4},
  [231] = {.lex_state = 0, .external_lex_state = 4},
  [232] = {.lex_state = 0, .external_lex_state = 4},
  [233] = {.lex_state = 0, .external_lex_state = 4},
  [234] = {.lex_state = 0, .external_lex_state = 4},
  [235] = {.lex_state = 0, .external_lex_state = 4},
  [236] = {.lex_state = 0, .external_lex_state = 4},
  [237] = {.lex_state = 0, .external_lex_state = 4},
  [238] = {.lex_state = 0, .external_lex_state = 4},
  [239] = {.lex_state = 0, .external_lex_state = 4},
  [240] = {.lex_state = 0, .external_lex_state = 4},
  [241] = {.lex_state = 0, .external_lex_state = 4},
  [242] = {.lex_state = 0, .external_lex_state = 4},
  [243] = {.lex_state = 0, .external_lex_state = 4},
  [244] = {.lex_state = 0, .external_lex_state = 4},
  [245] = {.lex_state = 0, .external_lex_state = 4},
  [246] = {.lex_state = 0, .external_lex_state = 4},
  [247] = {.lex_state = 0, .external_lex_state = 4},
  [248] = {.lex_state = 0, .external_lex_state = 4},
  [249] = {.lex_state = 0, .external_lex_state = 4},
  [250] = {.lex_state = 0, .external_lex_state = 4},
  [251] = {.lex_state = 0, .external_lex_state = 4},
  [252] = {.lex_state = 0, .external_lex_state = 4},
  [253] = {.lex_state = 0, .external_lex_state = 4},
  [254] = {.lex_state = 0, .external_lex_state = 4},
  [255] = {.lex_state = 0, .external_lex_state = 4},
  [256] = {.lex_state = 0, .external_lex_state = 4},
  [257] = {.lex_state = 0, .external_lex_state = 4},
  [258] = {.lex_state = 0, .external_lex_state = 4},
  [259] = {.lex_state = 0, .external_lex_state = 4},
  [260] = {.lex_state = 0, .external_lex_state = 4},
  [261] = {.lex_state = 0, .external_lex_state = 4},
  [262] = {.lex_state = 0, .external_lex_state = 4},
  [263] = {.lex_state = 0, .external_lex_state = 4},
  [264] = {.lex_state = 66, .external_lex_state = 4},
  [265] = {.lex_state = 0, .external_lex_state = 5},
  [266] = {.lex_state = 65, .external_lex_state = 4},
  [267] = {.lex_state = 0, .external_lex_state = 4},
  [268] = {.lex_state = 0, .external_lex_state = 4},
  [269] = {.lex_state = 66, .external_lex_state = 2},
  [270] = {.lex_state = 66, .external_lex_state = 2},
  [271] = {.lex_state = 66, .external_lex_state = 2},
  [272] = {.lex_state = 68},
  [273] = {.lex_state = 68},
  [274] = {.lex_state = 68},
  [275] = {.lex_state = 68},
  [276] = {.lex_state = 68},
  [277] = {.lex_state = 68},
  [278] = {.lex_state = 68},
  [279] = {.lex_state = 68},
  [280] = {.lex_state = 68},
  [281] = {.lex_state = 68},
  [282] = {.lex_state = 68},
  [283] = {.lex_state = 68},
  [284] = {.lex_state = 68},
  [285] = {.lex_state = 68},
  [286] = {.lex_state = 68},
  [287] = {.lex_state = 68},
  [288] = {.lex_state = 68},
  [289] = {.lex_state = 68},
  [290] = {.lex_state = 68},
  [291] = {.lex_state = 68},
  [292] = {.lex_state = 68},
  [293] = {.lex_state = 68},
  [294] = {.lex_state = 68},
  [295] = {.lex_state = 68},
  [296] = {.lex_state = 68},
  [297] = {.lex_state = 68},
  [298] = {.lex_state = 68},
  [299] = {.lex_state = 68},
  [300] = {.lex_state = 68},
  [301] = {.lex_state = 68},
  [302] = {.lex_state = 68},
  [303] = {.lex_state = 68},
  [304] = {.lex_state = 68},
  [305] = {.lex_state = 68},
  [306] = {.lex_state = 68},
  [307] = {.lex_state = 68},
  [308] = {.lex_state = 68},
  [309] = {.lex_state = 68},
  [310] = {.lex_state = 68},
  [311] = {.lex_state = 68},
  [312] = {.lex_state = 68},
  [313] = {.lex_state = 68},
  [314] = {.lex_state = 68},
  [315] = {.lex_state = 68},
  [316] = {.lex_state = 68},
  [317] = {.lex_state = 68, .external_lex_state = 10},
  [318] = {.lex_state = 68, .external_lex_state = 10},
  [319] = {.lex_state = 68, .external_lex_state = 10},
  [320] = {.lex_state = 68},
  [321] = {.lex_state = 68, .external_lex_state = 10},
  [322] = {.lex_state = 68, .external_lex_state = 10},
  [323] = {.lex_state = 68, .external_lex_state = 10},
  [324] = {.lex_state = 68, .external_lex_state = 10},
  [325] = {.lex_state = 68, .external_lex_state = 10},
  [326] = {.lex_state = 68, .external_lex_state = 10},
  [327] = {.lex_state = 68, .external_lex_state = 10},
  [328] = {.lex_state = 68, .external_lex_state = 10},
  [329] = {.lex_state = 68},
  [330] = {.lex_state = 68},
  [331] = {.lex_state = 68},
  [332] = {.lex_state = 68},
  [333] = {.lex_state = 68, .external_lex_state = 10},
  [334] = {.lex_state = 68, .external_lex_state = 10},
  [335] = {.lex_state = 6},
  [336] = {.lex_state = 6},
  [337] = {.lex_state = 6},
  [338] = {.lex_state = 6},
  [339] = {.lex_state = 6},
  [340] = {.lex_state = 6},
  [341] = {.lex_state = 6},
  [342] = {.lex_state = 6},
  [343] = {.lex_state = 6},
  [344] = {.lex_state = 68},
  [345] = {.lex_state = 6},
  [346] = {.lex_state = 2},
  [347] = {.lex_state = 7},
  [348] = {.lex_state = 7},
  [349] = {.lex_state = 7},
  [350] = {.lex_state = 7},
  [351] = {.lex_state = 6},
  [352] = {.lex_state = 6},
  [353] = {.lex_state = 7},
  [354] = {.lex_state = 2},
  [355] = {.lex_state = 68},
  [356] = {.lex_state = 3},
  [357] = {.lex_state = 3},
  [358] = {.lex_state = 3},
  [359] = {.lex_state = 6, .external_lex_state = 10},
  [360] = {.lex_state = 68},
  [361] = {.lex_state = 3},
  [362] = {.lex_state = 6, .external_lex_state = 10},
  [363] = {.lex_state = 3},
  [364] = {.lex_state = 3},
  [365] = {.lex_state = 3},
  [366] = {.lex_state = 3},
  [367] = {.lex_state = 6, .external_lex_state = 10},
  [368] = {.lex_state = 3},
  [369] = {.lex_state = 3},
  [370] = {.lex_state = 68},
  [371] = {.lex_state = 3},
  [372] = {.lex_state = 3},
  [373] = {.lex_state = 68},
  [374] = {.lex_state = 3},
  [375] = {.lex_state = 68},
  [376] = {.lex_state = 6, .external_lex_state = 10},
  [377] = {.lex_state = 7},
  [378] = {.lex_state = 6, .external_lex_state = 10},
  [379] = {.lex_state = 6, .external_lex_state = 10},
  [380] = {.lex_state = 7},
  [381] = {.lex_state = 6, .external_lex_state = 10},
  [382] = {.lex_state = 6, .external_lex_state = 10},
  [383] = {.lex_state = 4},
  [384] = {.lex_state = 4},
  [385] = {.lex_state = 6, .external_lex_state = 10},
  [386] = {.lex_state = 6, .external_lex_state = 10},
  [387] = {.lex_state = 4},
  [388] = {.lex_state = 6, .external_lex_state = 10},
  [389] = {.lex_state = 6},
  [390] = {.lex_state = 3},
  [391] = {.lex_state = 6, .external_lex_state = 10},
  [392] = {.lex_state = 3},
  [393] = {.lex_state = 6, .external_lex_state = 10},
  [394] = {.lex_state = 0},
  [395] = {.lex_state = 6, .external_lex_state = 10},
  [396] = {.lex_state = 6, .external_lex_state = 10},
  [397] = {.lex_state = 6, .external_lex_state = 10},
  [398] = {.lex_state = 6, .external_lex_state = 10},
  [399] = {.lex_state = 6, .external_lex_state = 10},
  [400] = {.lex_state = 6, .external_lex_state = 10},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 0},
  [403] = {.lex_state = 6},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 0},
  [406] = {.lex_state = 0},
  [407] = {.lex_state = 10},
  [408] = {.lex_state = 10},
  [409] = {.lex_state = 10},
  [410] = {.lex_state = 10},
  [411] = {.lex_state = 8},
  [412] = {.lex_state = 10},
  [413] = {.lex_state = 10},
  [414] = {.lex_state = 10},
  [415] = {.lex_state = 10},
  [416] = {.lex_state = 0},
  [417] = {.lex_state = 10},
  [418] = {.lex_state = 10},
  [419] = {.lex_state = 10},
  [420] = {.lex_state = 10},
  [421] = {.lex_state = 10},
  [422] = {.lex_state = 0},
  [423] = {.lex_state = 0},
  [424] = {.lex_state = 0},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 0},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 5},
  [429] = {.lex_state = 8},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 0},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 0},
  [436] = {.lex_state = 0},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0, .external_lex_state = 11},
  [439] = {.lex_state = 0, .external_lex_state = 11},
  [440] = {.lex_state = 0, .external_lex_state = 11},
  [441] = {.lex_state = 0, .external_lex_state = 11},
  [442] = {.lex_state = 0},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 66},
  [445] = {.lex_state = 0, .external_lex_state = 12},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 9},
  [448] = {.lex_state = 0, .external_lex_state = 11},
  [449] = {.lex_state = 66},
  [450] = {.lex_state = 0, .external_lex_state = 11},
  [451] = {.lex_state = 0, .external_lex_state = 11},
  [452] = {.lex_state = 0, .external_lex_state = 11},
  [453] = {.lex_state = 0, .external_lex_state = 11},
  [454] = {.lex_state = 0, .external_lex_state = 11},
  [455] = {.lex_state = 0, .external_lex_state = 11},
  [456] = {.lex_state = 0, .external_lex_state = 11},
  [457] = {.lex_state = 0},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 0},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 0},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 0},
  [465] = {.lex_state = 0},
  [466] = {.lex_state = 0},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 0},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 0},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 0},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 0},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0, .external_lex_state = 10},
  [479] = {.lex_state = 0, .external_lex_state = 13},
  [480] = {.lex_state = 0},
  [481] = {.lex_state = 0},
  [482] = {.lex_state = 11},
  [483] = {.lex_state = 0},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 0},
  [486] = {.lex_state = 0},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 0, .external_lex_state = 12},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 0, .external_lex_state = 10},
  [493] = {.lex_state = 0},
  [494] = {.lex_state = 0, .external_lex_state = 13},
  [495] = {.lex_state = 0},
  [496] = {.lex_state = 0},
  [497] = {.lex_state = 7},
  [498] = {.lex_state = 0},
  [499] = {.lex_state = 0, .external_lex_state = 10},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0, .external_lex_state = 13},
};

enum {
  ts_external_token__cmd_identifier = 0,
  ts_external_token__help_stmt = 1,
  ts_external_token_file_descriptor = 2,
  ts_external_token__eq_sep_concat = 3,
  ts_external_token__concat = 4,
  ts_external_token__concat_pf_dot = 5,
  ts_external_token__spec_sep = 6,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__cmd_identifier] = sym__cmd_identifier,
  [ts_external_token__help_stmt] = sym__help_stmt,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__eq_sep_concat] = sym__eq_sep_concat,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token__concat_pf_dot] = sym__concat_pf_dot,
  [ts_external_token__spec_sep] = sym__spec_sep,
};

static const bool ts_external_scanner_states[14][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__concat_pf_dot] = true,
    [ts_external_token__spec_sep] = true,
  },
  [2] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
  },
  [3] = {
    [ts_external_token__cmd_identifier] = true,
    [ts_external_token__help_stmt] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [4] = {
    [ts_external_token_file_descriptor] = true,
  },
  [5] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat_pf_dot] = true,
  },
  [6] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__spec_sep] = true,
  },
  [7] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__eq_sep_concat] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
  },
  [11] = {
    [ts_external_token__eq_sep_concat] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token__eq_sep_concat] = true,
  },
  [13] = {
    [ts_external_token__concat_pf_dot] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_PIPEH] = ACTIONS(1),
    [anon_sym_AT_AT_DOT] = ACTIONS(1),
    [anon_sym_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(1),
    [anon_sym_AT_AT] = ACTIONS(1),
    [anon_sym_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(1),
    [anon_sym_AT_ATC] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_AT_ATdbt] = ACTIONS(1),
    [anon_sym_AT_ATdbta] = ACTIONS(1),
    [anon_sym_AT_ATdbtb] = ACTIONS(1),
    [anon_sym_AT_ATdbts] = ACTIONS(1),
    [anon_sym_AT_ATt] = ACTIONS(1),
    [anon_sym_AT_ATb] = ACTIONS(1),
    [anon_sym_AT_ATi] = ACTIONS(1),
    [anon_sym_AT_ATii] = ACTIONS(1),
    [anon_sym_AT_ATiS] = ACTIONS(1),
    [anon_sym_AT_ATiSS] = ACTIONS(1),
    [anon_sym_AT_ATis] = ACTIONS(1),
    [anon_sym_AT_ATiz] = ACTIONS(1),
    [anon_sym_AT_ATf] = ACTIONS(1),
    [anon_sym_AT_ATF] = ACTIONS(1),
    [anon_sym_AT_ATom] = ACTIONS(1),
    [anon_sym_AT_ATdm] = ACTIONS(1),
    [anon_sym_AT_ATr] = ACTIONS(1),
    [anon_sym_AT_ATs_COLON] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_AT_BANG] = ACTIONS(1),
    [anon_sym_AT_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_ATa_COLON] = ACTIONS(1),
    [anon_sym_ATb_COLON] = ACTIONS(1),
    [anon_sym_ATB_COLON] = ACTIONS(1),
    [anon_sym_ATe_COLON] = ACTIONS(1),
    [anon_sym_ATF_COLON] = ACTIONS(1),
    [anon_sym_ATi_COLON] = ACTIONS(1),
    [anon_sym_ATk_COLON] = ACTIONS(1),
    [anon_sym_ATo_COLON] = ACTIONS(1),
    [anon_sym_ATr_COLON] = ACTIONS(1),
    [anon_sym_ATf_COLON] = ACTIONS(1),
    [anon_sym_ATs_COLON] = ACTIONS(1),
    [anon_sym_ATv_COLON] = ACTIONS(1),
    [anon_sym_ATx_COLON] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(1),
    [anon_sym_LPAREN_STAR] = ACTIONS(1),
    [anon_sym_LPAREN_DASH] = ACTIONS(1),
    [aux_sym__search_stmt_token1] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_PIPE_DOT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [sym_question_mark_identifier] = ACTIONS(1),
    [sym_pointer_identifier] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [sym_html_redirect_operator] = ACTIONS(1),
    [sym_html_append_operator] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [aux_sym_tmp_eval_arg_token1] = ACTIONS(1),
    [aux_sym_double_quoted_arg_token3] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1),
    [anon_sym_CR] = ACTIONS(1),
    [sym__cmd_identifier] = ACTIONS(1),
    [sym__help_stmt] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__eq_sep_concat] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym__concat_pf_dot] = ACTIONS(1),
    [sym__spec_sep] = ACTIONS(1),
  },
  [1] = {
    [sym_statements] = STATE(488),
    [sym__statement] = STATE(402),
    [sym_legacy_quoted_stmt] = STATE(169),
    [sym__simple_stmt] = STATE(169),
    [sym__tmp_stmt] = STATE(169),
    [sym__iter_stmt] = STATE(169),
    [sym__pipe_stmt] = STATE(169),
    [sym_grep_stmt] = STATE(169),
    [sym_html_disable_stmt] = STATE(169),
    [sym_html_enable_stmt] = STATE(169),
    [sym_pipe_stmt] = STATE(169),
    [sym_iter_file_lines_stmt] = STATE(169),
    [sym_iter_offsets_stmt] = STATE(169),
    [sym_iter_offsetssizes_stmt] = STATE(169),
    [sym_iter_hit_stmt] = STATE(169),
    [sym_iter_interpret_stmt] = STATE(169),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(169),
    [sym_iter_comment_stmt] = STATE(169),
    [sym_iter_dbta_stmt] = STATE(169),
    [sym_iter_dbtb_stmt] = STATE(169),
    [sym_iter_dbts_stmt] = STATE(169),
    [sym_iter_threads_stmt] = STATE(169),
    [sym_iter_bbs_stmt] = STATE(169),
    [sym_iter_instrs_stmt] = STATE(169),
    [sym_iter_import_stmt] = STATE(169),
    [sym_iter_sections_stmt] = STATE(169),
    [sym_iter_segments_stmt] = STATE(169),
    [sym_iter_symbol_stmt] = STATE(169),
    [sym_iter_string_stmt] = STATE(169),
    [sym_iter_flags_stmt] = STATE(169),
    [sym_iter_function_stmt] = STATE(169),
    [sym_iter_iomap_stmt] = STATE(169),
    [sym_iter_dbgmap_stmt] = STATE(169),
    [sym_iter_register_stmt] = STATE(169),
    [sym_iter_step_stmt] = STATE(169),
    [sym_tmp_seek_stmt] = STATE(169),
    [sym_tmp_blksz_stmt] = STATE(169),
    [sym_tmp_fromto_stmt] = STATE(169),
    [sym_tmp_arch_stmt] = STATE(169),
    [sym_tmp_bits_stmt] = STATE(169),
    [sym_tmp_nthi_stmt] = STATE(169),
    [sym_tmp_eval_stmt] = STATE(169),
    [sym_tmp_fs_stmt] = STATE(169),
    [sym_tmp_reli_stmt] = STATE(169),
    [sym_tmp_kuery_stmt] = STATE(169),
    [sym_tmp_fd_stmt] = STATE(169),
    [sym_tmp_reg_stmt] = STATE(169),
    [sym_tmp_file_stmt] = STATE(169),
    [sym_tmp_string_stmt] = STATE(169),
    [sym_tmp_value_stmt] = STATE(169),
    [sym_tmp_hex_stmt] = STATE(169),
    [sym_help_stmt] = STATE(169),
    [sym_macro_stmt] = STATE(169),
    [sym_arged_stmt] = STATE(169),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(169),
    [sym_Cf_cmd] = STATE(169),
    [sym_pf_new_cmd] = STATE(169),
    [sym_pf_dot_cmd] = STATE(169),
    [sym_pf_cmd] = STATE(169),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(169),
    [sym_redirect_stmt] = STATE(402),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym_statements_repeat1] = STATE(4),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(9),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(9),
    [anon_sym_CR] = ACTIONS(9),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [2] = {
    [sym_legacy_quoted_stmt] = STATE(217),
    [sym__simple_stmt] = STATE(217),
    [sym__tmp_stmt] = STATE(217),
    [sym__iter_stmt] = STATE(217),
    [sym__pipe_stmt] = STATE(217),
    [sym_grep_stmt] = STATE(217),
    [sym_html_disable_stmt] = STATE(217),
    [sym_html_enable_stmt] = STATE(217),
    [sym_pipe_stmt] = STATE(217),
    [sym_iter_file_lines_stmt] = STATE(217),
    [sym_iter_offsets_stmt] = STATE(217),
    [sym_iter_offsetssizes_stmt] = STATE(217),
    [sym_iter_hit_stmt] = STATE(217),
    [sym_iter_interpret_stmt] = STATE(217),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(217),
    [sym_iter_comment_stmt] = STATE(217),
    [sym_iter_dbta_stmt] = STATE(217),
    [sym_iter_dbtb_stmt] = STATE(217),
    [sym_iter_dbts_stmt] = STATE(217),
    [sym_iter_threads_stmt] = STATE(217),
    [sym_iter_bbs_stmt] = STATE(217),
    [sym_iter_instrs_stmt] = STATE(217),
    [sym_iter_import_stmt] = STATE(217),
    [sym_iter_sections_stmt] = STATE(217),
    [sym_iter_segments_stmt] = STATE(217),
    [sym_iter_symbol_stmt] = STATE(217),
    [sym_iter_string_stmt] = STATE(217),
    [sym_iter_flags_stmt] = STATE(217),
    [sym_iter_function_stmt] = STATE(217),
    [sym_iter_iomap_stmt] = STATE(217),
    [sym_iter_dbgmap_stmt] = STATE(217),
    [sym_iter_register_stmt] = STATE(217),
    [sym_iter_step_stmt] = STATE(217),
    [sym_tmp_seek_stmt] = STATE(217),
    [sym_tmp_blksz_stmt] = STATE(217),
    [sym_tmp_fromto_stmt] = STATE(217),
    [sym_tmp_arch_stmt] = STATE(217),
    [sym_tmp_bits_stmt] = STATE(217),
    [sym_tmp_nthi_stmt] = STATE(217),
    [sym_tmp_eval_stmt] = STATE(217),
    [sym_tmp_fs_stmt] = STATE(217),
    [sym_tmp_reli_stmt] = STATE(217),
    [sym_tmp_kuery_stmt] = STATE(217),
    [sym_tmp_fd_stmt] = STATE(217),
    [sym_tmp_reg_stmt] = STATE(217),
    [sym_tmp_file_stmt] = STATE(217),
    [sym_tmp_string_stmt] = STATE(217),
    [sym_tmp_value_stmt] = STATE(217),
    [sym_tmp_hex_stmt] = STATE(217),
    [sym_help_stmt] = STATE(217),
    [sym_macro_stmt] = STATE(217),
    [sym_arged_stmt] = STATE(217),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(217),
    [sym_Cf_cmd] = STATE(217),
    [sym_pf_new_cmd] = STATE(217),
    [sym_pf_dot_cmd] = STATE(217),
    [sym_pf_cmd] = STATE(217),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(217),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [ts_builtin_sym_end] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_PIPEH] = ACTIONS(55),
    [anon_sym_AT_AT_DOT] = ACTIONS(55),
    [anon_sym_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT] = ACTIONS(57),
    [anon_sym_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_ATC] = ACTIONS(55),
    [anon_sym_AT_ATdbt] = ACTIONS(57),
    [anon_sym_AT_ATdbta] = ACTIONS(55),
    [anon_sym_AT_ATdbtb] = ACTIONS(55),
    [anon_sym_AT_ATdbts] = ACTIONS(55),
    [anon_sym_AT_ATt] = ACTIONS(55),
    [anon_sym_AT_ATb] = ACTIONS(55),
    [anon_sym_AT_ATi] = ACTIONS(57),
    [anon_sym_AT_ATii] = ACTIONS(55),
    [anon_sym_AT_ATiS] = ACTIONS(57),
    [anon_sym_AT_ATiSS] = ACTIONS(55),
    [anon_sym_AT_ATis] = ACTIONS(55),
    [anon_sym_AT_ATiz] = ACTIONS(55),
    [anon_sym_AT_ATf] = ACTIONS(55),
    [anon_sym_AT_ATF] = ACTIONS(55),
    [anon_sym_AT_ATom] = ACTIONS(55),
    [anon_sym_AT_ATdm] = ACTIONS(55),
    [anon_sym_AT_ATr] = ACTIONS(55),
    [anon_sym_AT_ATs_COLON] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_AT_BANG] = ACTIONS(55),
    [anon_sym_AT_LPAREN] = ACTIONS(55),
    [anon_sym_RPAREN] = ACTIONS(55),
    [anon_sym_ATa_COLON] = ACTIONS(55),
    [anon_sym_ATb_COLON] = ACTIONS(55),
    [anon_sym_ATB_COLON] = ACTIONS(55),
    [anon_sym_ATe_COLON] = ACTIONS(55),
    [anon_sym_ATF_COLON] = ACTIONS(55),
    [anon_sym_ATi_COLON] = ACTIONS(55),
    [anon_sym_ATk_COLON] = ACTIONS(55),
    [anon_sym_ATo_COLON] = ACTIONS(55),
    [anon_sym_ATr_COLON] = ACTIONS(55),
    [anon_sym_ATf_COLON] = ACTIONS(55),
    [anon_sym_ATs_COLON] = ACTIONS(55),
    [anon_sym_ATv_COLON] = ACTIONS(55),
    [anon_sym_ATx_COLON] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(55),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_PIPE_DOT] = ACTIONS(55),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(55),
    [sym_html_redirect_operator] = ACTIONS(57),
    [sym_html_append_operator] = ACTIONS(55),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(55),
    [anon_sym_CR] = ACTIONS(55),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
    [sym_file_descriptor] = ACTIONS(55),
  },
  [3] = {
    [sym_legacy_quoted_stmt] = STATE(217),
    [sym__simple_stmt] = STATE(217),
    [sym__tmp_stmt] = STATE(217),
    [sym__iter_stmt] = STATE(217),
    [sym__pipe_stmt] = STATE(217),
    [sym_grep_stmt] = STATE(217),
    [sym_html_disable_stmt] = STATE(217),
    [sym_html_enable_stmt] = STATE(217),
    [sym_pipe_stmt] = STATE(217),
    [sym_iter_file_lines_stmt] = STATE(217),
    [sym_iter_offsets_stmt] = STATE(217),
    [sym_iter_offsetssizes_stmt] = STATE(217),
    [sym_iter_hit_stmt] = STATE(217),
    [sym_iter_interpret_stmt] = STATE(217),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(217),
    [sym_iter_comment_stmt] = STATE(217),
    [sym_iter_dbta_stmt] = STATE(217),
    [sym_iter_dbtb_stmt] = STATE(217),
    [sym_iter_dbts_stmt] = STATE(217),
    [sym_iter_threads_stmt] = STATE(217),
    [sym_iter_bbs_stmt] = STATE(217),
    [sym_iter_instrs_stmt] = STATE(217),
    [sym_iter_import_stmt] = STATE(217),
    [sym_iter_sections_stmt] = STATE(217),
    [sym_iter_segments_stmt] = STATE(217),
    [sym_iter_symbol_stmt] = STATE(217),
    [sym_iter_string_stmt] = STATE(217),
    [sym_iter_flags_stmt] = STATE(217),
    [sym_iter_function_stmt] = STATE(217),
    [sym_iter_iomap_stmt] = STATE(217),
    [sym_iter_dbgmap_stmt] = STATE(217),
    [sym_iter_register_stmt] = STATE(217),
    [sym_iter_step_stmt] = STATE(217),
    [sym_tmp_seek_stmt] = STATE(217),
    [sym_tmp_blksz_stmt] = STATE(217),
    [sym_tmp_fromto_stmt] = STATE(217),
    [sym_tmp_arch_stmt] = STATE(217),
    [sym_tmp_bits_stmt] = STATE(217),
    [sym_tmp_nthi_stmt] = STATE(217),
    [sym_tmp_eval_stmt] = STATE(217),
    [sym_tmp_fs_stmt] = STATE(217),
    [sym_tmp_reli_stmt] = STATE(217),
    [sym_tmp_kuery_stmt] = STATE(217),
    [sym_tmp_fd_stmt] = STATE(217),
    [sym_tmp_reg_stmt] = STATE(217),
    [sym_tmp_file_stmt] = STATE(217),
    [sym_tmp_string_stmt] = STATE(217),
    [sym_tmp_value_stmt] = STATE(217),
    [sym_tmp_hex_stmt] = STATE(217),
    [sym_help_stmt] = STATE(217),
    [sym_macro_stmt] = STATE(217),
    [sym_arged_stmt] = STATE(217),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(217),
    [sym_Cf_cmd] = STATE(217),
    [sym_pf_new_cmd] = STATE(217),
    [sym_pf_dot_cmd] = STATE(217),
    [sym_pf_cmd] = STATE(217),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(217),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_TILDE] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(57),
    [anon_sym_PIPEH] = ACTIONS(55),
    [anon_sym_AT_AT_DOT] = ACTIONS(55),
    [anon_sym_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(55),
    [anon_sym_AT_AT] = ACTIONS(57),
    [anon_sym_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(55),
    [anon_sym_AT_ATC] = ACTIONS(55),
    [anon_sym_AT_ATdbt] = ACTIONS(57),
    [anon_sym_AT_ATdbta] = ACTIONS(55),
    [anon_sym_AT_ATdbtb] = ACTIONS(55),
    [anon_sym_AT_ATdbts] = ACTIONS(55),
    [anon_sym_AT_ATt] = ACTIONS(55),
    [anon_sym_AT_ATb] = ACTIONS(55),
    [anon_sym_AT_ATi] = ACTIONS(57),
    [anon_sym_AT_ATii] = ACTIONS(55),
    [anon_sym_AT_ATiS] = ACTIONS(57),
    [anon_sym_AT_ATiSS] = ACTIONS(55),
    [anon_sym_AT_ATis] = ACTIONS(55),
    [anon_sym_AT_ATiz] = ACTIONS(55),
    [anon_sym_AT_ATf] = ACTIONS(55),
    [anon_sym_AT_ATF] = ACTIONS(55),
    [anon_sym_AT_ATom] = ACTIONS(55),
    [anon_sym_AT_ATdm] = ACTIONS(55),
    [anon_sym_AT_ATr] = ACTIONS(55),
    [anon_sym_AT_ATs_COLON] = ACTIONS(55),
    [anon_sym_AT] = ACTIONS(55),
    [anon_sym_AT_BANG] = ACTIONS(55),
    [anon_sym_AT_LPAREN] = ACTIONS(55),
    [anon_sym_ATa_COLON] = ACTIONS(55),
    [anon_sym_ATb_COLON] = ACTIONS(55),
    [anon_sym_ATB_COLON] = ACTIONS(55),
    [anon_sym_ATe_COLON] = ACTIONS(55),
    [anon_sym_ATF_COLON] = ACTIONS(55),
    [anon_sym_ATi_COLON] = ACTIONS(55),
    [anon_sym_ATk_COLON] = ACTIONS(55),
    [anon_sym_ATo_COLON] = ACTIONS(55),
    [anon_sym_ATr_COLON] = ACTIONS(55),
    [anon_sym_ATf_COLON] = ACTIONS(55),
    [anon_sym_ATs_COLON] = ACTIONS(55),
    [anon_sym_ATv_COLON] = ACTIONS(55),
    [anon_sym_ATx_COLON] = ACTIONS(55),
    [anon_sym_SEMI] = ACTIONS(55),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_PIPE_DOT] = ACTIONS(55),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(57),
    [anon_sym_GT_GT] = ACTIONS(55),
    [sym_html_redirect_operator] = ACTIONS(57),
    [sym_html_append_operator] = ACTIONS(55),
    [anon_sym_BQUOTE] = ACTIONS(55),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
    [sym_file_descriptor] = ACTIONS(55),
  },
  [4] = {
    [sym__statement] = STATE(401),
    [sym_legacy_quoted_stmt] = STATE(169),
    [sym__simple_stmt] = STATE(169),
    [sym__tmp_stmt] = STATE(169),
    [sym__iter_stmt] = STATE(169),
    [sym__pipe_stmt] = STATE(169),
    [sym_grep_stmt] = STATE(169),
    [sym_html_disable_stmt] = STATE(169),
    [sym_html_enable_stmt] = STATE(169),
    [sym_pipe_stmt] = STATE(169),
    [sym_iter_file_lines_stmt] = STATE(169),
    [sym_iter_offsets_stmt] = STATE(169),
    [sym_iter_offsetssizes_stmt] = STATE(169),
    [sym_iter_hit_stmt] = STATE(169),
    [sym_iter_interpret_stmt] = STATE(169),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(169),
    [sym_iter_comment_stmt] = STATE(169),
    [sym_iter_dbta_stmt] = STATE(169),
    [sym_iter_dbtb_stmt] = STATE(169),
    [sym_iter_dbts_stmt] = STATE(169),
    [sym_iter_threads_stmt] = STATE(169),
    [sym_iter_bbs_stmt] = STATE(169),
    [sym_iter_instrs_stmt] = STATE(169),
    [sym_iter_import_stmt] = STATE(169),
    [sym_iter_sections_stmt] = STATE(169),
    [sym_iter_segments_stmt] = STATE(169),
    [sym_iter_symbol_stmt] = STATE(169),
    [sym_iter_string_stmt] = STATE(169),
    [sym_iter_flags_stmt] = STATE(169),
    [sym_iter_function_stmt] = STATE(169),
    [sym_iter_iomap_stmt] = STATE(169),
    [sym_iter_dbgmap_stmt] = STATE(169),
    [sym_iter_register_stmt] = STATE(169),
    [sym_iter_step_stmt] = STATE(169),
    [sym_tmp_seek_stmt] = STATE(169),
    [sym_tmp_blksz_stmt] = STATE(169),
    [sym_tmp_fromto_stmt] = STATE(169),
    [sym_tmp_arch_stmt] = STATE(169),
    [sym_tmp_bits_stmt] = STATE(169),
    [sym_tmp_nthi_stmt] = STATE(169),
    [sym_tmp_eval_stmt] = STATE(169),
    [sym_tmp_fs_stmt] = STATE(169),
    [sym_tmp_reli_stmt] = STATE(169),
    [sym_tmp_kuery_stmt] = STATE(169),
    [sym_tmp_fd_stmt] = STATE(169),
    [sym_tmp_reg_stmt] = STATE(169),
    [sym_tmp_file_stmt] = STATE(169),
    [sym_tmp_string_stmt] = STATE(169),
    [sym_tmp_value_stmt] = STATE(169),
    [sym_tmp_hex_stmt] = STATE(169),
    [sym_help_stmt] = STATE(169),
    [sym_macro_stmt] = STATE(169),
    [sym_arged_stmt] = STATE(169),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(169),
    [sym_Cf_cmd] = STATE(169),
    [sym_pf_new_cmd] = STATE(169),
    [sym_pf_dot_cmd] = STATE(169),
    [sym_pf_cmd] = STATE(169),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(169),
    [sym_redirect_stmt] = STATE(401),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym_statements_repeat1] = STATE(269),
    [ts_builtin_sym_end] = ACTIONS(83),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(85),
    [anon_sym_CR] = ACTIONS(85),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [5] = {
    [sym__statement] = STATE(416),
    [sym_legacy_quoted_stmt] = STATE(169),
    [sym__simple_stmt] = STATE(169),
    [sym__tmp_stmt] = STATE(169),
    [sym__iter_stmt] = STATE(169),
    [sym__pipe_stmt] = STATE(169),
    [sym_grep_stmt] = STATE(169),
    [sym_html_disable_stmt] = STATE(169),
    [sym_html_enable_stmt] = STATE(169),
    [sym_pipe_stmt] = STATE(169),
    [sym_iter_file_lines_stmt] = STATE(169),
    [sym_iter_offsets_stmt] = STATE(169),
    [sym_iter_offsetssizes_stmt] = STATE(169),
    [sym_iter_hit_stmt] = STATE(169),
    [sym_iter_interpret_stmt] = STATE(169),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(169),
    [sym_iter_comment_stmt] = STATE(169),
    [sym_iter_dbta_stmt] = STATE(169),
    [sym_iter_dbtb_stmt] = STATE(169),
    [sym_iter_dbts_stmt] = STATE(169),
    [sym_iter_threads_stmt] = STATE(169),
    [sym_iter_bbs_stmt] = STATE(169),
    [sym_iter_instrs_stmt] = STATE(169),
    [sym_iter_import_stmt] = STATE(169),
    [sym_iter_sections_stmt] = STATE(169),
    [sym_iter_segments_stmt] = STATE(169),
    [sym_iter_symbol_stmt] = STATE(169),
    [sym_iter_string_stmt] = STATE(169),
    [sym_iter_flags_stmt] = STATE(169),
    [sym_iter_function_stmt] = STATE(169),
    [sym_iter_iomap_stmt] = STATE(169),
    [sym_iter_dbgmap_stmt] = STATE(169),
    [sym_iter_register_stmt] = STATE(169),
    [sym_iter_step_stmt] = STATE(169),
    [sym_tmp_seek_stmt] = STATE(169),
    [sym_tmp_blksz_stmt] = STATE(169),
    [sym_tmp_fromto_stmt] = STATE(169),
    [sym_tmp_arch_stmt] = STATE(169),
    [sym_tmp_bits_stmt] = STATE(169),
    [sym_tmp_nthi_stmt] = STATE(169),
    [sym_tmp_eval_stmt] = STATE(169),
    [sym_tmp_fs_stmt] = STATE(169),
    [sym_tmp_reli_stmt] = STATE(169),
    [sym_tmp_kuery_stmt] = STATE(169),
    [sym_tmp_fd_stmt] = STATE(169),
    [sym_tmp_reg_stmt] = STATE(169),
    [sym_tmp_file_stmt] = STATE(169),
    [sym_tmp_string_stmt] = STATE(169),
    [sym_tmp_value_stmt] = STATE(169),
    [sym_tmp_hex_stmt] = STATE(169),
    [sym_help_stmt] = STATE(169),
    [sym_macro_stmt] = STATE(169),
    [sym_arged_stmt] = STATE(169),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(169),
    [sym_Cf_cmd] = STATE(169),
    [sym_pf_new_cmd] = STATE(169),
    [sym_pf_dot_cmd] = STATE(169),
    [sym_pf_cmd] = STATE(169),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(169),
    [sym_redirect_stmt] = STATE(416),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(87),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(87),
    [anon_sym_CR] = ACTIONS(87),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [6] = {
    [sym__statements_singleline] = STATE(500),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [7] = {
    [sym__statements_singleline] = STATE(483),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [8] = {
    [sym__statements_singleline] = STATE(468),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [9] = {
    [sym__statements_singleline] = STATE(467),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [10] = {
    [sym__statements_singleline] = STATE(471),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [11] = {
    [sym__statements_singleline] = STATE(466),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [12] = {
    [sym__statements_singleline] = STATE(465),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [13] = {
    [sym__statements_singleline] = STATE(464),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [14] = {
    [sym__statements_singleline] = STATE(469),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [15] = {
    [sym__statements_singleline] = STATE(463),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [16] = {
    [sym__statements_singleline] = STATE(462),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [17] = {
    [sym__statements_singleline] = STATE(461),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [18] = {
    [sym__statements_singleline] = STATE(475),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [19] = {
    [sym__statements_singleline] = STATE(460),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [20] = {
    [sym__statements_singleline] = STATE(481),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [21] = {
    [sym__statements_singleline] = STATE(459),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [22] = {
    [sym__statements_singleline] = STATE(480),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [23] = {
    [sym__statements_singleline] = STATE(470),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [24] = {
    [sym__statements_singleline] = STATE(484),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [25] = {
    [sym__statements_singleline] = STATE(498),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [26] = {
    [sym__statements_singleline] = STATE(473),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [27] = {
    [sym__statements_singleline] = STATE(476),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [28] = {
    [sym__statements_singleline] = STATE(474),
    [sym__statement] = STATE(434),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(434),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(32),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(89),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [29] = {
    [sym__statements_singleline] = STATE(495),
    [sym__statement] = STATE(424),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(424),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(33),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [30] = {
    [sym__statement] = STATE(423),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(423),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [anon_sym_BQUOTE] = ACTIONS(93),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [31] = {
    [sym__statement] = STATE(423),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(423),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_RPAREN] = ACTIONS(93),
    [anon_sym_SEMI] = ACTIONS(93),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [32] = {
    [sym__statement] = STATE(432),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(432),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [aux_sym__statements_singleline_repeat1] = STATE(270),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [33] = {
    [sym__statement] = STATE(422),
    [sym_legacy_quoted_stmt] = STATE(261),
    [sym__simple_stmt] = STATE(261),
    [sym__tmp_stmt] = STATE(261),
    [sym__iter_stmt] = STATE(261),
    [sym__pipe_stmt] = STATE(261),
    [sym_grep_stmt] = STATE(261),
    [sym_html_disable_stmt] = STATE(261),
    [sym_html_enable_stmt] = STATE(261),
    [sym_pipe_stmt] = STATE(261),
    [sym_iter_file_lines_stmt] = STATE(261),
    [sym_iter_offsets_stmt] = STATE(261),
    [sym_iter_offsetssizes_stmt] = STATE(261),
    [sym_iter_hit_stmt] = STATE(261),
    [sym_iter_interpret_stmt] = STATE(261),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(261),
    [sym_iter_comment_stmt] = STATE(261),
    [sym_iter_dbta_stmt] = STATE(261),
    [sym_iter_dbtb_stmt] = STATE(261),
    [sym_iter_dbts_stmt] = STATE(261),
    [sym_iter_threads_stmt] = STATE(261),
    [sym_iter_bbs_stmt] = STATE(261),
    [sym_iter_instrs_stmt] = STATE(261),
    [sym_iter_import_stmt] = STATE(261),
    [sym_iter_sections_stmt] = STATE(261),
    [sym_iter_segments_stmt] = STATE(261),
    [sym_iter_symbol_stmt] = STATE(261),
    [sym_iter_string_stmt] = STATE(261),
    [sym_iter_flags_stmt] = STATE(261),
    [sym_iter_function_stmt] = STATE(261),
    [sym_iter_iomap_stmt] = STATE(261),
    [sym_iter_dbgmap_stmt] = STATE(261),
    [sym_iter_register_stmt] = STATE(261),
    [sym_iter_step_stmt] = STATE(261),
    [sym_tmp_seek_stmt] = STATE(261),
    [sym_tmp_blksz_stmt] = STATE(261),
    [sym_tmp_fromto_stmt] = STATE(261),
    [sym_tmp_arch_stmt] = STATE(261),
    [sym_tmp_bits_stmt] = STATE(261),
    [sym_tmp_nthi_stmt] = STATE(261),
    [sym_tmp_eval_stmt] = STATE(261),
    [sym_tmp_fs_stmt] = STATE(261),
    [sym_tmp_reli_stmt] = STATE(261),
    [sym_tmp_kuery_stmt] = STATE(261),
    [sym_tmp_fd_stmt] = STATE(261),
    [sym_tmp_reg_stmt] = STATE(261),
    [sym_tmp_file_stmt] = STATE(261),
    [sym_tmp_string_stmt] = STATE(261),
    [sym_tmp_value_stmt] = STATE(261),
    [sym_tmp_hex_stmt] = STATE(261),
    [sym_help_stmt] = STATE(261),
    [sym_macro_stmt] = STATE(261),
    [sym_arged_stmt] = STATE(261),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(261),
    [sym_Cf_cmd] = STATE(261),
    [sym_pf_new_cmd] = STATE(261),
    [sym_pf_dot_cmd] = STATE(261),
    [sym_pf_cmd] = STATE(261),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(261),
    [sym_redirect_stmt] = STATE(422),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [aux_sym__statements_singleline_repeat1] = STATE(270),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [34] = {
    [sym__statement] = STATE(425),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(425),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [35] = {
    [sym__statement] = STATE(443),
    [sym_legacy_quoted_stmt] = STATE(260),
    [sym__simple_stmt] = STATE(260),
    [sym__tmp_stmt] = STATE(260),
    [sym__iter_stmt] = STATE(260),
    [sym__pipe_stmt] = STATE(260),
    [sym_grep_stmt] = STATE(260),
    [sym_html_disable_stmt] = STATE(260),
    [sym_html_enable_stmt] = STATE(260),
    [sym_pipe_stmt] = STATE(260),
    [sym_iter_file_lines_stmt] = STATE(260),
    [sym_iter_offsets_stmt] = STATE(260),
    [sym_iter_offsetssizes_stmt] = STATE(260),
    [sym_iter_hit_stmt] = STATE(260),
    [sym_iter_interpret_stmt] = STATE(260),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(260),
    [sym_iter_comment_stmt] = STATE(260),
    [sym_iter_dbta_stmt] = STATE(260),
    [sym_iter_dbtb_stmt] = STATE(260),
    [sym_iter_dbts_stmt] = STATE(260),
    [sym_iter_threads_stmt] = STATE(260),
    [sym_iter_bbs_stmt] = STATE(260),
    [sym_iter_instrs_stmt] = STATE(260),
    [sym_iter_import_stmt] = STATE(260),
    [sym_iter_sections_stmt] = STATE(260),
    [sym_iter_segments_stmt] = STATE(260),
    [sym_iter_symbol_stmt] = STATE(260),
    [sym_iter_string_stmt] = STATE(260),
    [sym_iter_flags_stmt] = STATE(260),
    [sym_iter_function_stmt] = STATE(260),
    [sym_iter_iomap_stmt] = STATE(260),
    [sym_iter_dbgmap_stmt] = STATE(260),
    [sym_iter_register_stmt] = STATE(260),
    [sym_iter_step_stmt] = STATE(260),
    [sym_tmp_seek_stmt] = STATE(260),
    [sym_tmp_blksz_stmt] = STATE(260),
    [sym_tmp_fromto_stmt] = STATE(260),
    [sym_tmp_arch_stmt] = STATE(260),
    [sym_tmp_bits_stmt] = STATE(260),
    [sym_tmp_nthi_stmt] = STATE(260),
    [sym_tmp_eval_stmt] = STATE(260),
    [sym_tmp_fs_stmt] = STATE(260),
    [sym_tmp_reli_stmt] = STATE(260),
    [sym_tmp_kuery_stmt] = STATE(260),
    [sym_tmp_fd_stmt] = STATE(260),
    [sym_tmp_reg_stmt] = STATE(260),
    [sym_tmp_file_stmt] = STATE(260),
    [sym_tmp_string_stmt] = STATE(260),
    [sym_tmp_value_stmt] = STATE(260),
    [sym_tmp_hex_stmt] = STATE(260),
    [sym_help_stmt] = STATE(260),
    [sym_macro_stmt] = STATE(260),
    [sym_arged_stmt] = STATE(260),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(260),
    [sym_Cf_cmd] = STATE(260),
    [sym_pf_new_cmd] = STATE(260),
    [sym_pf_dot_cmd] = STATE(260),
    [sym_pf_cmd] = STATE(260),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(260),
    [sym_redirect_stmt] = STATE(443),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [36] = {
    [sym_legacy_quoted_stmt] = STATE(267),
    [sym__simple_stmt] = STATE(267),
    [sym__tmp_stmt] = STATE(267),
    [sym__iter_stmt] = STATE(267),
    [sym__pipe_stmt] = STATE(267),
    [sym_grep_stmt] = STATE(267),
    [sym_html_disable_stmt] = STATE(267),
    [sym_html_enable_stmt] = STATE(267),
    [sym_pipe_stmt] = STATE(267),
    [sym_iter_file_lines_stmt] = STATE(267),
    [sym_iter_offsets_stmt] = STATE(267),
    [sym_iter_offsetssizes_stmt] = STATE(267),
    [sym_iter_hit_stmt] = STATE(267),
    [sym_iter_interpret_stmt] = STATE(267),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(267),
    [sym_iter_comment_stmt] = STATE(267),
    [sym_iter_dbta_stmt] = STATE(267),
    [sym_iter_dbtb_stmt] = STATE(267),
    [sym_iter_dbts_stmt] = STATE(267),
    [sym_iter_threads_stmt] = STATE(267),
    [sym_iter_bbs_stmt] = STATE(267),
    [sym_iter_instrs_stmt] = STATE(267),
    [sym_iter_import_stmt] = STATE(267),
    [sym_iter_sections_stmt] = STATE(267),
    [sym_iter_segments_stmt] = STATE(267),
    [sym_iter_symbol_stmt] = STATE(267),
    [sym_iter_string_stmt] = STATE(267),
    [sym_iter_flags_stmt] = STATE(267),
    [sym_iter_function_stmt] = STATE(267),
    [sym_iter_iomap_stmt] = STATE(267),
    [sym_iter_dbgmap_stmt] = STATE(267),
    [sym_iter_register_stmt] = STATE(267),
    [sym_iter_step_stmt] = STATE(267),
    [sym_tmp_seek_stmt] = STATE(267),
    [sym_tmp_blksz_stmt] = STATE(267),
    [sym_tmp_fromto_stmt] = STATE(267),
    [sym_tmp_arch_stmt] = STATE(267),
    [sym_tmp_bits_stmt] = STATE(267),
    [sym_tmp_nthi_stmt] = STATE(267),
    [sym_tmp_eval_stmt] = STATE(267),
    [sym_tmp_fs_stmt] = STATE(267),
    [sym_tmp_reli_stmt] = STATE(267),
    [sym_tmp_kuery_stmt] = STATE(267),
    [sym_tmp_fd_stmt] = STATE(267),
    [sym_tmp_reg_stmt] = STATE(267),
    [sym_tmp_file_stmt] = STATE(267),
    [sym_tmp_string_stmt] = STATE(267),
    [sym_tmp_value_stmt] = STATE(267),
    [sym_tmp_hex_stmt] = STATE(267),
    [sym_help_stmt] = STATE(267),
    [sym_macro_stmt] = STATE(267),
    [sym_arged_stmt] = STATE(267),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(267),
    [sym_Cf_cmd] = STATE(267),
    [sym_pf_new_cmd] = STATE(267),
    [sym_pf_dot_cmd] = STATE(267),
    [sym_pf_cmd] = STATE(267),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(267),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [37] = {
    [sym_legacy_quoted_stmt] = STATE(262),
    [sym__simple_stmt] = STATE(262),
    [sym__tmp_stmt] = STATE(262),
    [sym__iter_stmt] = STATE(262),
    [sym__pipe_stmt] = STATE(262),
    [sym_grep_stmt] = STATE(262),
    [sym_html_disable_stmt] = STATE(262),
    [sym_html_enable_stmt] = STATE(262),
    [sym_pipe_stmt] = STATE(262),
    [sym_iter_file_lines_stmt] = STATE(262),
    [sym_iter_offsets_stmt] = STATE(262),
    [sym_iter_offsetssizes_stmt] = STATE(262),
    [sym_iter_hit_stmt] = STATE(262),
    [sym_iter_interpret_stmt] = STATE(262),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(262),
    [sym_iter_comment_stmt] = STATE(262),
    [sym_iter_dbta_stmt] = STATE(262),
    [sym_iter_dbtb_stmt] = STATE(262),
    [sym_iter_dbts_stmt] = STATE(262),
    [sym_iter_threads_stmt] = STATE(262),
    [sym_iter_bbs_stmt] = STATE(262),
    [sym_iter_instrs_stmt] = STATE(262),
    [sym_iter_import_stmt] = STATE(262),
    [sym_iter_sections_stmt] = STATE(262),
    [sym_iter_segments_stmt] = STATE(262),
    [sym_iter_symbol_stmt] = STATE(262),
    [sym_iter_string_stmt] = STATE(262),
    [sym_iter_flags_stmt] = STATE(262),
    [sym_iter_function_stmt] = STATE(262),
    [sym_iter_iomap_stmt] = STATE(262),
    [sym_iter_dbgmap_stmt] = STATE(262),
    [sym_iter_register_stmt] = STATE(262),
    [sym_iter_step_stmt] = STATE(262),
    [sym_tmp_seek_stmt] = STATE(262),
    [sym_tmp_blksz_stmt] = STATE(262),
    [sym_tmp_fromto_stmt] = STATE(262),
    [sym_tmp_arch_stmt] = STATE(262),
    [sym_tmp_bits_stmt] = STATE(262),
    [sym_tmp_nthi_stmt] = STATE(262),
    [sym_tmp_eval_stmt] = STATE(262),
    [sym_tmp_fs_stmt] = STATE(262),
    [sym_tmp_reli_stmt] = STATE(262),
    [sym_tmp_kuery_stmt] = STATE(262),
    [sym_tmp_fd_stmt] = STATE(262),
    [sym_tmp_reg_stmt] = STATE(262),
    [sym_tmp_file_stmt] = STATE(262),
    [sym_tmp_string_stmt] = STATE(262),
    [sym_tmp_value_stmt] = STATE(262),
    [sym_tmp_hex_stmt] = STATE(262),
    [sym_help_stmt] = STATE(262),
    [sym_macro_stmt] = STATE(262),
    [sym_arged_stmt] = STATE(262),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(262),
    [sym_Cf_cmd] = STATE(262),
    [sym_pf_new_cmd] = STATE(262),
    [sym_pf_dot_cmd] = STATE(262),
    [sym_pf_cmd] = STATE(262),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(262),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [38] = {
    [sym_legacy_quoted_stmt] = STATE(263),
    [sym__simple_stmt] = STATE(263),
    [sym__tmp_stmt] = STATE(263),
    [sym__iter_stmt] = STATE(263),
    [sym__pipe_stmt] = STATE(263),
    [sym_grep_stmt] = STATE(263),
    [sym_html_disable_stmt] = STATE(263),
    [sym_html_enable_stmt] = STATE(263),
    [sym_pipe_stmt] = STATE(263),
    [sym_iter_file_lines_stmt] = STATE(263),
    [sym_iter_offsets_stmt] = STATE(263),
    [sym_iter_offsetssizes_stmt] = STATE(263),
    [sym_iter_hit_stmt] = STATE(263),
    [sym_iter_interpret_stmt] = STATE(263),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(263),
    [sym_iter_comment_stmt] = STATE(263),
    [sym_iter_dbta_stmt] = STATE(263),
    [sym_iter_dbtb_stmt] = STATE(263),
    [sym_iter_dbts_stmt] = STATE(263),
    [sym_iter_threads_stmt] = STATE(263),
    [sym_iter_bbs_stmt] = STATE(263),
    [sym_iter_instrs_stmt] = STATE(263),
    [sym_iter_import_stmt] = STATE(263),
    [sym_iter_sections_stmt] = STATE(263),
    [sym_iter_segments_stmt] = STATE(263),
    [sym_iter_symbol_stmt] = STATE(263),
    [sym_iter_string_stmt] = STATE(263),
    [sym_iter_flags_stmt] = STATE(263),
    [sym_iter_function_stmt] = STATE(263),
    [sym_iter_iomap_stmt] = STATE(263),
    [sym_iter_dbgmap_stmt] = STATE(263),
    [sym_iter_register_stmt] = STATE(263),
    [sym_iter_step_stmt] = STATE(263),
    [sym_tmp_seek_stmt] = STATE(263),
    [sym_tmp_blksz_stmt] = STATE(263),
    [sym_tmp_fromto_stmt] = STATE(263),
    [sym_tmp_arch_stmt] = STATE(263),
    [sym_tmp_bits_stmt] = STATE(263),
    [sym_tmp_nthi_stmt] = STATE(263),
    [sym_tmp_eval_stmt] = STATE(263),
    [sym_tmp_fs_stmt] = STATE(263),
    [sym_tmp_reli_stmt] = STATE(263),
    [sym_tmp_kuery_stmt] = STATE(263),
    [sym_tmp_fd_stmt] = STATE(263),
    [sym_tmp_reg_stmt] = STATE(263),
    [sym_tmp_file_stmt] = STATE(263),
    [sym_tmp_string_stmt] = STATE(263),
    [sym_tmp_value_stmt] = STATE(263),
    [sym_tmp_hex_stmt] = STATE(263),
    [sym_help_stmt] = STATE(263),
    [sym_macro_stmt] = STATE(263),
    [sym_arged_stmt] = STATE(263),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(263),
    [sym_Cf_cmd] = STATE(263),
    [sym_pf_new_cmd] = STATE(263),
    [sym_pf_dot_cmd] = STATE(263),
    [sym_pf_cmd] = STATE(263),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(263),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [39] = {
    [sym_legacy_quoted_stmt] = STATE(190),
    [sym__simple_stmt] = STATE(190),
    [sym__tmp_stmt] = STATE(190),
    [sym__iter_stmt] = STATE(190),
    [sym__pipe_stmt] = STATE(190),
    [sym_grep_stmt] = STATE(190),
    [sym_html_disable_stmt] = STATE(190),
    [sym_html_enable_stmt] = STATE(190),
    [sym_pipe_stmt] = STATE(190),
    [sym_iter_file_lines_stmt] = STATE(190),
    [sym_iter_offsets_stmt] = STATE(190),
    [sym_iter_offsetssizes_stmt] = STATE(190),
    [sym_iter_hit_stmt] = STATE(190),
    [sym_iter_interpret_stmt] = STATE(190),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(190),
    [sym_iter_comment_stmt] = STATE(190),
    [sym_iter_dbta_stmt] = STATE(190),
    [sym_iter_dbtb_stmt] = STATE(190),
    [sym_iter_dbts_stmt] = STATE(190),
    [sym_iter_threads_stmt] = STATE(190),
    [sym_iter_bbs_stmt] = STATE(190),
    [sym_iter_instrs_stmt] = STATE(190),
    [sym_iter_import_stmt] = STATE(190),
    [sym_iter_sections_stmt] = STATE(190),
    [sym_iter_segments_stmt] = STATE(190),
    [sym_iter_symbol_stmt] = STATE(190),
    [sym_iter_string_stmt] = STATE(190),
    [sym_iter_flags_stmt] = STATE(190),
    [sym_iter_function_stmt] = STATE(190),
    [sym_iter_iomap_stmt] = STATE(190),
    [sym_iter_dbgmap_stmt] = STATE(190),
    [sym_iter_register_stmt] = STATE(190),
    [sym_iter_step_stmt] = STATE(190),
    [sym_tmp_seek_stmt] = STATE(190),
    [sym_tmp_blksz_stmt] = STATE(190),
    [sym_tmp_fromto_stmt] = STATE(190),
    [sym_tmp_arch_stmt] = STATE(190),
    [sym_tmp_bits_stmt] = STATE(190),
    [sym_tmp_nthi_stmt] = STATE(190),
    [sym_tmp_eval_stmt] = STATE(190),
    [sym_tmp_fs_stmt] = STATE(190),
    [sym_tmp_reli_stmt] = STATE(190),
    [sym_tmp_kuery_stmt] = STATE(190),
    [sym_tmp_fd_stmt] = STATE(190),
    [sym_tmp_reg_stmt] = STATE(190),
    [sym_tmp_file_stmt] = STATE(190),
    [sym_tmp_string_stmt] = STATE(190),
    [sym_tmp_value_stmt] = STATE(190),
    [sym_tmp_hex_stmt] = STATE(190),
    [sym_help_stmt] = STATE(190),
    [sym_macro_stmt] = STATE(190),
    [sym_arged_stmt] = STATE(190),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(296),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(190),
    [sym_Cf_cmd] = STATE(190),
    [sym_pf_new_cmd] = STATE(190),
    [sym_pf_dot_cmd] = STATE(190),
    [sym_pf_cmd] = STATE(190),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(190),
    [sym__dec_number] = STATE(39),
    [sym_cmd_identifier] = STATE(43),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(15),
    [anon_sym_DOT] = ACTIONS(17),
    [aux_sym__interpret_stmt_token1] = ACTIONS(19),
    [aux_sym__interpret_stmt_token3] = ACTIONS(21),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(27),
    [anon_sym_Cf] = ACTIONS(29),
    [sym_pf_dot_cmd_identifier] = ACTIONS(31),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(33),
    [aux_sym_pf_cmd_token1] = ACTIONS(35),
    [sym__env_stmt_identifier] = ACTIONS(37),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(41),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(53),
  },
  [40] = {
    [sym_legacy_quoted_stmt] = STATE(190),
    [sym__simple_stmt] = STATE(190),
    [sym__tmp_stmt] = STATE(190),
    [sym__iter_stmt] = STATE(190),
    [sym__pipe_stmt] = STATE(190),
    [sym_grep_stmt] = STATE(190),
    [sym_html_disable_stmt] = STATE(190),
    [sym_html_enable_stmt] = STATE(190),
    [sym_pipe_stmt] = STATE(190),
    [sym_iter_file_lines_stmt] = STATE(190),
    [sym_iter_offsets_stmt] = STATE(190),
    [sym_iter_offsetssizes_stmt] = STATE(190),
    [sym_iter_hit_stmt] = STATE(190),
    [sym_iter_interpret_stmt] = STATE(190),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(190),
    [sym_iter_comment_stmt] = STATE(190),
    [sym_iter_dbta_stmt] = STATE(190),
    [sym_iter_dbtb_stmt] = STATE(190),
    [sym_iter_dbts_stmt] = STATE(190),
    [sym_iter_threads_stmt] = STATE(190),
    [sym_iter_bbs_stmt] = STATE(190),
    [sym_iter_instrs_stmt] = STATE(190),
    [sym_iter_import_stmt] = STATE(190),
    [sym_iter_sections_stmt] = STATE(190),
    [sym_iter_segments_stmt] = STATE(190),
    [sym_iter_symbol_stmt] = STATE(190),
    [sym_iter_string_stmt] = STATE(190),
    [sym_iter_flags_stmt] = STATE(190),
    [sym_iter_function_stmt] = STATE(190),
    [sym_iter_iomap_stmt] = STATE(190),
    [sym_iter_dbgmap_stmt] = STATE(190),
    [sym_iter_register_stmt] = STATE(190),
    [sym_iter_step_stmt] = STATE(190),
    [sym_tmp_seek_stmt] = STATE(190),
    [sym_tmp_blksz_stmt] = STATE(190),
    [sym_tmp_fromto_stmt] = STATE(190),
    [sym_tmp_arch_stmt] = STATE(190),
    [sym_tmp_bits_stmt] = STATE(190),
    [sym_tmp_nthi_stmt] = STATE(190),
    [sym_tmp_eval_stmt] = STATE(190),
    [sym_tmp_fs_stmt] = STATE(190),
    [sym_tmp_reli_stmt] = STATE(190),
    [sym_tmp_kuery_stmt] = STATE(190),
    [sym_tmp_fd_stmt] = STATE(190),
    [sym_tmp_reg_stmt] = STATE(190),
    [sym_tmp_file_stmt] = STATE(190),
    [sym_tmp_string_stmt] = STATE(190),
    [sym_tmp_value_stmt] = STATE(190),
    [sym_tmp_hex_stmt] = STATE(190),
    [sym_help_stmt] = STATE(190),
    [sym_macro_stmt] = STATE(190),
    [sym_arged_stmt] = STATE(190),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(190),
    [sym_Cf_cmd] = STATE(190),
    [sym_pf_new_cmd] = STATE(190),
    [sym_pf_dot_cmd] = STATE(190),
    [sym_pf_cmd] = STATE(190),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(190),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [41] = {
    [sym_legacy_quoted_stmt] = STATE(268),
    [sym__simple_stmt] = STATE(268),
    [sym__tmp_stmt] = STATE(268),
    [sym__iter_stmt] = STATE(268),
    [sym__pipe_stmt] = STATE(268),
    [sym_grep_stmt] = STATE(268),
    [sym_html_disable_stmt] = STATE(268),
    [sym_html_enable_stmt] = STATE(268),
    [sym_pipe_stmt] = STATE(268),
    [sym_iter_file_lines_stmt] = STATE(268),
    [sym_iter_offsets_stmt] = STATE(268),
    [sym_iter_offsetssizes_stmt] = STATE(268),
    [sym_iter_hit_stmt] = STATE(268),
    [sym_iter_interpret_stmt] = STATE(268),
    [sym_iter_interpret_offsetssizes_stmt] = STATE(268),
    [sym_iter_comment_stmt] = STATE(268),
    [sym_iter_dbta_stmt] = STATE(268),
    [sym_iter_dbtb_stmt] = STATE(268),
    [sym_iter_dbts_stmt] = STATE(268),
    [sym_iter_threads_stmt] = STATE(268),
    [sym_iter_bbs_stmt] = STATE(268),
    [sym_iter_instrs_stmt] = STATE(268),
    [sym_iter_import_stmt] = STATE(268),
    [sym_iter_sections_stmt] = STATE(268),
    [sym_iter_segments_stmt] = STATE(268),
    [sym_iter_symbol_stmt] = STATE(268),
    [sym_iter_string_stmt] = STATE(268),
    [sym_iter_flags_stmt] = STATE(268),
    [sym_iter_function_stmt] = STATE(268),
    [sym_iter_iomap_stmt] = STATE(268),
    [sym_iter_dbgmap_stmt] = STATE(268),
    [sym_iter_register_stmt] = STATE(268),
    [sym_iter_step_stmt] = STATE(268),
    [sym_tmp_seek_stmt] = STATE(268),
    [sym_tmp_blksz_stmt] = STATE(268),
    [sym_tmp_fromto_stmt] = STATE(268),
    [sym_tmp_arch_stmt] = STATE(268),
    [sym_tmp_bits_stmt] = STATE(268),
    [sym_tmp_nthi_stmt] = STATE(268),
    [sym_tmp_eval_stmt] = STATE(268),
    [sym_tmp_fs_stmt] = STATE(268),
    [sym_tmp_reli_stmt] = STATE(268),
    [sym_tmp_kuery_stmt] = STATE(268),
    [sym_tmp_fd_stmt] = STATE(268),
    [sym_tmp_reg_stmt] = STATE(268),
    [sym_tmp_file_stmt] = STATE(268),
    [sym_tmp_string_stmt] = STATE(268),
    [sym_tmp_value_stmt] = STATE(268),
    [sym_tmp_hex_stmt] = STATE(268),
    [sym_help_stmt] = STATE(268),
    [sym_macro_stmt] = STATE(268),
    [sym_arged_stmt] = STATE(268),
    [sym__macro_arged_stmt] = STATE(251),
    [sym__simple_arged_stmt_question] = STATE(244),
    [sym__simple_arged_stmt] = STATE(236),
    [sym__pointer_arged_stmt] = STATE(227),
    [sym__system_stmt] = STATE(226),
    [sym__interpret_stmt] = STATE(225),
    [sym__interpret_search_identifier] = STATE(300),
    [sym__pf_arged_stmt] = STATE(179),
    [sym__pf_stmts] = STATE(268),
    [sym_Cf_cmd] = STATE(268),
    [sym_pf_new_cmd] = STATE(268),
    [sym_pf_dot_cmd] = STATE(268),
    [sym_pf_cmd] = STATE(268),
    [sym__env_stmt] = STATE(180),
    [sym__last_stmt] = STATE(181),
    [sym_last_stmt_identifier] = STATE(182),
    [sym_repeat_stmt] = STATE(268),
    [sym__dec_number] = STATE(40),
    [sym_cmd_identifier] = STATE(60),
    [anon_sym_DQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(11),
    [anon_sym_LPAREN_DASH_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_STAR] = ACTIONS(13),
    [anon_sym_LPAREN_DASH] = ACTIONS(59),
    [anon_sym_DOT] = ACTIONS(61),
    [aux_sym__interpret_stmt_token1] = ACTIONS(63),
    [aux_sym__interpret_stmt_token3] = ACTIONS(65),
    [aux_sym__interpret_stmt_token4] = ACTIONS(23),
    [anon_sym_DOT_SLASH] = ACTIONS(25),
    [anon_sym_pfo] = ACTIONS(67),
    [anon_sym_Cf] = ACTIONS(69),
    [sym_pf_dot_cmd_identifier] = ACTIONS(71),
    [sym_pf_dot_full_cmd_identifier] = ACTIONS(73),
    [aux_sym_pf_cmd_token1] = ACTIONS(75),
    [sym__env_stmt_identifier] = ACTIONS(77),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(39),
    [sym_system_identifier] = ACTIONS(79),
    [sym_question_mark_identifier] = ACTIONS(43),
    [sym_pointer_identifier] = ACTIONS(45),
    [aux_sym__dec_number_token1] = ACTIONS(47),
    [aux_sym__dec_number_token2] = ACTIONS(49),
    [sym__comment] = ACTIONS(3),
    [sym__cmd_identifier] = ACTIONS(51),
    [sym__help_stmt] = ACTIONS(81),
  },
  [42] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(185),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(97),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(97),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_PIPEH] = ACTIONS(97),
    [anon_sym_AT_AT_DOT] = ACTIONS(97),
    [anon_sym_AT_AT_EQ] = ACTIONS(97),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(97),
    [anon_sym_AT_AT] = ACTIONS(101),
    [anon_sym_AT_ATc_COLON] = ACTIONS(97),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(97),
    [anon_sym_AT_ATC] = ACTIONS(97),
    [anon_sym_AT_ATdbt] = ACTIONS(101),
    [anon_sym_AT_ATdbta] = ACTIONS(97),
    [anon_sym_AT_ATdbtb] = ACTIONS(97),
    [anon_sym_AT_ATdbts] = ACTIONS(97),
    [anon_sym_AT_ATt] = ACTIONS(97),
    [anon_sym_AT_ATb] = ACTIONS(97),
    [anon_sym_AT_ATi] = ACTIONS(101),
    [anon_sym_AT_ATii] = ACTIONS(97),
    [anon_sym_AT_ATiS] = ACTIONS(101),
    [anon_sym_AT_ATiSS] = ACTIONS(97),
    [anon_sym_AT_ATis] = ACTIONS(97),
    [anon_sym_AT_ATiz] = ACTIONS(97),
    [anon_sym_AT_ATf] = ACTIONS(97),
    [anon_sym_AT_ATF] = ACTIONS(97),
    [anon_sym_AT_ATom] = ACTIONS(97),
    [anon_sym_AT_ATdm] = ACTIONS(97),
    [anon_sym_AT_ATr] = ACTIONS(97),
    [anon_sym_AT_ATs_COLON] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(97),
    [anon_sym_AT_BANG] = ACTIONS(97),
    [anon_sym_AT_LPAREN] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(97),
    [anon_sym_ATa_COLON] = ACTIONS(97),
    [anon_sym_ATb_COLON] = ACTIONS(97),
    [anon_sym_ATB_COLON] = ACTIONS(97),
    [anon_sym_ATe_COLON] = ACTIONS(97),
    [anon_sym_ATF_COLON] = ACTIONS(97),
    [anon_sym_ATi_COLON] = ACTIONS(97),
    [anon_sym_ATk_COLON] = ACTIONS(97),
    [anon_sym_ATo_COLON] = ACTIONS(97),
    [anon_sym_ATr_COLON] = ACTIONS(97),
    [anon_sym_ATf_COLON] = ACTIONS(97),
    [anon_sym_ATs_COLON] = ACTIONS(97),
    [anon_sym_ATv_COLON] = ACTIONS(97),
    [anon_sym_ATx_COLON] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(97),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(97),
    [sym_html_redirect_operator] = ACTIONS(101),
    [sym_html_append_operator] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(97),
    [anon_sym_CR] = ACTIONS(97),
    [sym_file_descriptor] = ACTIONS(97),
  },
  [43] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(208),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(115),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_PIPEH] = ACTIONS(115),
    [anon_sym_AT_AT_DOT] = ACTIONS(115),
    [anon_sym_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT] = ACTIONS(117),
    [anon_sym_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_ATC] = ACTIONS(115),
    [anon_sym_AT_ATdbt] = ACTIONS(117),
    [anon_sym_AT_ATdbta] = ACTIONS(115),
    [anon_sym_AT_ATdbtb] = ACTIONS(115),
    [anon_sym_AT_ATdbts] = ACTIONS(115),
    [anon_sym_AT_ATt] = ACTIONS(115),
    [anon_sym_AT_ATb] = ACTIONS(115),
    [anon_sym_AT_ATi] = ACTIONS(117),
    [anon_sym_AT_ATii] = ACTIONS(115),
    [anon_sym_AT_ATiS] = ACTIONS(117),
    [anon_sym_AT_ATiSS] = ACTIONS(115),
    [anon_sym_AT_ATis] = ACTIONS(115),
    [anon_sym_AT_ATiz] = ACTIONS(115),
    [anon_sym_AT_ATf] = ACTIONS(115),
    [anon_sym_AT_ATF] = ACTIONS(115),
    [anon_sym_AT_ATom] = ACTIONS(115),
    [anon_sym_AT_ATdm] = ACTIONS(115),
    [anon_sym_AT_ATr] = ACTIONS(115),
    [anon_sym_AT_ATs_COLON] = ACTIONS(115),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_AT_BANG] = ACTIONS(115),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(115),
    [anon_sym_ATa_COLON] = ACTIONS(115),
    [anon_sym_ATb_COLON] = ACTIONS(115),
    [anon_sym_ATB_COLON] = ACTIONS(115),
    [anon_sym_ATe_COLON] = ACTIONS(115),
    [anon_sym_ATF_COLON] = ACTIONS(115),
    [anon_sym_ATi_COLON] = ACTIONS(115),
    [anon_sym_ATk_COLON] = ACTIONS(115),
    [anon_sym_ATo_COLON] = ACTIONS(115),
    [anon_sym_ATr_COLON] = ACTIONS(115),
    [anon_sym_ATf_COLON] = ACTIONS(115),
    [anon_sym_ATs_COLON] = ACTIONS(115),
    [anon_sym_ATv_COLON] = ACTIONS(115),
    [anon_sym_ATx_COLON] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(117),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym_html_redirect_operator] = ACTIONS(117),
    [sym_html_append_operator] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(115),
    [anon_sym_CR] = ACTIONS(115),
    [sym_file_descriptor] = ACTIONS(115),
  },
  [44] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(219),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(119),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_PIPEH] = ACTIONS(119),
    [anon_sym_AT_AT_DOT] = ACTIONS(119),
    [anon_sym_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT] = ACTIONS(121),
    [anon_sym_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_ATC] = ACTIONS(119),
    [anon_sym_AT_ATdbt] = ACTIONS(121),
    [anon_sym_AT_ATdbta] = ACTIONS(119),
    [anon_sym_AT_ATdbtb] = ACTIONS(119),
    [anon_sym_AT_ATdbts] = ACTIONS(119),
    [anon_sym_AT_ATt] = ACTIONS(119),
    [anon_sym_AT_ATb] = ACTIONS(119),
    [anon_sym_AT_ATi] = ACTIONS(121),
    [anon_sym_AT_ATii] = ACTIONS(119),
    [anon_sym_AT_ATiS] = ACTIONS(121),
    [anon_sym_AT_ATiSS] = ACTIONS(119),
    [anon_sym_AT_ATis] = ACTIONS(119),
    [anon_sym_AT_ATiz] = ACTIONS(119),
    [anon_sym_AT_ATf] = ACTIONS(119),
    [anon_sym_AT_ATF] = ACTIONS(119),
    [anon_sym_AT_ATom] = ACTIONS(119),
    [anon_sym_AT_ATdm] = ACTIONS(119),
    [anon_sym_AT_ATr] = ACTIONS(119),
    [anon_sym_AT_ATs_COLON] = ACTIONS(119),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_AT_BANG] = ACTIONS(119),
    [anon_sym_AT_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_ATa_COLON] = ACTIONS(119),
    [anon_sym_ATb_COLON] = ACTIONS(119),
    [anon_sym_ATB_COLON] = ACTIONS(119),
    [anon_sym_ATe_COLON] = ACTIONS(119),
    [anon_sym_ATF_COLON] = ACTIONS(119),
    [anon_sym_ATi_COLON] = ACTIONS(119),
    [anon_sym_ATk_COLON] = ACTIONS(119),
    [anon_sym_ATo_COLON] = ACTIONS(119),
    [anon_sym_ATr_COLON] = ACTIONS(119),
    [anon_sym_ATf_COLON] = ACTIONS(119),
    [anon_sym_ATs_COLON] = ACTIONS(119),
    [anon_sym_ATv_COLON] = ACTIONS(119),
    [anon_sym_ATx_COLON] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_GT_GT] = ACTIONS(119),
    [sym_html_redirect_operator] = ACTIONS(121),
    [sym_html_append_operator] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(119),
    [anon_sym_CR] = ACTIONS(119),
    [sym_file_descriptor] = ACTIONS(119),
  },
  [45] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(188),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_PIPEH] = ACTIONS(123),
    [anon_sym_AT_AT_DOT] = ACTIONS(123),
    [anon_sym_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT] = ACTIONS(125),
    [anon_sym_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_ATC] = ACTIONS(123),
    [anon_sym_AT_ATdbt] = ACTIONS(125),
    [anon_sym_AT_ATdbta] = ACTIONS(123),
    [anon_sym_AT_ATdbtb] = ACTIONS(123),
    [anon_sym_AT_ATdbts] = ACTIONS(123),
    [anon_sym_AT_ATt] = ACTIONS(123),
    [anon_sym_AT_ATb] = ACTIONS(123),
    [anon_sym_AT_ATi] = ACTIONS(125),
    [anon_sym_AT_ATii] = ACTIONS(123),
    [anon_sym_AT_ATiS] = ACTIONS(125),
    [anon_sym_AT_ATiSS] = ACTIONS(123),
    [anon_sym_AT_ATis] = ACTIONS(123),
    [anon_sym_AT_ATiz] = ACTIONS(123),
    [anon_sym_AT_ATf] = ACTIONS(123),
    [anon_sym_AT_ATF] = ACTIONS(123),
    [anon_sym_AT_ATom] = ACTIONS(123),
    [anon_sym_AT_ATdm] = ACTIONS(123),
    [anon_sym_AT_ATr] = ACTIONS(123),
    [anon_sym_AT_ATs_COLON] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_AT_BANG] = ACTIONS(123),
    [anon_sym_AT_LPAREN] = ACTIONS(123),
    [anon_sym_RPAREN] = ACTIONS(123),
    [anon_sym_ATa_COLON] = ACTIONS(123),
    [anon_sym_ATb_COLON] = ACTIONS(123),
    [anon_sym_ATB_COLON] = ACTIONS(123),
    [anon_sym_ATe_COLON] = ACTIONS(123),
    [anon_sym_ATF_COLON] = ACTIONS(123),
    [anon_sym_ATi_COLON] = ACTIONS(123),
    [anon_sym_ATk_COLON] = ACTIONS(123),
    [anon_sym_ATo_COLON] = ACTIONS(123),
    [anon_sym_ATr_COLON] = ACTIONS(123),
    [anon_sym_ATf_COLON] = ACTIONS(123),
    [anon_sym_ATs_COLON] = ACTIONS(123),
    [anon_sym_ATv_COLON] = ACTIONS(123),
    [anon_sym_ATx_COLON] = ACTIONS(123),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym_html_redirect_operator] = ACTIONS(125),
    [sym_html_append_operator] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(123),
    [anon_sym_CR] = ACTIONS(123),
    [sym_file_descriptor] = ACTIONS(123),
  },
  [46] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(209),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(127),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(127),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(127),
    [anon_sym_CR] = ACTIONS(127),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [47] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(187),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(131),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_RPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(131),
    [anon_sym_CR] = ACTIONS(131),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [48] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(172),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(137),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(137),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(137),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(137),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(135),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(137),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(135),
    [anon_sym_CR] = ACTIONS(135),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [49] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(254),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(139),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(141),
    [anon_sym_PIPEH] = ACTIONS(139),
    [anon_sym_AT_AT_DOT] = ACTIONS(139),
    [anon_sym_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT] = ACTIONS(141),
    [anon_sym_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_ATC] = ACTIONS(139),
    [anon_sym_AT_ATdbt] = ACTIONS(141),
    [anon_sym_AT_ATdbta] = ACTIONS(139),
    [anon_sym_AT_ATdbtb] = ACTIONS(139),
    [anon_sym_AT_ATdbts] = ACTIONS(139),
    [anon_sym_AT_ATt] = ACTIONS(139),
    [anon_sym_AT_ATb] = ACTIONS(139),
    [anon_sym_AT_ATi] = ACTIONS(141),
    [anon_sym_AT_ATii] = ACTIONS(139),
    [anon_sym_AT_ATiS] = ACTIONS(141),
    [anon_sym_AT_ATiSS] = ACTIONS(139),
    [anon_sym_AT_ATis] = ACTIONS(139),
    [anon_sym_AT_ATiz] = ACTIONS(139),
    [anon_sym_AT_ATf] = ACTIONS(139),
    [anon_sym_AT_ATF] = ACTIONS(139),
    [anon_sym_AT_ATom] = ACTIONS(139),
    [anon_sym_AT_ATdm] = ACTIONS(139),
    [anon_sym_AT_ATr] = ACTIONS(139),
    [anon_sym_AT_ATs_COLON] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(139),
    [anon_sym_AT_BANG] = ACTIONS(139),
    [anon_sym_AT_LPAREN] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(139),
    [anon_sym_ATa_COLON] = ACTIONS(139),
    [anon_sym_ATb_COLON] = ACTIONS(139),
    [anon_sym_ATB_COLON] = ACTIONS(139),
    [anon_sym_ATe_COLON] = ACTIONS(139),
    [anon_sym_ATF_COLON] = ACTIONS(139),
    [anon_sym_ATi_COLON] = ACTIONS(139),
    [anon_sym_ATk_COLON] = ACTIONS(139),
    [anon_sym_ATo_COLON] = ACTIONS(139),
    [anon_sym_ATr_COLON] = ACTIONS(139),
    [anon_sym_ATf_COLON] = ACTIONS(139),
    [anon_sym_ATs_COLON] = ACTIONS(139),
    [anon_sym_ATv_COLON] = ACTIONS(139),
    [anon_sym_ATx_COLON] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(141),
    [anon_sym_GT_GT] = ACTIONS(139),
    [sym_html_redirect_operator] = ACTIONS(141),
    [sym_html_append_operator] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(139),
    [anon_sym_CR] = ACTIONS(139),
    [sym_file_descriptor] = ACTIONS(139),
  },
  [50] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(53),
    [sym_args] = STATE(218),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(53),
    [ts_builtin_sym_end] = ACTIONS(143),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(143),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_PIPEH] = ACTIONS(143),
    [anon_sym_AT_AT_DOT] = ACTIONS(143),
    [anon_sym_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT] = ACTIONS(145),
    [anon_sym_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_ATC] = ACTIONS(143),
    [anon_sym_AT_ATdbt] = ACTIONS(145),
    [anon_sym_AT_ATdbta] = ACTIONS(143),
    [anon_sym_AT_ATdbtb] = ACTIONS(143),
    [anon_sym_AT_ATdbts] = ACTIONS(143),
    [anon_sym_AT_ATt] = ACTIONS(143),
    [anon_sym_AT_ATb] = ACTIONS(143),
    [anon_sym_AT_ATi] = ACTIONS(145),
    [anon_sym_AT_ATii] = ACTIONS(143),
    [anon_sym_AT_ATiS] = ACTIONS(145),
    [anon_sym_AT_ATiSS] = ACTIONS(143),
    [anon_sym_AT_ATis] = ACTIONS(143),
    [anon_sym_AT_ATiz] = ACTIONS(143),
    [anon_sym_AT_ATf] = ACTIONS(143),
    [anon_sym_AT_ATF] = ACTIONS(143),
    [anon_sym_AT_ATom] = ACTIONS(143),
    [anon_sym_AT_ATdm] = ACTIONS(143),
    [anon_sym_AT_ATr] = ACTIONS(143),
    [anon_sym_AT_ATs_COLON] = ACTIONS(143),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_AT_BANG] = ACTIONS(143),
    [anon_sym_AT_LPAREN] = ACTIONS(143),
    [anon_sym_RPAREN] = ACTIONS(143),
    [anon_sym_ATa_COLON] = ACTIONS(143),
    [anon_sym_ATb_COLON] = ACTIONS(143),
    [anon_sym_ATB_COLON] = ACTIONS(143),
    [anon_sym_ATe_COLON] = ACTIONS(143),
    [anon_sym_ATF_COLON] = ACTIONS(143),
    [anon_sym_ATi_COLON] = ACTIONS(143),
    [anon_sym_ATk_COLON] = ACTIONS(143),
    [anon_sym_ATo_COLON] = ACTIONS(143),
    [anon_sym_ATr_COLON] = ACTIONS(143),
    [anon_sym_ATf_COLON] = ACTIONS(143),
    [anon_sym_ATs_COLON] = ACTIONS(143),
    [anon_sym_ATv_COLON] = ACTIONS(143),
    [anon_sym_ATx_COLON] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(143),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(143),
    [sym_html_redirect_operator] = ACTIONS(145),
    [sym_html_append_operator] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(143),
    [anon_sym_CR] = ACTIONS(143),
    [sym_file_descriptor] = ACTIONS(143),
  },
  [51] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(51),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(51),
    [ts_builtin_sym_end] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(149),
    [anon_sym_TILDE] = ACTIONS(147),
    [anon_sym_PIPE] = ACTIONS(152),
    [anon_sym_PIPEH] = ACTIONS(147),
    [anon_sym_AT_AT_DOT] = ACTIONS(147),
    [anon_sym_AT_AT_EQ] = ACTIONS(147),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(147),
    [anon_sym_AT_AT] = ACTIONS(152),
    [anon_sym_AT_ATc_COLON] = ACTIONS(147),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(147),
    [anon_sym_AT_ATC] = ACTIONS(147),
    [anon_sym_AT_ATdbt] = ACTIONS(152),
    [anon_sym_AT_ATdbta] = ACTIONS(147),
    [anon_sym_AT_ATdbtb] = ACTIONS(147),
    [anon_sym_AT_ATdbts] = ACTIONS(147),
    [anon_sym_AT_ATt] = ACTIONS(147),
    [anon_sym_AT_ATb] = ACTIONS(147),
    [anon_sym_AT_ATi] = ACTIONS(152),
    [anon_sym_AT_ATii] = ACTIONS(147),
    [anon_sym_AT_ATiS] = ACTIONS(152),
    [anon_sym_AT_ATiSS] = ACTIONS(147),
    [anon_sym_AT_ATis] = ACTIONS(147),
    [anon_sym_AT_ATiz] = ACTIONS(147),
    [anon_sym_AT_ATf] = ACTIONS(147),
    [anon_sym_AT_ATF] = ACTIONS(147),
    [anon_sym_AT_ATom] = ACTIONS(147),
    [anon_sym_AT_ATdm] = ACTIONS(147),
    [anon_sym_AT_ATr] = ACTIONS(147),
    [anon_sym_AT_ATs_COLON] = ACTIONS(147),
    [anon_sym_AT] = ACTIONS(147),
    [anon_sym_AT_BANG] = ACTIONS(147),
    [anon_sym_AT_LPAREN] = ACTIONS(147),
    [anon_sym_RPAREN] = ACTIONS(147),
    [anon_sym_ATa_COLON] = ACTIONS(147),
    [anon_sym_ATb_COLON] = ACTIONS(147),
    [anon_sym_ATB_COLON] = ACTIONS(147),
    [anon_sym_ATe_COLON] = ACTIONS(147),
    [anon_sym_ATF_COLON] = ACTIONS(147),
    [anon_sym_ATi_COLON] = ACTIONS(147),
    [anon_sym_ATk_COLON] = ACTIONS(147),
    [anon_sym_ATo_COLON] = ACTIONS(147),
    [anon_sym_ATr_COLON] = ACTIONS(147),
    [anon_sym_ATf_COLON] = ACTIONS(147),
    [anon_sym_ATs_COLON] = ACTIONS(147),
    [anon_sym_ATv_COLON] = ACTIONS(147),
    [anon_sym_ATx_COLON] = ACTIONS(147),
    [anon_sym_SEMI] = ACTIONS(147),
    [anon_sym_LPAREN] = ACTIONS(154),
    [anon_sym_PIPE_DOT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(157),
    [anon_sym_GT] = ACTIONS(152),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym_html_redirect_operator] = ACTIONS(152),
    [sym_html_append_operator] = ACTIONS(147),
    [anon_sym_COMMA] = ACTIONS(160),
    [aux_sym_arg_identifier_token1] = ACTIONS(157),
    [anon_sym_SQUOTE] = ACTIONS(163),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(166),
    [anon_sym_BQUOTE] = ACTIONS(169),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(147),
    [anon_sym_CR] = ACTIONS(147),
    [sym_file_descriptor] = ACTIONS(147),
  },
  [52] = {
    [sym__Cf_args] = STATE(232),
    [sym__arg_with_paren] = STATE(376),
    [sym__arg] = STATE(376),
    [sym_arg] = STATE(345),
    [sym_arg_identifier] = STATE(376),
    [sym_double_quoted_arg] = STATE(376),
    [sym_single_quoted_arg] = STATE(376),
    [sym_cmd_substitution_arg] = STATE(376),
    [sym_concatenation] = STATE(403),
    [ts_builtin_sym_end] = ACTIONS(172),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(172),
    [anon_sym_PIPE] = ACTIONS(176),
    [anon_sym_PIPEH] = ACTIONS(172),
    [anon_sym_AT_AT_DOT] = ACTIONS(172),
    [anon_sym_AT_AT_EQ] = ACTIONS(172),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(172),
    [anon_sym_AT_AT] = ACTIONS(176),
    [anon_sym_AT_ATc_COLON] = ACTIONS(172),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(172),
    [anon_sym_AT_ATC] = ACTIONS(172),
    [anon_sym_AT_ATdbt] = ACTIONS(176),
    [anon_sym_AT_ATdbta] = ACTIONS(172),
    [anon_sym_AT_ATdbtb] = ACTIONS(172),
    [anon_sym_AT_ATdbts] = ACTIONS(172),
    [anon_sym_AT_ATt] = ACTIONS(172),
    [anon_sym_AT_ATb] = ACTIONS(172),
    [anon_sym_AT_ATi] = ACTIONS(176),
    [anon_sym_AT_ATii] = ACTIONS(172),
    [anon_sym_AT_ATiS] = ACTIONS(176),
    [anon_sym_AT_ATiSS] = ACTIONS(172),
    [anon_sym_AT_ATis] = ACTIONS(172),
    [anon_sym_AT_ATiz] = ACTIONS(172),
    [anon_sym_AT_ATf] = ACTIONS(172),
    [anon_sym_AT_ATF] = ACTIONS(172),
    [anon_sym_AT_ATom] = ACTIONS(172),
    [anon_sym_AT_ATdm] = ACTIONS(172),
    [anon_sym_AT_ATr] = ACTIONS(172),
    [anon_sym_AT_ATs_COLON] = ACTIONS(172),
    [anon_sym_AT] = ACTIONS(172),
    [anon_sym_AT_BANG] = ACTIONS(172),
    [anon_sym_AT_LPAREN] = ACTIONS(172),
    [anon_sym_RPAREN] = ACTIONS(172),
    [anon_sym_ATa_COLON] = ACTIONS(172),
    [anon_sym_ATb_COLON] = ACTIONS(172),
    [anon_sym_ATB_COLON] = ACTIONS(172),
    [anon_sym_ATe_COLON] = ACTIONS(172),
    [anon_sym_ATF_COLON] = ACTIONS(172),
    [anon_sym_ATi_COLON] = ACTIONS(172),
    [anon_sym_ATk_COLON] = ACTIONS(172),
    [anon_sym_ATo_COLON] = ACTIONS(172),
    [anon_sym_ATr_COLON] = ACTIONS(172),
    [anon_sym_ATf_COLON] = ACTIONS(172),
    [anon_sym_ATs_COLON] = ACTIONS(172),
    [anon_sym_ATv_COLON] = ACTIONS(172),
    [anon_sym_ATx_COLON] = ACTIONS(172),
    [anon_sym_SEMI] = ACTIONS(172),
    [anon_sym_LPAREN] = ACTIONS(178),
    [anon_sym_PIPE_DOT] = ACTIONS(172),
    [anon_sym_DOLLAR] = ACTIONS(180),
    [anon_sym_GT] = ACTIONS(176),
    [anon_sym_GT_GT] = ACTIONS(172),
    [sym_html_redirect_operator] = ACTIONS(176),
    [sym_html_append_operator] = ACTIONS(172),
    [anon_sym_COMMA] = ACTIONS(182),
    [aux_sym_arg_identifier_token1] = ACTIONS(180),
    [anon_sym_SQUOTE] = ACTIONS(184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(186),
    [anon_sym_BQUOTE] = ACTIONS(188),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(172),
    [anon_sym_CR] = ACTIONS(172),
    [sym_file_descriptor] = ACTIONS(172),
  },
  [53] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(51),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(51),
    [ts_builtin_sym_end] = ACTIONS(190),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(190),
    [anon_sym_PIPE] = ACTIONS(192),
    [anon_sym_PIPEH] = ACTIONS(190),
    [anon_sym_AT_AT_DOT] = ACTIONS(190),
    [anon_sym_AT_AT_EQ] = ACTIONS(190),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(190),
    [anon_sym_AT_AT] = ACTIONS(192),
    [anon_sym_AT_ATc_COLON] = ACTIONS(190),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(190),
    [anon_sym_AT_ATC] = ACTIONS(190),
    [anon_sym_AT_ATdbt] = ACTIONS(192),
    [anon_sym_AT_ATdbta] = ACTIONS(190),
    [anon_sym_AT_ATdbtb] = ACTIONS(190),
    [anon_sym_AT_ATdbts] = ACTIONS(190),
    [anon_sym_AT_ATt] = ACTIONS(190),
    [anon_sym_AT_ATb] = ACTIONS(190),
    [anon_sym_AT_ATi] = ACTIONS(192),
    [anon_sym_AT_ATii] = ACTIONS(190),
    [anon_sym_AT_ATiS] = ACTIONS(192),
    [anon_sym_AT_ATiSS] = ACTIONS(190),
    [anon_sym_AT_ATis] = ACTIONS(190),
    [anon_sym_AT_ATiz] = ACTIONS(190),
    [anon_sym_AT_ATf] = ACTIONS(190),
    [anon_sym_AT_ATF] = ACTIONS(190),
    [anon_sym_AT_ATom] = ACTIONS(190),
    [anon_sym_AT_ATdm] = ACTIONS(190),
    [anon_sym_AT_ATr] = ACTIONS(190),
    [anon_sym_AT_ATs_COLON] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(190),
    [anon_sym_AT_BANG] = ACTIONS(190),
    [anon_sym_AT_LPAREN] = ACTIONS(190),
    [anon_sym_RPAREN] = ACTIONS(190),
    [anon_sym_ATa_COLON] = ACTIONS(190),
    [anon_sym_ATb_COLON] = ACTIONS(190),
    [anon_sym_ATB_COLON] = ACTIONS(190),
    [anon_sym_ATe_COLON] = ACTIONS(190),
    [anon_sym_ATF_COLON] = ACTIONS(190),
    [anon_sym_ATi_COLON] = ACTIONS(190),
    [anon_sym_ATk_COLON] = ACTIONS(190),
    [anon_sym_ATo_COLON] = ACTIONS(190),
    [anon_sym_ATr_COLON] = ACTIONS(190),
    [anon_sym_ATf_COLON] = ACTIONS(190),
    [anon_sym_ATs_COLON] = ACTIONS(190),
    [anon_sym_ATv_COLON] = ACTIONS(190),
    [anon_sym_ATx_COLON] = ACTIONS(190),
    [anon_sym_SEMI] = ACTIONS(190),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(192),
    [anon_sym_GT_GT] = ACTIONS(190),
    [sym_html_redirect_operator] = ACTIONS(192),
    [sym_html_append_operator] = ACTIONS(190),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(190),
    [anon_sym_CR] = ACTIONS(190),
    [sym_file_descriptor] = ACTIONS(190),
  },
  [54] = {
    [sym__pf_arg_parentheses] = STATE(96),
    [sym_pf_arg_identifier] = STATE(96),
    [sym__pf_arg] = STATE(96),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(69),
    [sym_pf_args] = STATE(230),
    [sym_cmd_substitution_arg] = STATE(96),
    [aux_sym_pf_args_repeat1] = STATE(69),
    [aux_sym_pf_dot_args_repeat1] = STATE(114),
    [ts_builtin_sym_end] = ACTIONS(194),
    [anon_sym_TILDE] = ACTIONS(194),
    [anon_sym_PIPE] = ACTIONS(196),
    [anon_sym_PIPEH] = ACTIONS(194),
    [anon_sym_AT_AT_DOT] = ACTIONS(194),
    [anon_sym_AT_AT_EQ] = ACTIONS(194),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(194),
    [anon_sym_AT_AT] = ACTIONS(196),
    [anon_sym_AT_ATc_COLON] = ACTIONS(194),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(194),
    [anon_sym_AT_ATC] = ACTIONS(194),
    [anon_sym_AT_ATdbt] = ACTIONS(196),
    [anon_sym_AT_ATdbta] = ACTIONS(194),
    [anon_sym_AT_ATdbtb] = ACTIONS(194),
    [anon_sym_AT_ATdbts] = ACTIONS(194),
    [anon_sym_AT_ATt] = ACTIONS(194),
    [anon_sym_AT_ATb] = ACTIONS(194),
    [anon_sym_AT_ATi] = ACTIONS(196),
    [anon_sym_AT_ATii] = ACTIONS(194),
    [anon_sym_AT_ATiS] = ACTIONS(196),
    [anon_sym_AT_ATiSS] = ACTIONS(194),
    [anon_sym_AT_ATis] = ACTIONS(194),
    [anon_sym_AT_ATiz] = ACTIONS(194),
    [anon_sym_AT_ATf] = ACTIONS(194),
    [anon_sym_AT_ATF] = ACTIONS(194),
    [anon_sym_AT_ATom] = ACTIONS(194),
    [anon_sym_AT_ATdm] = ACTIONS(194),
    [anon_sym_AT_ATr] = ACTIONS(194),
    [anon_sym_AT_ATs_COLON] = ACTIONS(194),
    [anon_sym_AT] = ACTIONS(194),
    [anon_sym_AT_BANG] = ACTIONS(194),
    [anon_sym_AT_LPAREN] = ACTIONS(194),
    [anon_sym_RPAREN] = ACTIONS(194),
    [anon_sym_ATa_COLON] = ACTIONS(194),
    [anon_sym_ATb_COLON] = ACTIONS(194),
    [anon_sym_ATB_COLON] = ACTIONS(194),
    [anon_sym_ATe_COLON] = ACTIONS(194),
    [anon_sym_ATF_COLON] = ACTIONS(194),
    [anon_sym_ATi_COLON] = ACTIONS(194),
    [anon_sym_ATk_COLON] = ACTIONS(194),
    [anon_sym_ATo_COLON] = ACTIONS(194),
    [anon_sym_ATr_COLON] = ACTIONS(194),
    [anon_sym_ATf_COLON] = ACTIONS(194),
    [anon_sym_ATs_COLON] = ACTIONS(194),
    [anon_sym_ATv_COLON] = ACTIONS(194),
    [anon_sym_ATx_COLON] = ACTIONS(194),
    [anon_sym_SEMI] = ACTIONS(194),
    [anon_sym_LPAREN] = ACTIONS(198),
    [anon_sym_PIPE_DOT] = ACTIONS(194),
    [anon_sym_EQ] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(200),
    [anon_sym_GT] = ACTIONS(196),
    [anon_sym_GT_GT] = ACTIONS(194),
    [sym_html_redirect_operator] = ACTIONS(196),
    [sym_html_append_operator] = ACTIONS(194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(202),
    [anon_sym_BQUOTE] = ACTIONS(204),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(194),
    [anon_sym_CR] = ACTIONS(194),
    [sym_file_descriptor] = ACTIONS(194),
    [sym__concat_pf_dot] = ACTIONS(206),
  },
  [55] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(188),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_PIPEH] = ACTIONS(123),
    [anon_sym_AT_AT_DOT] = ACTIONS(123),
    [anon_sym_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(123),
    [anon_sym_AT_AT] = ACTIONS(125),
    [anon_sym_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(123),
    [anon_sym_AT_ATC] = ACTIONS(123),
    [anon_sym_AT_ATdbt] = ACTIONS(125),
    [anon_sym_AT_ATdbta] = ACTIONS(123),
    [anon_sym_AT_ATdbtb] = ACTIONS(123),
    [anon_sym_AT_ATdbts] = ACTIONS(123),
    [anon_sym_AT_ATt] = ACTIONS(123),
    [anon_sym_AT_ATb] = ACTIONS(123),
    [anon_sym_AT_ATi] = ACTIONS(125),
    [anon_sym_AT_ATii] = ACTIONS(123),
    [anon_sym_AT_ATiS] = ACTIONS(125),
    [anon_sym_AT_ATiSS] = ACTIONS(123),
    [anon_sym_AT_ATis] = ACTIONS(123),
    [anon_sym_AT_ATiz] = ACTIONS(123),
    [anon_sym_AT_ATf] = ACTIONS(123),
    [anon_sym_AT_ATF] = ACTIONS(123),
    [anon_sym_AT_ATom] = ACTIONS(123),
    [anon_sym_AT_ATdm] = ACTIONS(123),
    [anon_sym_AT_ATr] = ACTIONS(123),
    [anon_sym_AT_ATs_COLON] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_AT_BANG] = ACTIONS(123),
    [anon_sym_AT_LPAREN] = ACTIONS(123),
    [anon_sym_ATa_COLON] = ACTIONS(123),
    [anon_sym_ATb_COLON] = ACTIONS(123),
    [anon_sym_ATB_COLON] = ACTIONS(123),
    [anon_sym_ATe_COLON] = ACTIONS(123),
    [anon_sym_ATF_COLON] = ACTIONS(123),
    [anon_sym_ATi_COLON] = ACTIONS(123),
    [anon_sym_ATk_COLON] = ACTIONS(123),
    [anon_sym_ATo_COLON] = ACTIONS(123),
    [anon_sym_ATr_COLON] = ACTIONS(123),
    [anon_sym_ATf_COLON] = ACTIONS(123),
    [anon_sym_ATs_COLON] = ACTIONS(123),
    [anon_sym_ATv_COLON] = ACTIONS(123),
    [anon_sym_ATx_COLON] = ACTIONS(123),
    [anon_sym_SEMI] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym_html_redirect_operator] = ACTIONS(125),
    [sym_html_append_operator] = ACTIONS(123),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(123),
  },
  [56] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(219),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(121),
    [anon_sym_PIPEH] = ACTIONS(119),
    [anon_sym_AT_AT_DOT] = ACTIONS(119),
    [anon_sym_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(119),
    [anon_sym_AT_AT] = ACTIONS(121),
    [anon_sym_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(119),
    [anon_sym_AT_ATC] = ACTIONS(119),
    [anon_sym_AT_ATdbt] = ACTIONS(121),
    [anon_sym_AT_ATdbta] = ACTIONS(119),
    [anon_sym_AT_ATdbtb] = ACTIONS(119),
    [anon_sym_AT_ATdbts] = ACTIONS(119),
    [anon_sym_AT_ATt] = ACTIONS(119),
    [anon_sym_AT_ATb] = ACTIONS(119),
    [anon_sym_AT_ATi] = ACTIONS(121),
    [anon_sym_AT_ATii] = ACTIONS(119),
    [anon_sym_AT_ATiS] = ACTIONS(121),
    [anon_sym_AT_ATiSS] = ACTIONS(119),
    [anon_sym_AT_ATis] = ACTIONS(119),
    [anon_sym_AT_ATiz] = ACTIONS(119),
    [anon_sym_AT_ATf] = ACTIONS(119),
    [anon_sym_AT_ATF] = ACTIONS(119),
    [anon_sym_AT_ATom] = ACTIONS(119),
    [anon_sym_AT_ATdm] = ACTIONS(119),
    [anon_sym_AT_ATr] = ACTIONS(119),
    [anon_sym_AT_ATs_COLON] = ACTIONS(119),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_AT_BANG] = ACTIONS(119),
    [anon_sym_AT_LPAREN] = ACTIONS(119),
    [anon_sym_ATa_COLON] = ACTIONS(119),
    [anon_sym_ATb_COLON] = ACTIONS(119),
    [anon_sym_ATB_COLON] = ACTIONS(119),
    [anon_sym_ATe_COLON] = ACTIONS(119),
    [anon_sym_ATF_COLON] = ACTIONS(119),
    [anon_sym_ATi_COLON] = ACTIONS(119),
    [anon_sym_ATk_COLON] = ACTIONS(119),
    [anon_sym_ATo_COLON] = ACTIONS(119),
    [anon_sym_ATr_COLON] = ACTIONS(119),
    [anon_sym_ATf_COLON] = ACTIONS(119),
    [anon_sym_ATs_COLON] = ACTIONS(119),
    [anon_sym_ATv_COLON] = ACTIONS(119),
    [anon_sym_ATx_COLON] = ACTIONS(119),
    [anon_sym_SEMI] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(119),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(121),
    [anon_sym_GT_GT] = ACTIONS(119),
    [sym_html_redirect_operator] = ACTIONS(121),
    [sym_html_append_operator] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(119),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(119),
  },
  [57] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(187),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(131),
    [anon_sym_PIPE] = ACTIONS(133),
    [anon_sym_PIPEH] = ACTIONS(131),
    [anon_sym_AT_AT_DOT] = ACTIONS(131),
    [anon_sym_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(131),
    [anon_sym_AT_AT] = ACTIONS(133),
    [anon_sym_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(131),
    [anon_sym_AT_ATC] = ACTIONS(131),
    [anon_sym_AT_ATdbt] = ACTIONS(133),
    [anon_sym_AT_ATdbta] = ACTIONS(131),
    [anon_sym_AT_ATdbtb] = ACTIONS(131),
    [anon_sym_AT_ATdbts] = ACTIONS(131),
    [anon_sym_AT_ATt] = ACTIONS(131),
    [anon_sym_AT_ATb] = ACTIONS(131),
    [anon_sym_AT_ATi] = ACTIONS(133),
    [anon_sym_AT_ATii] = ACTIONS(131),
    [anon_sym_AT_ATiS] = ACTIONS(133),
    [anon_sym_AT_ATiSS] = ACTIONS(131),
    [anon_sym_AT_ATis] = ACTIONS(131),
    [anon_sym_AT_ATiz] = ACTIONS(131),
    [anon_sym_AT_ATf] = ACTIONS(131),
    [anon_sym_AT_ATF] = ACTIONS(131),
    [anon_sym_AT_ATom] = ACTIONS(131),
    [anon_sym_AT_ATdm] = ACTIONS(131),
    [anon_sym_AT_ATr] = ACTIONS(131),
    [anon_sym_AT_ATs_COLON] = ACTIONS(131),
    [anon_sym_AT] = ACTIONS(131),
    [anon_sym_AT_BANG] = ACTIONS(131),
    [anon_sym_AT_LPAREN] = ACTIONS(131),
    [anon_sym_ATa_COLON] = ACTIONS(131),
    [anon_sym_ATb_COLON] = ACTIONS(131),
    [anon_sym_ATB_COLON] = ACTIONS(131),
    [anon_sym_ATe_COLON] = ACTIONS(131),
    [anon_sym_ATF_COLON] = ACTIONS(131),
    [anon_sym_ATi_COLON] = ACTIONS(131),
    [anon_sym_ATk_COLON] = ACTIONS(131),
    [anon_sym_ATo_COLON] = ACTIONS(131),
    [anon_sym_ATr_COLON] = ACTIONS(131),
    [anon_sym_ATf_COLON] = ACTIONS(131),
    [anon_sym_ATs_COLON] = ACTIONS(131),
    [anon_sym_ATv_COLON] = ACTIONS(131),
    [anon_sym_ATx_COLON] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(131),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(133),
    [anon_sym_GT_GT] = ACTIONS(131),
    [sym_html_redirect_operator] = ACTIONS(133),
    [sym_html_append_operator] = ACTIONS(131),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(113),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(131),
  },
  [58] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(185),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(97),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_PIPEH] = ACTIONS(97),
    [anon_sym_AT_AT_DOT] = ACTIONS(97),
    [anon_sym_AT_AT_EQ] = ACTIONS(97),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(97),
    [anon_sym_AT_AT] = ACTIONS(101),
    [anon_sym_AT_ATc_COLON] = ACTIONS(97),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(97),
    [anon_sym_AT_ATC] = ACTIONS(97),
    [anon_sym_AT_ATdbt] = ACTIONS(101),
    [anon_sym_AT_ATdbta] = ACTIONS(97),
    [anon_sym_AT_ATdbtb] = ACTIONS(97),
    [anon_sym_AT_ATdbts] = ACTIONS(97),
    [anon_sym_AT_ATt] = ACTIONS(97),
    [anon_sym_AT_ATb] = ACTIONS(97),
    [anon_sym_AT_ATi] = ACTIONS(101),
    [anon_sym_AT_ATii] = ACTIONS(97),
    [anon_sym_AT_ATiS] = ACTIONS(101),
    [anon_sym_AT_ATiSS] = ACTIONS(97),
    [anon_sym_AT_ATis] = ACTIONS(97),
    [anon_sym_AT_ATiz] = ACTIONS(97),
    [anon_sym_AT_ATf] = ACTIONS(97),
    [anon_sym_AT_ATF] = ACTIONS(97),
    [anon_sym_AT_ATom] = ACTIONS(97),
    [anon_sym_AT_ATdm] = ACTIONS(97),
    [anon_sym_AT_ATr] = ACTIONS(97),
    [anon_sym_AT_ATs_COLON] = ACTIONS(97),
    [anon_sym_AT] = ACTIONS(97),
    [anon_sym_AT_BANG] = ACTIONS(97),
    [anon_sym_AT_LPAREN] = ACTIONS(97),
    [anon_sym_ATa_COLON] = ACTIONS(97),
    [anon_sym_ATb_COLON] = ACTIONS(97),
    [anon_sym_ATB_COLON] = ACTIONS(97),
    [anon_sym_ATe_COLON] = ACTIONS(97),
    [anon_sym_ATF_COLON] = ACTIONS(97),
    [anon_sym_ATi_COLON] = ACTIONS(97),
    [anon_sym_ATk_COLON] = ACTIONS(97),
    [anon_sym_ATo_COLON] = ACTIONS(97),
    [anon_sym_ATr_COLON] = ACTIONS(97),
    [anon_sym_ATf_COLON] = ACTIONS(97),
    [anon_sym_ATs_COLON] = ACTIONS(97),
    [anon_sym_ATv_COLON] = ACTIONS(97),
    [anon_sym_ATx_COLON] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(97),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(97),
    [sym_html_redirect_operator] = ACTIONS(101),
    [sym_html_append_operator] = ACTIONS(97),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(97),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(97),
  },
  [59] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(218),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(143),
    [anon_sym_PIPE] = ACTIONS(145),
    [anon_sym_PIPEH] = ACTIONS(143),
    [anon_sym_AT_AT_DOT] = ACTIONS(143),
    [anon_sym_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(143),
    [anon_sym_AT_AT] = ACTIONS(145),
    [anon_sym_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(143),
    [anon_sym_AT_ATC] = ACTIONS(143),
    [anon_sym_AT_ATdbt] = ACTIONS(145),
    [anon_sym_AT_ATdbta] = ACTIONS(143),
    [anon_sym_AT_ATdbtb] = ACTIONS(143),
    [anon_sym_AT_ATdbts] = ACTIONS(143),
    [anon_sym_AT_ATt] = ACTIONS(143),
    [anon_sym_AT_ATb] = ACTIONS(143),
    [anon_sym_AT_ATi] = ACTIONS(145),
    [anon_sym_AT_ATii] = ACTIONS(143),
    [anon_sym_AT_ATiS] = ACTIONS(145),
    [anon_sym_AT_ATiSS] = ACTIONS(143),
    [anon_sym_AT_ATis] = ACTIONS(143),
    [anon_sym_AT_ATiz] = ACTIONS(143),
    [anon_sym_AT_ATf] = ACTIONS(143),
    [anon_sym_AT_ATF] = ACTIONS(143),
    [anon_sym_AT_ATom] = ACTIONS(143),
    [anon_sym_AT_ATdm] = ACTIONS(143),
    [anon_sym_AT_ATr] = ACTIONS(143),
    [anon_sym_AT_ATs_COLON] = ACTIONS(143),
    [anon_sym_AT] = ACTIONS(143),
    [anon_sym_AT_BANG] = ACTIONS(143),
    [anon_sym_AT_LPAREN] = ACTIONS(143),
    [anon_sym_ATa_COLON] = ACTIONS(143),
    [anon_sym_ATb_COLON] = ACTIONS(143),
    [anon_sym_ATB_COLON] = ACTIONS(143),
    [anon_sym_ATe_COLON] = ACTIONS(143),
    [anon_sym_ATF_COLON] = ACTIONS(143),
    [anon_sym_ATi_COLON] = ACTIONS(143),
    [anon_sym_ATk_COLON] = ACTIONS(143),
    [anon_sym_ATo_COLON] = ACTIONS(143),
    [anon_sym_ATr_COLON] = ACTIONS(143),
    [anon_sym_ATf_COLON] = ACTIONS(143),
    [anon_sym_ATs_COLON] = ACTIONS(143),
    [anon_sym_ATv_COLON] = ACTIONS(143),
    [anon_sym_ATx_COLON] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(143),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(145),
    [anon_sym_GT_GT] = ACTIONS(143),
    [sym_html_redirect_operator] = ACTIONS(145),
    [sym_html_append_operator] = ACTIONS(143),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(143),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(143),
  },
  [60] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(208),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(115),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_PIPEH] = ACTIONS(115),
    [anon_sym_AT_AT_DOT] = ACTIONS(115),
    [anon_sym_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(115),
    [anon_sym_AT_AT] = ACTIONS(117),
    [anon_sym_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(115),
    [anon_sym_AT_ATC] = ACTIONS(115),
    [anon_sym_AT_ATdbt] = ACTIONS(117),
    [anon_sym_AT_ATdbta] = ACTIONS(115),
    [anon_sym_AT_ATdbtb] = ACTIONS(115),
    [anon_sym_AT_ATdbts] = ACTIONS(115),
    [anon_sym_AT_ATt] = ACTIONS(115),
    [anon_sym_AT_ATb] = ACTIONS(115),
    [anon_sym_AT_ATi] = ACTIONS(117),
    [anon_sym_AT_ATii] = ACTIONS(115),
    [anon_sym_AT_ATiS] = ACTIONS(117),
    [anon_sym_AT_ATiSS] = ACTIONS(115),
    [anon_sym_AT_ATis] = ACTIONS(115),
    [anon_sym_AT_ATiz] = ACTIONS(115),
    [anon_sym_AT_ATf] = ACTIONS(115),
    [anon_sym_AT_ATF] = ACTIONS(115),
    [anon_sym_AT_ATom] = ACTIONS(115),
    [anon_sym_AT_ATdm] = ACTIONS(115),
    [anon_sym_AT_ATr] = ACTIONS(115),
    [anon_sym_AT_ATs_COLON] = ACTIONS(115),
    [anon_sym_AT] = ACTIONS(115),
    [anon_sym_AT_BANG] = ACTIONS(115),
    [anon_sym_AT_LPAREN] = ACTIONS(115),
    [anon_sym_ATa_COLON] = ACTIONS(115),
    [anon_sym_ATb_COLON] = ACTIONS(115),
    [anon_sym_ATB_COLON] = ACTIONS(115),
    [anon_sym_ATe_COLON] = ACTIONS(115),
    [anon_sym_ATF_COLON] = ACTIONS(115),
    [anon_sym_ATi_COLON] = ACTIONS(115),
    [anon_sym_ATk_COLON] = ACTIONS(115),
    [anon_sym_ATo_COLON] = ACTIONS(115),
    [anon_sym_ATr_COLON] = ACTIONS(115),
    [anon_sym_ATf_COLON] = ACTIONS(115),
    [anon_sym_ATs_COLON] = ACTIONS(115),
    [anon_sym_ATv_COLON] = ACTIONS(115),
    [anon_sym_ATx_COLON] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(115),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(115),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(117),
    [anon_sym_GT_GT] = ACTIONS(115),
    [sym_html_redirect_operator] = ACTIONS(117),
    [sym_html_append_operator] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(115),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(115),
  },
  [61] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(172),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(137),
    [anon_sym_PIPEH] = ACTIONS(135),
    [anon_sym_AT_AT_DOT] = ACTIONS(135),
    [anon_sym_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(135),
    [anon_sym_AT_AT] = ACTIONS(137),
    [anon_sym_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(135),
    [anon_sym_AT_ATC] = ACTIONS(135),
    [anon_sym_AT_ATdbt] = ACTIONS(137),
    [anon_sym_AT_ATdbta] = ACTIONS(135),
    [anon_sym_AT_ATdbtb] = ACTIONS(135),
    [anon_sym_AT_ATdbts] = ACTIONS(135),
    [anon_sym_AT_ATt] = ACTIONS(135),
    [anon_sym_AT_ATb] = ACTIONS(135),
    [anon_sym_AT_ATi] = ACTIONS(137),
    [anon_sym_AT_ATii] = ACTIONS(135),
    [anon_sym_AT_ATiS] = ACTIONS(137),
    [anon_sym_AT_ATiSS] = ACTIONS(135),
    [anon_sym_AT_ATis] = ACTIONS(135),
    [anon_sym_AT_ATiz] = ACTIONS(135),
    [anon_sym_AT_ATf] = ACTIONS(135),
    [anon_sym_AT_ATF] = ACTIONS(135),
    [anon_sym_AT_ATom] = ACTIONS(135),
    [anon_sym_AT_ATdm] = ACTIONS(135),
    [anon_sym_AT_ATr] = ACTIONS(135),
    [anon_sym_AT_ATs_COLON] = ACTIONS(135),
    [anon_sym_AT] = ACTIONS(135),
    [anon_sym_AT_BANG] = ACTIONS(135),
    [anon_sym_AT_LPAREN] = ACTIONS(135),
    [anon_sym_ATa_COLON] = ACTIONS(135),
    [anon_sym_ATb_COLON] = ACTIONS(135),
    [anon_sym_ATB_COLON] = ACTIONS(135),
    [anon_sym_ATe_COLON] = ACTIONS(135),
    [anon_sym_ATF_COLON] = ACTIONS(135),
    [anon_sym_ATi_COLON] = ACTIONS(135),
    [anon_sym_ATk_COLON] = ACTIONS(135),
    [anon_sym_ATo_COLON] = ACTIONS(135),
    [anon_sym_ATr_COLON] = ACTIONS(135),
    [anon_sym_ATf_COLON] = ACTIONS(135),
    [anon_sym_ATs_COLON] = ACTIONS(135),
    [anon_sym_ATv_COLON] = ACTIONS(135),
    [anon_sym_ATx_COLON] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(135),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(137),
    [anon_sym_GT_GT] = ACTIONS(135),
    [sym_html_redirect_operator] = ACTIONS(137),
    [sym_html_append_operator] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(135),
  },
  [62] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(254),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(139),
    [anon_sym_PIPE] = ACTIONS(141),
    [anon_sym_PIPEH] = ACTIONS(139),
    [anon_sym_AT_AT_DOT] = ACTIONS(139),
    [anon_sym_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(139),
    [anon_sym_AT_AT] = ACTIONS(141),
    [anon_sym_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(139),
    [anon_sym_AT_ATC] = ACTIONS(139),
    [anon_sym_AT_ATdbt] = ACTIONS(141),
    [anon_sym_AT_ATdbta] = ACTIONS(139),
    [anon_sym_AT_ATdbtb] = ACTIONS(139),
    [anon_sym_AT_ATdbts] = ACTIONS(139),
    [anon_sym_AT_ATt] = ACTIONS(139),
    [anon_sym_AT_ATb] = ACTIONS(139),
    [anon_sym_AT_ATi] = ACTIONS(141),
    [anon_sym_AT_ATii] = ACTIONS(139),
    [anon_sym_AT_ATiS] = ACTIONS(141),
    [anon_sym_AT_ATiSS] = ACTIONS(139),
    [anon_sym_AT_ATis] = ACTIONS(139),
    [anon_sym_AT_ATiz] = ACTIONS(139),
    [anon_sym_AT_ATf] = ACTIONS(139),
    [anon_sym_AT_ATF] = ACTIONS(139),
    [anon_sym_AT_ATom] = ACTIONS(139),
    [anon_sym_AT_ATdm] = ACTIONS(139),
    [anon_sym_AT_ATr] = ACTIONS(139),
    [anon_sym_AT_ATs_COLON] = ACTIONS(139),
    [anon_sym_AT] = ACTIONS(139),
    [anon_sym_AT_BANG] = ACTIONS(139),
    [anon_sym_AT_LPAREN] = ACTIONS(139),
    [anon_sym_ATa_COLON] = ACTIONS(139),
    [anon_sym_ATb_COLON] = ACTIONS(139),
    [anon_sym_ATB_COLON] = ACTIONS(139),
    [anon_sym_ATe_COLON] = ACTIONS(139),
    [anon_sym_ATF_COLON] = ACTIONS(139),
    [anon_sym_ATi_COLON] = ACTIONS(139),
    [anon_sym_ATk_COLON] = ACTIONS(139),
    [anon_sym_ATo_COLON] = ACTIONS(139),
    [anon_sym_ATr_COLON] = ACTIONS(139),
    [anon_sym_ATf_COLON] = ACTIONS(139),
    [anon_sym_ATs_COLON] = ACTIONS(139),
    [anon_sym_ATv_COLON] = ACTIONS(139),
    [anon_sym_ATx_COLON] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(139),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(139),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(141),
    [anon_sym_GT_GT] = ACTIONS(139),
    [sym_html_redirect_operator] = ACTIONS(141),
    [sym_html_append_operator] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(139),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(139),
  },
  [63] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(65),
    [sym_args] = STATE(209),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(65),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(127),
    [anon_sym_PIPE] = ACTIONS(129),
    [anon_sym_PIPEH] = ACTIONS(127),
    [anon_sym_AT_AT_DOT] = ACTIONS(127),
    [anon_sym_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(127),
    [anon_sym_AT_AT] = ACTIONS(129),
    [anon_sym_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(127),
    [anon_sym_AT_ATC] = ACTIONS(127),
    [anon_sym_AT_ATdbt] = ACTIONS(129),
    [anon_sym_AT_ATdbta] = ACTIONS(127),
    [anon_sym_AT_ATdbtb] = ACTIONS(127),
    [anon_sym_AT_ATdbts] = ACTIONS(127),
    [anon_sym_AT_ATt] = ACTIONS(127),
    [anon_sym_AT_ATb] = ACTIONS(127),
    [anon_sym_AT_ATi] = ACTIONS(129),
    [anon_sym_AT_ATii] = ACTIONS(127),
    [anon_sym_AT_ATiS] = ACTIONS(129),
    [anon_sym_AT_ATiSS] = ACTIONS(127),
    [anon_sym_AT_ATis] = ACTIONS(127),
    [anon_sym_AT_ATiz] = ACTIONS(127),
    [anon_sym_AT_ATf] = ACTIONS(127),
    [anon_sym_AT_ATF] = ACTIONS(127),
    [anon_sym_AT_ATom] = ACTIONS(127),
    [anon_sym_AT_ATdm] = ACTIONS(127),
    [anon_sym_AT_ATr] = ACTIONS(127),
    [anon_sym_AT_ATs_COLON] = ACTIONS(127),
    [anon_sym_AT] = ACTIONS(127),
    [anon_sym_AT_BANG] = ACTIONS(127),
    [anon_sym_AT_LPAREN] = ACTIONS(127),
    [anon_sym_ATa_COLON] = ACTIONS(127),
    [anon_sym_ATb_COLON] = ACTIONS(127),
    [anon_sym_ATB_COLON] = ACTIONS(127),
    [anon_sym_ATe_COLON] = ACTIONS(127),
    [anon_sym_ATF_COLON] = ACTIONS(127),
    [anon_sym_ATi_COLON] = ACTIONS(127),
    [anon_sym_ATk_COLON] = ACTIONS(127),
    [anon_sym_ATo_COLON] = ACTIONS(127),
    [anon_sym_ATr_COLON] = ACTIONS(127),
    [anon_sym_ATf_COLON] = ACTIONS(127),
    [anon_sym_ATs_COLON] = ACTIONS(127),
    [anon_sym_ATv_COLON] = ACTIONS(127),
    [anon_sym_ATx_COLON] = ACTIONS(127),
    [anon_sym_SEMI] = ACTIONS(127),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(127),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(129),
    [anon_sym_GT_GT] = ACTIONS(127),
    [sym_html_redirect_operator] = ACTIONS(129),
    [sym_html_append_operator] = ACTIONS(127),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(127),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(127),
  },
  [64] = {
    [sym__Cf_args] = STATE(232),
    [sym__arg_with_paren] = STATE(376),
    [sym__arg] = STATE(376),
    [sym_arg] = STATE(343),
    [sym_arg_identifier] = STATE(376),
    [sym_double_quoted_arg] = STATE(376),
    [sym_single_quoted_arg] = STATE(376),
    [sym_cmd_substitution_arg] = STATE(376),
    [sym_concatenation] = STATE(403),
    [anon_sym_DQUOTE] = ACTIONS(174),
    [anon_sym_TILDE] = ACTIONS(172),
    [anon_sym_PIPE] = ACTIONS(176),
    [anon_sym_PIPEH] = ACTIONS(172),
    [anon_sym_AT_AT_DOT] = ACTIONS(172),
    [anon_sym_AT_AT_EQ] = ACTIONS(172),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(172),
    [anon_sym_AT_AT] = ACTIONS(176),
    [anon_sym_AT_ATc_COLON] = ACTIONS(172),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(172),
    [anon_sym_AT_ATC] = ACTIONS(172),
    [anon_sym_AT_ATdbt] = ACTIONS(176),
    [anon_sym_AT_ATdbta] = ACTIONS(172),
    [anon_sym_AT_ATdbtb] = ACTIONS(172),
    [anon_sym_AT_ATdbts] = ACTIONS(172),
    [anon_sym_AT_ATt] = ACTIONS(172),
    [anon_sym_AT_ATb] = ACTIONS(172),
    [anon_sym_AT_ATi] = ACTIONS(176),
    [anon_sym_AT_ATii] = ACTIONS(172),
    [anon_sym_AT_ATiS] = ACTIONS(176),
    [anon_sym_AT_ATiSS] = ACTIONS(172),
    [anon_sym_AT_ATis] = ACTIONS(172),
    [anon_sym_AT_ATiz] = ACTIONS(172),
    [anon_sym_AT_ATf] = ACTIONS(172),
    [anon_sym_AT_ATF] = ACTIONS(172),
    [anon_sym_AT_ATom] = ACTIONS(172),
    [anon_sym_AT_ATdm] = ACTIONS(172),
    [anon_sym_AT_ATr] = ACTIONS(172),
    [anon_sym_AT_ATs_COLON] = ACTIONS(172),
    [anon_sym_AT] = ACTIONS(172),
    [anon_sym_AT_BANG] = ACTIONS(172),
    [anon_sym_AT_LPAREN] = ACTIONS(172),
    [anon_sym_ATa_COLON] = ACTIONS(172),
    [anon_sym_ATb_COLON] = ACTIONS(172),
    [anon_sym_ATB_COLON] = ACTIONS(172),
    [anon_sym_ATe_COLON] = ACTIONS(172),
    [anon_sym_ATF_COLON] = ACTIONS(172),
    [anon_sym_ATi_COLON] = ACTIONS(172),
    [anon_sym_ATk_COLON] = ACTIONS(172),
    [anon_sym_ATo_COLON] = ACTIONS(172),
    [anon_sym_ATr_COLON] = ACTIONS(172),
    [anon_sym_ATf_COLON] = ACTIONS(172),
    [anon_sym_ATs_COLON] = ACTIONS(172),
    [anon_sym_ATv_COLON] = ACTIONS(172),
    [anon_sym_ATx_COLON] = ACTIONS(172),
    [anon_sym_SEMI] = ACTIONS(172),
    [anon_sym_LPAREN] = ACTIONS(178),
    [anon_sym_PIPE_DOT] = ACTIONS(172),
    [anon_sym_DOLLAR] = ACTIONS(180),
    [anon_sym_GT] = ACTIONS(176),
    [anon_sym_GT_GT] = ACTIONS(172),
    [sym_html_redirect_operator] = ACTIONS(176),
    [sym_html_append_operator] = ACTIONS(172),
    [anon_sym_COMMA] = ACTIONS(182),
    [aux_sym_arg_identifier_token1] = ACTIONS(180),
    [anon_sym_SQUOTE] = ACTIONS(184),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(186),
    [anon_sym_BQUOTE] = ACTIONS(172),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(172),
  },
  [65] = {
    [sym__arg_with_paren] = STATE(73),
    [sym__arg] = STATE(73),
    [sym_arg] = STATE(51),
    [sym_arg_identifier] = STATE(73),
    [sym_double_quoted_arg] = STATE(73),
    [sym_single_quoted_arg] = STATE(73),
    [sym_cmd_substitution_arg] = STATE(73),
    [sym_concatenation] = STATE(91),
    [aux_sym_args_repeat1] = STATE(51),
    [anon_sym_DQUOTE] = ACTIONS(99),
    [anon_sym_TILDE] = ACTIONS(190),
    [anon_sym_PIPE] = ACTIONS(192),
    [anon_sym_PIPEH] = ACTIONS(190),
    [anon_sym_AT_AT_DOT] = ACTIONS(190),
    [anon_sym_AT_AT_EQ] = ACTIONS(190),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(190),
    [anon_sym_AT_AT] = ACTIONS(192),
    [anon_sym_AT_ATc_COLON] = ACTIONS(190),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(190),
    [anon_sym_AT_ATC] = ACTIONS(190),
    [anon_sym_AT_ATdbt] = ACTIONS(192),
    [anon_sym_AT_ATdbta] = ACTIONS(190),
    [anon_sym_AT_ATdbtb] = ACTIONS(190),
    [anon_sym_AT_ATdbts] = ACTIONS(190),
    [anon_sym_AT_ATt] = ACTIONS(190),
    [anon_sym_AT_ATb] = ACTIONS(190),
    [anon_sym_AT_ATi] = ACTIONS(192),
    [anon_sym_AT_ATii] = ACTIONS(190),
    [anon_sym_AT_ATiS] = ACTIONS(192),
    [anon_sym_AT_ATiSS] = ACTIONS(190),
    [anon_sym_AT_ATis] = ACTIONS(190),
    [anon_sym_AT_ATiz] = ACTIONS(190),
    [anon_sym_AT_ATf] = ACTIONS(190),
    [anon_sym_AT_ATF] = ACTIONS(190),
    [anon_sym_AT_ATom] = ACTIONS(190),
    [anon_sym_AT_ATdm] = ACTIONS(190),
    [anon_sym_AT_ATr] = ACTIONS(190),
    [anon_sym_AT_ATs_COLON] = ACTIONS(190),
    [anon_sym_AT] = ACTIONS(190),
    [anon_sym_AT_BANG] = ACTIONS(190),
    [anon_sym_AT_LPAREN] = ACTIONS(190),
    [anon_sym_ATa_COLON] = ACTIONS(190),
    [anon_sym_ATb_COLON] = ACTIONS(190),
    [anon_sym_ATB_COLON] = ACTIONS(190),
    [anon_sym_ATe_COLON] = ACTIONS(190),
    [anon_sym_ATF_COLON] = ACTIONS(190),
    [anon_sym_ATi_COLON] = ACTIONS(190),
    [anon_sym_ATk_COLON] = ACTIONS(190),
    [anon_sym_ATo_COLON] = ACTIONS(190),
    [anon_sym_ATr_COLON] = ACTIONS(190),
    [anon_sym_ATf_COLON] = ACTIONS(190),
    [anon_sym_ATs_COLON] = ACTIONS(190),
    [anon_sym_ATv_COLON] = ACTIONS(190),
    [anon_sym_ATx_COLON] = ACTIONS(190),
    [anon_sym_SEMI] = ACTIONS(190),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_PIPE_DOT] = ACTIONS(190),
    [anon_sym_DOLLAR] = ACTIONS(105),
    [anon_sym_GT] = ACTIONS(192),
    [anon_sym_GT_GT] = ACTIONS(190),
    [sym_html_redirect_operator] = ACTIONS(192),
    [sym_html_append_operator] = ACTIONS(190),
    [anon_sym_COMMA] = ACTIONS(107),
    [aux_sym_arg_identifier_token1] = ACTIONS(105),
    [anon_sym_SQUOTE] = ACTIONS(109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(190),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(190),
  },
  [66] = {
    [sym_eq_sep_args] = STATE(250),
    [sym__eq_sep_key_single] = STATE(118),
    [sym__eq_sep_key_concatenation] = STATE(164),
    [sym__eq_sep_key] = STATE(166),
    [sym_double_quoted_arg] = STATE(118),
    [sym_single_quoted_arg] = STATE(118),
    [sym_cmd_substitution_arg] = STATE(118),
    [ts_builtin_sym_end] = ACTIONS(208),
    [anon_sym_DQUOTE] = ACTIONS(210),
    [anon_sym_TILDE] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(212),
    [anon_sym_PIPEH] = ACTIONS(208),
    [anon_sym_AT_AT_DOT] = ACTIONS(208),
    [anon_sym_AT_AT_EQ] = ACTIONS(208),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(208),
    [anon_sym_AT_AT] = ACTIONS(212),
    [anon_sym_AT_ATc_COLON] = ACTIONS(208),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(208),
    [anon_sym_AT_ATC] = ACTIONS(208),
    [anon_sym_AT_ATdbt] = ACTIONS(212),
    [anon_sym_AT_ATdbta] = ACTIONS(208),
    [anon_sym_AT_ATdbtb] = ACTIONS(208),
    [anon_sym_AT_ATdbts] = ACTIONS(208),
    [anon_sym_AT_ATt] = ACTIONS(208),
    [anon_sym_AT_ATb] = ACTIONS(208),
    [anon_sym_AT_ATi] = ACTIONS(212),
    [anon_sym_AT_ATii] = ACTIONS(208),
    [anon_sym_AT_ATiS] = ACTIONS(212),
    [anon_sym_AT_ATiSS] = ACTIONS(208),
    [anon_sym_AT_ATis] = ACTIONS(208),
    [anon_sym_AT_ATiz] = ACTIONS(208),
    [anon_sym_AT_ATf] = ACTIONS(208),
    [anon_sym_AT_ATF] = ACTIONS(208),
    [anon_sym_AT_ATom] = ACTIONS(208),
    [anon_sym_AT_ATdm] = ACTIONS(208),
    [anon_sym_AT_ATr] = ACTIONS(208),
    [anon_sym_AT_ATs_COLON] = ACTIONS(208),
    [anon_sym_AT] = ACTIONS(208),
    [anon_sym_AT_BANG] = ACTIONS(208),
    [anon_sym_AT_LPAREN] = ACTIONS(208),
    [anon_sym_RPAREN] = ACTIONS(208),
    [anon_sym_ATa_COLON] = ACTIONS(208),
    [anon_sym_ATb_COLON] = ACTIONS(208),
    [anon_sym_ATB_COLON] = ACTIONS(208),
    [anon_sym_ATe_COLON] = ACTIONS(208),
    [anon_sym_ATF_COLON] = ACTIONS(208),
    [anon_sym_ATi_COLON] = ACTIONS(208),
    [anon_sym_ATk_COLON] = ACTIONS(208),
    [anon_sym_ATo_COLON] = ACTIONS(208),
    [anon_sym_ATr_COLON] = ACTIONS(208),
    [anon_sym_ATf_COLON] = ACTIONS(208),
    [anon_sym_ATs_COLON] = ACTIONS(208),
    [anon_sym_ATv_COLON] = ACTIONS(208),
    [anon_sym_ATx_COLON] = ACTIONS(208),
    [anon_sym_SEMI] = ACTIONS(208),
    [anon_sym_PIPE_DOT] = ACTIONS(208),
    [anon_sym_GT] = ACTIONS(212),
    [anon_sym_GT_GT] = ACTIONS(208),
    [sym_html_redirect_operator] = ACTIONS(212),
    [sym_html_append_operator] = ACTIONS(208),
    [sym__eq_sep_key_identifier] = ACTIONS(214),
    [anon_sym_SQUOTE] = ACTIONS(216),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(218),
    [anon_sym_BQUOTE] = ACTIONS(220),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(208),
    [anon_sym_CR] = ACTIONS(208),
    [sym_file_descriptor] = ACTIONS(208),
  },
  [67] = {
    [sym__pf_arg_parentheses] = STATE(96),
    [sym_pf_arg_identifier] = STATE(96),
    [sym__pf_arg] = STATE(96),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(93),
    [sym_pf_args] = STATE(230),
    [sym_cmd_substitution_arg] = STATE(96),
    [aux_sym_pf_args_repeat1] = STATE(93),
    [aux_sym_pf_dot_args_repeat1] = STATE(114),
    [anon_sym_TILDE] = ACTIONS(194),
    [anon_sym_PIPE] = ACTIONS(196),
    [anon_sym_PIPEH] = ACTIONS(194),
    [anon_sym_AT_AT_DOT] = ACTIONS(194),
    [anon_sym_AT_AT_EQ] = ACTIONS(194),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(194),
    [anon_sym_AT_AT] = ACTIONS(196),
    [anon_sym_AT_ATc_COLON] = ACTIONS(194),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(194),
    [anon_sym_AT_ATC] = ACTIONS(194),
    [anon_sym_AT_ATdbt] = ACTIONS(196),
    [anon_sym_AT_ATdbta] = ACTIONS(194),
    [anon_sym_AT_ATdbtb] = ACTIONS(194),
    [anon_sym_AT_ATdbts] = ACTIONS(194),
    [anon_sym_AT_ATt] = ACTIONS(194),
    [anon_sym_AT_ATb] = ACTIONS(194),
    [anon_sym_AT_ATi] = ACTIONS(196),
    [anon_sym_AT_ATii] = ACTIONS(194),
    [anon_sym_AT_ATiS] = ACTIONS(196),
    [anon_sym_AT_ATiSS] = ACTIONS(194),
    [anon_sym_AT_ATis] = ACTIONS(194),
    [anon_sym_AT_ATiz] = ACTIONS(194),
    [anon_sym_AT_ATf] = ACTIONS(194),
    [anon_sym_AT_ATF] = ACTIONS(194),
    [anon_sym_AT_ATom] = ACTIONS(194),
    [anon_sym_AT_ATdm] = ACTIONS(194),
    [anon_sym_AT_ATr] = ACTIONS(194),
    [anon_sym_AT_ATs_COLON] = ACTIONS(194),
    [anon_sym_AT] = ACTIONS(194),
    [anon_sym_AT_BANG] = ACTIONS(194),
    [anon_sym_AT_LPAREN] = ACTIONS(194),
    [anon_sym_ATa_COLON] = ACTIONS(194),
    [anon_sym_ATb_COLON] = ACTIONS(194),
    [anon_sym_ATB_COLON] = ACTIONS(194),
    [anon_sym_ATe_COLON] = ACTIONS(194),
    [anon_sym_ATF_COLON] = ACTIONS(194),
    [anon_sym_ATi_COLON] = ACTIONS(194),
    [anon_sym_ATk_COLON] = ACTIONS(194),
    [anon_sym_ATo_COLON] = ACTIONS(194),
    [anon_sym_ATr_COLON] = ACTIONS(194),
    [anon_sym_ATf_COLON] = ACTIONS(194),
    [anon_sym_ATs_COLON] = ACTIONS(194),
    [anon_sym_ATv_COLON] = ACTIONS(194),
    [anon_sym_ATx_COLON] = ACTIONS(194),
    [anon_sym_SEMI] = ACTIONS(194),
    [anon_sym_LPAREN] = ACTIONS(198),
    [anon_sym_PIPE_DOT] = ACTIONS(194),
    [anon_sym_EQ] = ACTIONS(196),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(200),
    [anon_sym_GT] = ACTIONS(196),
    [anon_sym_GT_GT] = ACTIONS(194),
    [sym_html_redirect_operator] = ACTIONS(196),
    [sym_html_append_operator] = ACTIONS(194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(202),
    [anon_sym_BQUOTE] = ACTIONS(194),
    [sym__comment] = ACTIONS(3),
    [sym_file_descriptor] = ACTIONS(194),
    [sym__concat_pf_dot] = ACTIONS(206),
  },
  [68] = {
    [sym__pf_arg_parentheses] = STATE(96),
    [sym_pf_arg_identifier] = STATE(96),
    [sym__pf_arg] = STATE(96),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(68),
    [sym_cmd_substitution_arg] = STATE(96),
    [aux_sym_pf_args_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(222),
    [anon_sym_TILDE] = ACTIONS(222),
    [anon_sym_PIPE] = ACTIONS(224),
    [anon_sym_PIPEH] = ACTIONS(222),
    [anon_sym_AT_AT_DOT] = ACTIONS(222),
    [anon_sym_AT_AT_EQ] = ACTIONS(222),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(222),
    [anon_sym_AT_AT] = ACTIONS(224),
    [anon_sym_AT_ATc_COLON] = ACTIONS(222),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(222),
    [anon_sym_AT_ATC] = ACTIONS(222),
    [anon_sym_AT_ATdbt] = ACTIONS(224),
    [anon_sym_AT_ATdbta] = ACTIONS(222),
    [anon_sym_AT_ATdbtb] = ACTIONS(222),
    [anon_sym_AT_ATdbts] = ACTIONS(222),
    [anon_sym_AT_ATt] = ACTIONS(222),
    [anon_sym_AT_ATb] = ACTIONS(222),
    [anon_sym_AT_ATi] = ACTIONS(224),
    [anon_sym_AT_ATii] = ACTIONS(222),
    [anon_sym_AT_ATiS] = ACTIONS(224),
    [anon_sym_AT_ATiSS] = ACTIONS(222),
    [anon_sym_AT_ATis] = ACTIONS(222),
    [anon_sym_AT_ATiz] = ACTIONS(222),
    [anon_sym_AT_ATf] = ACTIONS(222),
    [anon_sym_AT_ATF] = ACTIONS(222),
    [anon_sym_AT_ATom] = ACTIONS(222),
    [anon_sym_AT_ATdm] = ACTIONS(222),
    [anon_sym_AT_ATr] = ACTIONS(222),
    [anon_sym_AT_ATs_COLON] = ACTIONS(222),
    [anon_sym_AT] = ACTIONS(222),
    [anon_sym_AT_BANG] = ACTIONS(222),
    [anon_sym_AT_LPAREN] = ACTIONS(222),
    [anon_sym_RPAREN] = ACTIONS(222),
    [anon_sym_ATa_COLON] = ACTIONS(222),
    [anon_sym_ATb_COLON] = ACTIONS(222),
    [anon_sym_ATB_COLON] = ACTIONS(222),
    [anon_sym_ATe_COLON] = ACTIONS(222),
    [anon_sym_ATF_COLON] = ACTIONS(222),
    [anon_sym_ATi_COLON] = ACTIONS(222),
    [anon_sym_ATk_COLON] = ACTIONS(222),
    [anon_sym_ATo_COLON] = ACTIONS(222),
    [anon_sym_ATr_COLON] = ACTIONS(222),
    [anon_sym_ATf_COLON] = ACTIONS(222),
    [anon_sym_ATs_COLON] = ACTIONS(222),
    [anon_sym_ATv_COLON] = ACTIONS(222),
    [anon_sym_ATx_COLON] = ACTIONS(222),
    [anon_sym_SEMI] = ACTIONS(222),
    [anon_sym_LPAREN] = ACTIONS(226),
    [anon_sym_PIPE_DOT] = ACTIONS(222),
    [anon_sym_DOLLAR] = ACTIONS(229),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(229),
    [anon_sym_GT] = ACTIONS(224),
    [anon_sym_GT_GT] = ACTIONS(222),
    [sym_html_redirect_operator] = ACTIONS(224),
    [sym_html_append_operator] = ACTIONS(222),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(232),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(222),
    [anon_sym_CR] = ACTIONS(222),
    [sym_file_descriptor] = ACTIONS(222),
  },
  [69] = {
    [sym__pf_arg_parentheses] = STATE(96),
    [sym_pf_arg_identifier] = STATE(96),
    [sym__pf_arg] = STATE(96),
    [sym_pf_concatenation] = STATE(109),
    [sym_pf_arg] = STATE(68),
    [sym_cmd_substitution_arg] = STATE(96),
    [aux_sym_pf_args_repeat1] = STATE(68),
    [ts_builtin_sym_end] = ACTIONS(238),
    [anon_sym_TILDE] = ACTIONS(238),
    [anon_sym_PIPE] = ACTIONS(240),
    [anon_sym_PIPEH] = ACTIONS(238),
    [anon_sym_AT_AT_DOT] = ACTIONS(238),
    [anon_sym_AT_AT_EQ] = ACTIONS(238),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(238),
    [anon_sym_AT_AT] = ACTIONS(240),
    [anon_sym_AT_ATc_COLON] = ACTIONS(238),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(238),
    [anon_sym_AT_ATC] = ACTIONS(238),
    [anon_sym_AT_ATdbt] = ACTIONS(240),
    [anon_sym_AT_ATdbta] = ACTIONS(238),
    [anon_sym_AT_ATdbtb] = ACTIONS(238),
    [anon_sym_AT_ATdbts] = ACTIONS(238),
    [anon_sym_AT_ATt] = ACTIONS(238),
    [anon_sym_AT_ATb] = ACTIONS(238),
    [anon_sym_AT_ATi] = ACTIONS(240),
    [anon_sym_AT_ATii] = ACTIONS(238),
    [anon_sym_AT_ATiS] = ACTIONS(240),
    [anon_sym_AT_ATiSS] = ACTIONS(238),
    [anon_sym_AT_ATis] = ACTIONS(238),
    [anon_sym_AT_ATiz] = ACTIONS(238),
    [anon_sym_AT_ATf] = ACTIONS(238),
    [anon_sym_AT_ATF] = ACTIONS(238),
    [anon_sym_AT_ATom] = ACTIONS(238),
    [anon_sym_AT_ATdm] = ACTIONS(238),
    [anon_sym_AT_ATr] = ACTIONS(238),
    [anon_sym_AT_ATs_COLON] = ACTIONS(238),
    [anon_sym_AT] = ACTIONS(238),
    [anon_sym_AT_BANG] = ACTIONS(238),
    [anon_sym_AT_LPAREN] = ACTIONS(238),
    [anon_sym_RPAREN] = ACTIONS(238),
    [anon_sym_ATa_COLON] = ACTIONS(238),
    [anon_sym_ATb_COLON] = ACTIONS(238),
    [anon_sym_ATB_COLON] = ACTIONS(238),
    [anon_sym_ATe_COLON] = ACTIONS(238),
    [anon_sym_ATF_COLON] = ACTIONS(238),
    [anon_sym_ATi_COLON] = ACTIONS(238),
    [anon_sym_ATk_COLON] = ACTIONS(238),
    [anon_sym_ATo_COLON] = ACTIONS(238),
    [anon_sym_ATr_COLON] = ACTIONS(238),
    [anon_sym_ATf_COLON] = ACTIONS(238),
    [anon_sym_ATs_COLON] = ACTIONS(238),
    [anon_sym_ATv_COLON] = ACTIONS(238),
    [anon_sym_ATx_COLON] = ACTIONS(238),
    [anon_sym_SEMI] = ACTIONS(238),
    [anon_sym_LPAREN] = ACTIONS(198),
    [anon_sym_PIPE_DOT] = ACTIONS(238),
    [anon_sym_DOLLAR] = ACTIONS(200),
    [aux_sym_pf_arg_identifier_token1] = ACTIONS(200),
    [anon_sym_GT] = ACTIONS(240),
    [anon_sym_GT_GT] = ACTIONS(238),
    [sym_html_redirect_operator] = ACTIONS(240),
    [sym_html_append_operator] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(202),
    [anon_sym_BQUOTE] = ACTIONS(204),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(238),
    [anon_sym_CR] = ACTIONS(238),
    [sym_file_descriptor] = ACTIONS(238),
  },
  [70] = {
    [sym_specifiers] = STATE(92),
    [aux_sym_specifiers_repeat1] = STATE(75),
    [ts_builtin_sym_end] = ACTIONS(242),
    [anon_sym_DQUOTE] = ACTIONS(242),
    [anon_sym_TILDE] = ACTIONS(242),
    [anon_sym_PIPE] = ACTIONS(244),
    [anon_sym_PIPEH] = ACTIONS(242),
    [anon_sym_AT_AT_DOT] = ACTIONS(242),
    [anon_sym_AT_AT_EQ] = ACTIONS(242),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(242),
    [anon_sym_AT_AT] = ACTIONS(244),
    [anon_sym_AT_ATc_COLON] = ACTIONS(242),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(242),
    [anon_sym_AT_ATC] = ACTIONS(242),
    [anon_sym_AT_ATdbt] = ACTIONS(244),
    [anon_sym_AT_ATdbta] = ACTIONS(242),
    [anon_sym_AT_ATdbtb] = ACTIONS(242),
    [anon_sym_AT_ATdbts] = ACTIONS(242),
    [anon_sym_AT_ATt] = ACTIONS(242),
    [anon_sym_AT_ATb] = ACTIONS(242),
    [anon_sym_AT_ATi] = ACTIONS(244),
    [anon_sym_AT_ATii] = ACTIONS(242),
    [anon_sym_AT_ATiS] = ACTIONS(244),
    [anon_sym_AT_ATiSS] = ACTIONS(242),
    [anon_sym_AT_ATis] = ACTIONS(242),
    [anon_sym_AT_ATiz] = ACTIONS(242),
    [anon_sym_AT_ATf] = ACTIONS(242),
    [anon_sym_AT_ATF] = ACTIONS(242),
    [anon_sym_AT_ATom] = ACTIONS(242),
    [anon_sym_AT_ATdm] = ACTIONS(242),
    [anon_sym_AT_ATr] = ACTIONS(242),
    [anon_sym_AT_ATs_COLON] = ACTIONS(242),
    [anon_sym_AT] = ACTIONS(242),
    [anon_sym_AT_BANG] = ACTIONS(242),
    [anon_sym_AT_LPAREN] = ACTIONS(242),
    [anon_sym_RPAREN] = ACTIONS(242),
    [anon_sym_ATa_COLON] = ACTIONS(242),
    [anon_sym_ATb_COLON] = ACTIONS(242),
    [anon_sym_ATB_COLON] = ACTIONS(242),
    [anon_sym_ATe_COLON] = ACTIONS(242),
    [anon_sym_ATF_COLON] = ACTIONS(242),
    [anon_sym_ATi_COLON] = ACTIONS(242),
    [anon_sym_ATk_COLON] = ACTIONS(242),
    [anon_sym_ATo_COLON] = ACTIONS(242),
    [anon_sym_ATr_COLON] = ACTIONS(242),
    [anon_sym_ATf_COLON] = ACTIONS(242),
    [anon_sym_ATs_COLON] = ACTIONS(242),
    [anon_sym_ATv_COLON] = ACTIONS(242),
    [anon_sym_ATx_COLON] = ACTIONS(242),
    [anon_sym_SEMI] = ACTIONS(242),
    [anon_sym_LPAREN] = ACTIONS(242),
    [anon_sym_PIPE_DOT] = ACTIONS(242),
    [anon_sym_DOLLAR] = ACTIONS(244),
    [anon_sym_GT] = ACTIONS(244),
    [anon_sym_GT_GT] = ACTIONS(242),
    [sym_html_redirect_operator] = ACTIONS(244),
    [sym_html_append_operator] = ACTIONS(242),
    [anon_sym_COMMA] = ACTIONS(242),
    [aux_sym_arg_identifier_token1] = ACTIONS(244),
    [anon_sym_SQUOTE] = ACTIONS(242),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(242),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(242),
    [anon_sym_CR] = ACTIONS(242),
    [sym_file_descriptor] = ACTIONS(242),
    [sym__spec_sep] = ACTIONS(246),
  },
  [71] = {
    [aux_sym_concatenation_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(248),
    [anon_sym_DQUOTE] = ACTIONS(248),
    [anon_sym_TILDE] = ACTIONS(248),
    [anon_sym_PIPE] = ACTIONS(250),
    [anon_sym_PIPEH] = ACTIONS(248),
    [anon_sym_AT_AT_DOT] = ACTIONS(248),
    [anon_sym_AT_AT_EQ] = ACTIONS(248),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(248),
    [anon_sym_AT_AT] = ACTIONS(250),
    [anon_sym_AT_ATc_COLON] = ACTIONS(248),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(248),
    [anon_sym_AT_ATC] = ACTIONS(248),
    [anon_sym_AT_ATdbt] = ACTIONS(250),
    [anon_sym_AT_ATdbta] = ACTIONS(248),
    [anon_sym_AT_ATdbtb] = ACTIONS(248),
    [anon_sym_AT_ATdbts] = ACTIONS(248),
    [anon_sym_AT_ATt] = ACTIONS(248),
    [anon_sym_AT_ATb] = ACTIONS(248),
    [anon_sym_AT_ATi] = ACTIONS(250),
    [anon_sym_AT_ATii] = ACTIONS(248),
    [anon_sym_AT_ATiS] = ACTIONS(250),
    [anon_sym_AT_ATiSS] = ACTIONS(248),
    [anon_sym_AT_ATis] = ACTIONS(248),
    [anon_sym_AT_ATiz] = ACTIONS(248),
    [anon_sym_AT_ATf] = ACTIONS(248),
    [anon_sym_AT_ATF] = ACTIONS(248),
    [anon_sym_AT_ATom] = ACTIONS(248),
    [anon_sym_AT_ATdm] = ACTIONS(248),
    [anon_sym_AT_ATr] = ACTIONS(248),
    [anon_sym_AT_ATs_COLON] = ACTIONS(248),
    [anon_sym_AT] = ACTIONS(248),
    [anon_sym_AT_BANG] = ACTIONS(248),
    [anon_sym_AT_LPAREN] = ACTIONS(248),
    [anon_sym_RPAREN] = ACTIONS(248),
    [anon_sym_ATa_COLON] = ACTIONS(248),
    [anon_sym_ATb_COLON] = ACTIONS(248),
    [anon_sym_ATB_COLON] = ACTIONS(248),
    [anon_sym_ATe_COLON] = ACTIONS(248),
    [anon_sym_ATF_COLON] = ACTIONS(248),
    [anon_sym_ATi_COLON] = ACTIONS(248),
    [anon_sym_ATk_COLON] = ACTIONS(248),
    [anon_sym_ATo_COLON] = ACTIONS(248),
    [anon_sym_ATr_COLON] = ACTIONS(248),
    [anon_sym_ATf_COLON] = ACTIONS(248),
    [anon_sym_ATs_COLON] = ACTIONS(248),
    [anon_sym_ATv_COLON] = ACTIONS(248),
    [anon_sym_ATx_COLON] = ACTIONS(248),
    [anon_sym_SEMI] = ACTIONS(248),
    [anon_sym_LPAREN] = ACTIONS(248),
    [anon_sym_PIPE_DOT] = ACTIONS(248),
    [anon_sym_DOLLAR] = ACTIONS(250),
    [anon_sym_GT] = ACTIONS(250),
    [anon_sym_GT_GT] = ACTIONS(248),
    [sym_html_redirect_operator] = ACTIONS(250),
    [sym_html_append_operator] = ACTIONS(248),
    [anon_sym_COMMA] = ACTIONS(248),
    [aux_sym_arg_identifier_token1] = ACTIONS(250),
    [anon_sym_SQUOTE] = ACTIONS(248),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(248),
    [anon_sym_BQUOTE] = ACTIONS(248),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(248),
    [anon_sym_CR] = ACTIONS(248),
    [sym_file_descriptor] = ACTIONS(248),
    [sym__concat] = ACTIONS(252),
  },
  [72] = {
    [aux_sym_specifiers_repeat1] = STATE(72),
    [ts_builtin_sym_end] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [anon_sym_TILDE] = ACTIONS(254),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_PIPEH] = ACTIONS(254),
    [anon_sym_AT_AT_DOT] = ACTIONS(254),
    [anon_sym_AT_AT_EQ] = ACTIONS(254),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(254),
    [anon_sym_AT_AT] = ACTIONS(256),
    [anon_sym_AT_ATc_COLON] = ACTIONS(254),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(254),
    [anon_sym_AT_ATC] = ACTIONS(254),
    [anon_sym_AT_ATdbt] = ACTIONS(256),
    [anon_sym_AT_ATdbta] = ACTIONS(254),
    [anon_sym_AT_ATdbtb] = ACTIONS(254),
    [anon_sym_AT_ATdbts] = ACTIONS(254),
    [anon_sym_AT_ATt] = ACTIONS(254),
    [anon_sym_AT_ATb] = ACTIONS(254),
    [anon_sym_AT_ATi] = ACTIONS(256),
    [anon_sym_AT_ATii] = ACTIONS(254),
    [anon_sym_AT_ATiS] = ACTIONS(256),
    [anon_sym_AT_ATiSS] = ACTIONS(254),
    [anon_sym_AT_ATis] = ACTIONS(254),
    [anon_sym_AT_ATiz] = ACTIONS(254),
    [anon_sym_AT_ATf] = ACTIONS(254),
    [anon_sym_AT_ATF] = ACTIONS(254),
    [anon_sym_AT_ATom] = ACTIONS(254),
    [anon_sym_AT_ATdm] = ACTIONS(254),
    [anon_sym_AT_ATr] = ACTIONS(254),
    [anon_sym_AT_ATs_COLON] = ACTIONS(254),
    [anon_sym_AT] = ACTIONS(254),
    [anon_sym_AT_BANG] = ACTIONS(254),
    [anon_sym_AT_LPAREN] = ACTIONS(254),
    [anon_sym_RPAREN] = ACTIONS(254),
    [anon_sym_ATa_COLON] = ACTIONS(254),
    [anon_sym_ATb_COLON] = ACTIONS(254),
    [anon_sym_ATB_COLON] = ACTIONS(254),
    [anon_sym_ATe_COLON] = ACTIONS(254),
    [anon_sym_ATF_COLON] = ACTIONS(254),
    [anon_sym_ATi_COLON] = ACTIONS(254),
    [anon_sym_ATk_COLON] = ACTIONS(254),
    [anon_sym_ATo_COLON] = ACTIONS(254),
    [anon_sym_ATr_COLON] = ACTIONS(254),
    [anon_sym_ATf_COLON] = ACTIONS(254),
    [anon_sym_ATs_COLON] = ACTIONS(254),
    [anon_sym_ATv_COLON] = ACTIONS(254),
    [anon_sym_ATx_COLON] = ACTIONS(254),
    [anon_sym_SEMI] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(254),
    [anon_sym_PIPE_DOT] = ACTIONS(254),
    [anon_sym_DOLLAR] = ACTIONS(256),
    [anon_sym_GT] = ACTIONS(256),
    [anon_sym_GT_GT] = ACTIONS(254),
    [sym_html_redirect_operator] = ACTIONS(256),
    [sym_html_append_operator] = ACTIONS(254),
    [anon_sym_COMMA] = ACTIONS(254),
    [aux_sym_arg_identifier_token1] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(254),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(254),
    [anon_sym_BQUOTE] = ACTIONS(254),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(254),
    [anon_sym_CR] = ACTIONS(254),
    [sym_file_descriptor] = ACTIONS(254),
    [sym__spec_sep] = ACTIONS(258),
  },
  [73] = {
    [aux_sym_concatenation_repeat1] = STATE(71),
    [ts_builtin_sym_end] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(261),
    [anon_sym_TILDE] = ACTIONS(261),
    [anon_sym_PIPE] = ACTIONS(263),
    [anon_sym_PIPEH] = ACTIONS(261),
    [anon_sym_AT_AT_DOT] = ACTIONS(261),
    [anon_sym_AT_AT_EQ] = ACTIONS(261),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(261),
    [anon_sym_AT_AT] = ACTIONS(263),
    [anon_sym_AT_ATc_COLON] = ACTIONS(261),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(261),
    [anon_sym_AT_ATC] = ACTIONS(261),
    [anon_sym_AT_ATdbt] = ACTIONS(263),
    [anon_sym_AT_ATdbta] = ACTIONS(261),
    [anon_sym_AT_ATdbtb] = ACTIONS(261),
    [anon_sym_AT_ATdbts] = ACTIONS(261),
    [anon_sym_AT_ATt] = ACTIONS(261),
    [anon_sym_AT_ATb] = ACTIONS(261),
    [anon_sym_AT_ATi] = ACTIONS(263),
    [anon_sym_AT_ATii] = ACTIONS(261),
    [anon_sym_AT_ATiS] = ACTIONS(263),
    [anon_sym_AT_ATiSS] = ACTIONS(261),
    [anon_sym_AT_ATis] = ACTIONS(261),
    [anon_sym_AT_ATiz] = ACTIONS(261),
    [anon_sym_AT_ATf] = ACTIONS(261),
    [anon_sym_AT_ATF] = ACTIONS(261),
    [anon_sym_AT_ATom] = ACTIONS(261),
    [anon_sym_AT_ATdm] = ACTIONS(261),
    [anon_sym_AT_ATr] = ACTIONS(261),
    [anon_sym_AT_ATs_COLON] = ACTIONS(261),
    [anon_sym_AT] = ACTIONS(261),
    [anon_sym_AT_BANG] = ACTIONS(261),
    [anon_sym_AT_LPAREN] = ACTIONS(261),
    [anon_sym_RPAREN] = ACTIONS(261),
    [anon_sym_ATa_COLON] = ACTIONS(261),
    [anon_sym_ATb_COLON] = ACTIONS(261),
    [anon_sym_ATB_COLON] = ACTIONS(261),
    [anon_sym_ATe_COLON] = ACTIONS(261),
    [anon_sym_ATF_COLON] = ACTIONS(261),
    [anon_sym_ATi_COLON] = ACTIONS(261),
    [anon_sym_ATk_COLON] = ACTIONS(261),
    [anon_sym_ATo_COLON] = ACTIONS(261),
    [anon_sym_ATr_COLON] = ACTIONS(261),
    [anon_sym_ATf_COLON] = ACTIONS(261),
    [anon_sym_ATs_COLON] = ACTIONS(261),
    [anon_sym_ATv_COLON] = ACTIONS(261),
    [anon_sym_ATx_COLON] = ACTIONS(261),
    [anon_sym_SEMI] = ACTIONS(261),
    [anon_sym_LPAREN] = ACTIONS(261),
    [anon_sym_PIPE_DOT] = ACTIONS(261),
    [anon_sym_DOLLAR] = ACTIONS(263),
    [anon_sym_GT] = ACTIONS(263),
    [anon_sym_GT_GT] = ACTIONS(261),
    [sym_html_redirect_operator] = ACTIONS(263),
    [sym_html_append_operator] = ACTIONS(261),
    [anon_sym_COMMA] = ACTIONS(261),
    [aux_sym_arg_identifier_token1] = ACTIONS(263),
    [anon_sym_SQUOTE] = ACTIONS(261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(261),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(261),
    [anon_sym_CR] = ACTIONS(261),
    [sym_file_descriptor] = ACTIONS(261),
    [sym__concat] = ACTIONS(252),
  },
  [74] = {
    [aux_sym_concatenation_repeat1] = STATE(74),
    [ts_builtin_sym_end] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_PIPE] = ACTIONS(267),
    [anon_sym_PIPEH] = ACTIONS(265),
    [anon_sym_AT_AT_DOT] = ACTIONS(265),
    [anon_sym_AT_AT_EQ] = ACTIONS(265),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(265),
    [anon_sym_AT_AT] = ACTIONS(267),
    [anon_sym_AT_ATc_COLON] = ACTIONS(265),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(265),
    [anon_sym_AT_ATC] = ACTIONS(265),
    [anon_sym_AT_ATdbt] = ACTIONS(267),
    [anon_sym_AT_ATdbta] = ACTIONS(265),
    [anon_sym_AT_ATdbtb] = ACTIONS(265),
    [anon_sym_AT_ATdbts] = ACTIONS(265),
    [anon_sym_AT_ATt] = ACTIONS(265),
    [anon_sym_AT_ATb] = ACTIONS(265),
    [anon_sym_AT_ATi] = ACTIONS(267),
    [anon_sym_AT_ATii] = ACTIONS(265),
    [anon_sym_AT_ATiS] = ACTIONS(267),
    [anon_sym_AT_ATiSS] = ACTIONS(265),
    [anon_sym_AT_ATis] = ACTIONS(265),
    [anon_sym_AT_ATiz] = ACTIONS(265),
    [anon_sym_AT_ATf] = ACTIONS(265),
    [anon_sym_AT_ATF] = ACTIONS(265),
    [anon_sym_AT_ATom] = ACTIONS(265),
    [anon_sym_AT_ATdm] = ACTIONS(265),
    [anon_sym_AT_ATr] = ACTIONS(265),
    [anon_sym_AT_ATs_COLON] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(265),
    [anon_sym_AT_BANG] = ACTIONS(265),
    [anon_sym_AT_LPAREN] = ACTIONS(265),
    [anon_sym_RPAREN] = ACTIONS(265),
    [anon_sym_ATa_COLON] = ACTIONS(265),
    [anon_sym_ATb_COLON] = ACTIONS(265),
    [anon_sym_ATB_COLON] = ACTIONS(265),
    [anon_sym_ATe_COLON] = ACTIONS(265),
    [anon_sym_ATF_COLON] = ACTIONS(265),
    [anon_sym_ATi_COLON] = ACTIONS(265),
    [anon_sym_ATk_COLON] = ACTIONS(265),
    [anon_sym_ATo_COLON] = ACTIONS(265),
    [anon_sym_ATr_COLON] = ACTIONS(265),
    [anon_sym_ATf_COLON] = ACTIONS(265),
    [anon_sym_ATs_COLON] = ACTIONS(265),
    [anon_sym_ATv_COLON] = ACTIONS(265),
    [anon_sym_ATx_COLON] = ACTIONS(265),
    [anon_sym_SEMI] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_PIPE_DOT] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(267),
    [anon_sym_GT] = ACTIONS(267),
    [anon_sym_GT_GT] = ACTIONS(265),
    [sym_html_redirect_operator] = ACTIONS(267),
    [sym_html_append_operator] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(265),
    [aux_sym_arg_identifier_token1] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(265),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(265),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(265),
    [anon_sym_CR] = ACTIONS(265),
    [sym_file_descriptor] = ACTIONS(265),
    [sym__concat] = ACTIONS(269),
  },
  [75] = {
    [aux_sym_specifiers_repeat1] = STATE(72),
    [ts_builtin_sym_end] = ACTIONS(272),
    [anon_sym_DQUOTE] = ACTIONS(272),
    [anon_sym_TILDE] = ACTIONS(272),
    [anon_sym_PIPE] = ACTIONS(274),
    [anon_sym_PIPEH] = ACTIONS(272),
    [anon_sym_AT_AT_DOT] = ACTIONS(272),
    [anon_sym_AT_AT_EQ] = ACTIONS(272),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(272),
    [anon_sym_AT_AT] = ACTIONS(274),
    [anon_sym_AT_ATc_COLON] = ACTIONS(272),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(272),
    [anon_sym_AT_ATC] = ACTIONS(272),
    [anon_sym_AT_ATdbt] = ACTIONS(274),
    [anon_sym_AT_ATdbta] = ACTIONS(272),
    [anon_sym_AT_ATdbtb] = ACTIONS(272),
    [anon_sym_AT_ATdbts] = ACTIONS(272),
    [anon_sym_AT_ATt] = ACTIONS(272),
    [anon_sym_AT_ATb] = ACTIONS(272),
    [anon_sym_AT_ATi] = ACTIONS(274),
    [anon_sym_AT_ATii] = ACTIONS(272),
    [anon_sym_AT_ATiS] = ACTIONS(274),
    [anon_sym_AT_ATiSS] = ACTIONS(272),
    [anon_sym_AT_ATis] = ACTIONS(272),
    [anon_sym_AT_ATiz] = ACTIONS(272),
    [anon_sym_AT_ATf] = ACTIONS(272),
    [anon_sym_AT_ATF] = ACTIONS(272),
    [anon_sym_AT_ATom] = ACTIONS(272),
    [anon_sym_AT_ATdm] = ACTIONS(272),
    [anon_sym_AT_ATr] = ACTIONS(272),
    [anon_sym_AT_ATs_COLON] = ACTIONS(272),
    [anon_sym_AT] = ACTIONS(272),
    [anon_sym_AT_BANG] = ACTIONS(272),
    [anon_sym_AT_LPAREN] = ACTIONS(272),
    [anon_sym_RPAREN] = ACTIONS(272),
    [anon_sym_ATa_COLON] = ACTIONS(272),
    [anon_sym_ATb_COLON] = ACTIONS(272),
    [anon_sym_ATB_COLON] = ACTIONS(272),
    [anon_sym_ATe_COLON] = ACTIONS(272),
    [anon_sym_ATF_COLON] = ACTIONS(272),
    [anon_sym_ATi_COLON] = ACTIONS(272),
    [anon_sym_ATk_COLON] = ACTIONS(272),
    [anon_sym_ATo_COLON] = ACTIONS(272),
    [anon_sym_ATr_COLON] = ACTIONS(272),
    [anon_sym_ATf_COLON] = ACTIONS(272),
    [anon_sym_ATs_COLON] = ACTIONS(272),
    [anon_sym_ATv_COLON] = ACTIONS(272),
    [anon_sym_ATx_COLON] = ACTIONS(272),
    [anon_sym_SEMI] = ACTIONS(272),
    [anon_sym_LPAREN] = ACTIONS(272),
    [anon_sym_PIPE_DOT] = ACTIONS(272),
    [anon_sym_DOLLAR] = ACTIONS(274),
    [anon_sym_GT] = ACTIONS(274),
    [anon_sym_GT_GT] = ACTIONS(272),
    [sym_html_redirect_operator] = ACTIONS(274),
    [sym_html_append_operator] = ACTIONS(272),
    [anon_sym_COMMA] = ACTIONS(272),
    [aux_sym_arg_identifier_token1] = ACTIONS(274),
    [anon_sym_SQUOTE] = ACTIONS(272),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(272),
    [anon_sym_BQUOTE] = ACTIONS(272),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(272),
    [anon_sym_CR] = ACTIONS(272),
    [sym_file_descriptor] = ACTIONS(272),
    [sym__spec_sep] = ACTIONS(246),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(276),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [anon_sym_TILDE] = ACTIONS(276),
    [anon_sym_PIPE] = ACTIONS(278),
    [anon_sym_PIPEH] = ACTIONS(276),
    [anon_sym_AT_AT_DOT] = ACTIONS(276),
    [anon_sym_AT_AT_EQ] = ACTIONS(276),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(276),
    [anon_sym_AT_AT] = ACTIONS(278),
    [anon_sym_AT_ATc_COLON] = ACTIONS(276),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(276),
    [anon_sym_AT_ATC] = ACTIONS(276),
    [anon_sym_AT_ATdbt] = ACTIONS(278),
    [anon_sym_AT_ATdbta] = ACTIONS(276),
    [anon_sym_AT_ATdbtb] = ACTIONS(276),
    [anon_sym_AT_ATdbts] = ACTIONS(276),
    [anon_sym_AT_ATt] = ACTIONS(276),
    [anon_sym_AT_ATb] = ACTIONS(276),
    [anon_sym_AT_ATi] = ACTIONS(278),
    [anon_sym_AT_ATii] = ACTIONS(276),
    [anon_sym_AT_ATiS] = ACTIONS(278),
    [anon_sym_AT_ATiSS] = ACTIONS(276),
    [anon_sym_AT_ATis] = ACTIONS(276),
    [anon_sym_AT_ATiz] = ACTIONS(276),
    [anon_sym_AT_ATf] = ACTIONS(276),
    [anon_sym_AT_ATF] = ACTIONS(276),
    [anon_sym_AT_ATom] = ACTIONS(276),
    [anon_sym_AT_ATdm] = ACTIONS(276),
    [anon_sym_AT_ATr] = ACTIONS(276),
    [anon_sym_AT_ATs_COLON] = ACTIONS(276),
    [anon_sym_AT] = ACTIONS(276),
    [anon_sym_AT_BANG] = ACTIONS(276),
    [anon_sym_AT_LPAREN] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(276),
    [anon_sym_ATa_COLON] = ACTIONS(276),
    [anon_sym_ATb_COLON] = ACTIONS(276),
    [anon_sym_ATB_COLON] = ACTIONS(276),
    [anon_sym_ATe_COLON] = ACTIONS(276),
    [anon_sym_ATF_COLON] = ACTIONS(276),
    [anon_sym_ATi_COLON] = ACTIONS(276),
    [anon_sym_ATk_COLON] = ACTIONS(276),
    [anon_sym_ATo_COLON] = ACTIONS(276),
    [anon_sym_ATr_COLON] = ACTIONS(276),
    [anon_sym_ATf_COLON] = ACTIONS(276),
    [anon_sym_ATs_COLON] = ACTIONS(276),
    [anon_sym_ATv_COLON] = ACTIONS(276),
    [anon_sym_ATx_COLON] = ACTIONS(276),
    [anon_sym_SEMI] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_PIPE_DOT] = ACTIONS(276),
    [anon_sym_DOLLAR] = ACTIONS(278),
    [anon_sym_GT] = ACTIONS(278),
    [anon_sym_GT_GT] = ACTIONS(276),
    [sym_html_redirect_operator] = ACTIONS(278),
    [sym_html_append_operator] = ACTIONS(276),
    [anon_sym_COMMA] = ACTIONS(276),
    [aux_sym_arg_identifier_token1] = ACTIONS(278),
    [anon_sym_SQUOTE] = ACTIONS(276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(276),
    [anon_sym_BQUOTE] = ACTIONS(276),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(276),
    [anon_sym_CR] = ACTIONS(276),
    [sym_file_descriptor] = ACTIONS(276),
    [sym__concat] = ACTIONS(276),
  },
  [77] = {
    [ts_builtin_sym_end] = ACTIONS(280),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_PIPE] = ACTIONS(282),
    [anon_sym_PIPEH] = ACTIONS(280),
    [anon_sym_AT_AT_DOT] = ACTIONS(280),
    [anon_sym_AT_AT_EQ] = ACTIONS(280),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(280),
    [anon_sym_AT_AT] = ACTIONS(282),
    [anon_sym_AT_ATc_COLON] = ACTIONS(280),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(280),
    [anon_sym_AT_ATC] = ACTIONS(280),
    [anon_sym_AT_ATdbt] = ACTIONS(282),
    [anon_sym_AT_ATdbta] = ACTIONS(280),
    [anon_sym_AT_ATdbtb] = ACTIONS(280),
    [anon_sym_AT_ATdbts] = ACTIONS(280),
    [anon_sym_AT_ATt] = ACTIONS(280),
    [anon_sym_AT_ATb] = ACTIONS(280),
    [anon_sym_AT_ATi] = ACTIONS(282),
    [anon_sym_AT_ATii] = ACTIONS(280),
    [anon_sym_AT_ATiS] = ACTIONS(282),
    [anon_sym_AT_ATiSS] = ACTIONS(280),
    [anon_sym_AT_ATis] = ACTIONS(280),
    [anon_sym_AT_ATiz] = ACTIONS(280),
    [anon_sym_AT_ATf] = ACTIONS(280),
    [anon_sym_AT_ATF] = ACTIONS(280),
    [anon_sym_AT_ATom] = ACTIONS(280),
    [anon_sym_AT_ATdm] = ACTIONS(280),
    [anon_sym_AT_ATr] = ACTIONS(280),
    [anon_sym_AT_ATs_COLON] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(280),
    [anon_sym_AT_BANG] = ACTIONS(280),
    [anon_sym_AT_LPAREN] = ACTIONS(280),
    [anon_sym_RPAREN] = ACTIONS(280),
    [anon_sym_ATa_COLON] = ACTIONS(280),
    [anon_sym_ATb_COLON] = ACTIONS(280),
    [anon_sym_ATB_COLON] = ACTIONS(280),
    [anon_sym_ATe_COLON] = ACTIONS(280),
    [anon_sym_ATF_COLON] = ACTIONS(280),
    [anon_sym_ATi_COLON] = ACTIONS(280),
    [anon_sym_ATk_COLON] = ACTIONS(280),
    [anon_sym_ATo_COLON] = ACTIONS(280),
    [anon_sym_ATr_COLON] = ACTIONS(280),
    [anon_sym_ATf_COLON] = ACTIONS(280),
    [anon_sym_ATs_COLON] = ACTIONS(280),
    [anon_sym_ATv_COLON] = ACTIONS(280),
    [anon_sym_ATx_COLON] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(280),
    [anon_sym_LPAREN] = ACTIONS(280),
    [anon_sym_PIPE_DOT] = ACTIONS(280),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_GT] = ACTIONS(282),
    [anon_sym_GT_GT] = ACTIONS(280),
    [sym_html_redirect_operator] = ACTIONS(282),
    [sym_html_append_operator] = ACTIONS(280),
    [anon_sym_COMMA] = ACTIONS(280),
    [aux_sym_arg_identifier_token1] = ACTIONS(282),
    [anon_sym_SQUOTE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(280),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(280),
    [anon_sym_CR] = ACTIONS(280),
    [sym_file_descriptor] = ACTIONS(280),
    [sym__concat] = ACTIONS(280),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(284),
    [anon_sym_DQUOTE] = ACTIONS(284),
    [anon_sym_TILDE] = ACTIONS(284),
    [anon_sym_PIPE] = ACTIONS(286),
    [anon_sym_PIPEH] = ACTIONS(284),
    [anon_sym_AT_AT_DOT] = ACTIONS(284),
    [anon_sym_AT_AT_EQ] = ACTIONS(284),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(284),
    [anon_sym_AT_AT] = ACTIONS(286),
    [anon_sym_AT_ATc_COLON] = ACTIONS(284),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(284),
    [anon_sym_AT_ATC] = ACTIONS(284),
    [anon_sym_AT_ATdbt] = ACTIONS(286),
    [anon_sym_AT_ATdbta] = ACTIONS(284),
    [anon_sym_AT_ATdbtb] = ACTIONS(284),
    [anon_sym_AT_ATdbts] = ACTIONS(284),
    [anon_sym_AT_ATt] = ACTIONS(284),
    [anon_sym_AT_ATb] = ACTIONS(284),
    [anon_sym_AT_ATi] = ACTIONS(286),
    [anon_sym_AT_ATii] = ACTIONS(284),
    [anon_sym_AT_ATiS] = ACTIONS(286),
    [anon_sym_AT_ATiSS] = ACTIONS(284),
    [anon_sym_AT_ATis] = ACTIONS(284),
    [anon_sym_AT_ATiz] = ACTIONS(284),
    [anon_sym_AT_ATf] = ACTIONS(284),
    [anon_sym_AT_ATF] = ACTIONS(284),
    [anon_sym_AT_ATom] = ACTIONS(284),
    [anon_sym_AT_ATdm] = ACTIONS(284),
    [anon_sym_AT_ATr] = ACTIONS(284),
    [anon_sym_AT_ATs_COLON] = ACTIONS(284),
    [anon_sym_AT] = ACTIONS(284),
    [anon_sym_AT_BANG] = ACTIONS(284),
    [anon_sym_AT_LPAREN] = ACTIONS(284),
    [anon_sym_RPAREN] = ACTIONS(284),
    [anon_sym_ATa_COLON] = ACTIONS(284),
    [anon_sym_ATb_COLON] = ACTIONS(284),
    [anon_sym_ATB_COLON] = ACTIONS(284),
    [anon_sym_ATe_COLON] = ACTIONS(284),
    [anon_sym_ATF_COLON] = ACTIONS(284),
    [anon_sym_ATi_COLON] = ACTIONS(284),
    [anon_sym_ATk_COLON] = ACTIONS(284),
    [anon_sym_ATo_COLON] = ACTIONS(284),
    [anon_sym_ATr_COLON] = ACTIONS(284),
    [anon_sym_ATf_COLON] = ACTIONS(284),
    [anon_sym_ATs_COLON] = ACTIONS(284),
    [anon_sym_ATv_COLON] = ACTIONS(284),
    [anon_sym_ATx_COLON] = ACTIONS(284),
    [anon_sym_SEMI] = ACTIONS(284),
    [anon_sym_LPAREN] = ACTIONS(284),
    [anon_sym_PIPE_DOT] = ACTIONS(284),
    [anon_sym_DOLLAR] = ACTIONS(286),
    [anon_sym_GT] = ACTIONS(286),
    [anon_sym_GT_GT] = ACTIONS(284),
    [sym_html_redirect_operator] = ACTIONS(286),
    [sym_html_append_operator] = ACTIONS(284),
    [anon_sym_COMMA] = ACTIONS(284),
    [aux_sym_arg_identifier_token1] = ACTIONS(286),
    [anon_sym_SQUOTE] = ACTIONS(284),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(284),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(284),
    [anon_sym_CR] = ACTIONS(284),
    [sym_file_descriptor] = ACTIONS(284),
    [sym__concat] = ACTIONS(284),
  },
  [79] = {
    [ts_builtin_sym_end] = ACTIONS(288),
    [anon_sym_DQUOTE] = ACTIONS(288),
    [anon_sym_TILDE] = ACTIONS(288),
    [anon_sym_PIPE] = ACTIONS(290),
    [anon_sym_PIPEH] = ACTIONS(288),
    [anon_sym_AT_AT_DOT] = ACTIONS(288),
    [anon_sym_AT_AT_EQ] = ACTIONS(288),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(288),
    [anon_sym_AT_AT] = ACTIONS(290),
    [anon_sym_AT_ATc_COLON] = ACTIONS(288),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(288),
    [anon_sym_AT_ATC] = ACTIONS(288),
    [anon_sym_AT_ATdbt] = ACTIONS(290),
    [anon_sym_AT_ATdbta] = ACTIONS(288),
    [anon_sym_AT_ATdbtb] = ACTIONS(288),
    [anon_sym_AT_ATdbts] = ACTIONS(288),
    [anon_sym_AT_ATt] = ACTIONS(288),
    [anon_sym_AT_ATb] = ACTIONS(288),
    [anon_sym_AT_ATi] = ACTIONS(290),
    [anon_sym_AT_ATii] = ACTIONS(288),
    [anon_sym_AT_ATiS] = ACTIONS(290),
    [anon_sym_AT_ATiSS] = ACTIONS(288),
    [anon_sym_AT_ATis] = ACTIONS(288),
    [anon_sym_AT_ATiz] = ACTIONS(288),
    [anon_sym_AT_ATf] = ACTIONS(288),
    [anon_sym_AT_ATF] = ACTIONS(288),
    [anon_sym_AT_ATom] = ACTIONS(288),
    [anon_sym_AT_ATdm] = ACTIONS(288),
    [anon_sym_AT_ATr] = ACTIONS(288),
    [anon_sym_AT_ATs_COLON] = ACTIONS(288),
    [anon_sym_AT] = ACTIONS(288),
    [anon_sym_AT_BANG] = ACTIONS(288),
    [anon_sym_AT_LPAREN] = ACTIONS(288),
    [anon_sym_RPAREN] = ACTIONS(288),
    [anon_sym_ATa_COLON] = ACTIONS(288),
    [anon_sym_ATb_COLON] = ACTIONS(288),
    [anon_sym_ATB_COLON] = ACTIONS(288),
    [anon_sym_ATe_COLON] = ACTIONS(288),
    [anon_sym_ATF_COLON] = ACTIONS(288),
    [anon_sym_ATi_COLON] = ACTIONS(288),
    [anon_sym_ATk_COLON] = ACTIONS(288),
    [anon_sym_ATo_COLON] = ACTIONS(288),
    [anon_sym_ATr_COLON] = ACTIONS(288),
    [anon_sym_ATf_COLON] = ACTIONS(288),
    [anon_sym_ATs_COLON] = ACTIONS(288),
    [anon_sym_ATv_COLON] = ACTIONS(288),
    [anon_sym_ATx_COLON] = ACTIONS(288),
    [anon_sym_SEMI] = ACTIONS(288),
    [anon_sym_LPAREN] = ACTIONS(288),
    [anon_sym_PIPE_DOT] = ACTIONS(288),
    [anon_sym_DOLLAR] = ACTIONS(290),
    [anon_sym_GT] = ACTIONS(290),
    [anon_sym_GT_GT] = ACTIONS(288),
    [sym_html_redirect_operator] = ACTIONS(290),
    [sym_html_append_operator] = ACTIONS(288),
    [anon_sym_COMMA] = ACTIONS(288),
    [aux_sym_arg_identifier_token1] = ACTIONS(290),
    [anon_sym_SQUOTE] = ACTIONS(288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(288),
    [anon_sym_BQUOTE] = ACTIONS(288),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(288),
    [anon_sym_CR] = ACTIONS(288),
    [sym_file_descriptor] = ACTIONS(288),
    [sym__concat] = ACTIONS(288),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [anon_sym_TILDE] = ACTIONS(292),
    [anon_sym_PIPE] = ACTIONS(294),
    [anon_sym_PIPEH] = ACTIONS(292),
    [anon_sym_AT_AT_DOT] = ACTIONS(292),
    [anon_sym_AT_AT_EQ] = ACTIONS(292),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(292),
    [anon_sym_AT_AT] = ACTIONS(294),
    [anon_sym_AT_ATc_COLON] = ACTIONS(292),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(292),
    [anon_sym_AT_ATC] = ACTIONS(292),
    [anon_sym_AT_ATdbt] = ACTIONS(294),
    [anon_sym_AT_ATdbta] = ACTIONS(292),
    [anon_sym_AT_ATdbtb] = ACTIONS(292),
    [anon_sym_AT_ATdbts] = ACTIONS(292),
    [anon_sym_AT_ATt] = ACTIONS(292),
    [anon_sym_AT_ATb] = ACTIONS(292),
    [anon_sym_AT_ATi] = ACTIONS(294),
    [anon_sym_AT_ATii] = ACTIONS(292),
    [anon_sym_AT_ATiS] = ACTIONS(294),
    [anon_sym_AT_ATiSS] = ACTIONS(292),
    [anon_sym_AT_ATis] = ACTIONS(292),
    [anon_sym_AT_ATiz] = ACTIONS(292),
    [anon_sym_AT_ATf] = ACTIONS(292),
    [anon_sym_AT_ATF] = ACTIONS(292),
    [anon_sym_AT_ATom] = ACTIONS(292),
    [anon_sym_AT_ATdm] = ACTIONS(292),
    [anon_sym_AT_ATr] = ACTIONS(292),
    [anon_sym_AT_ATs_COLON] = ACTIONS(292),
    [anon_sym_AT] = ACTIONS(292),
    [anon_sym_AT_BANG] = ACTIONS(292),
    [anon_sym_AT_LPAREN] = ACTIONS(292),
    [anon_sym_RPAREN] = ACTIONS(292),
    [anon_sym_ATa_COLON] = ACTIONS(292),
    [anon_sym_ATb_COLON] = ACTIONS(292),
    [anon_sym_ATB_COLON] = ACTIONS(292),
    [anon_sym_ATe_COLON] = ACTIONS(292),
    [anon_sym_ATF_COLON] = ACTIONS(292),
    [anon_sym_ATi_COLON] = ACTIONS(292),
    [anon_sym_ATk_COLON] = ACTIONS(292),
    [anon_sym_ATo_COLON] = ACTIONS(292),
    [anon_sym_ATr_COLON] = ACTIONS(292),
    [anon_sym_ATf_COLON] = ACTIONS(292),
    [anon_sym_ATs_COLON] = ACTIONS(292),
    [anon_sym_ATv_COLON] = ACTIONS(292),
    [anon_sym_ATx_COLON] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(292),
    [anon_sym_LPAREN] = ACTIONS(292),
    [anon_sym_PIPE_DOT] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(292),
    [sym_html_redirect_operator] = ACTIONS(294),
    [sym_html_append_operator] = ACTIONS(292),
    [anon_sym_COMMA] = ACTIONS(292),
    [aux_sym_arg_identifier_token1] = ACTIONS(294),
    [anon_sym_SQUOTE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(292),
    [anon_sym_CR] = ACTIONS(292),
    [sym_file_descriptor] = ACTIONS(292),
    [sym__concat] = ACTIONS(292),
  },
  [81] = {
    [ts_builtin_sym_end] = ACTIONS(296),
    [anon_sym_DQUOTE] = ACTIONS(296),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PIPE] = ACTIONS(298),
    [anon_sym_PIPEH] = ACTIONS(296),
    [anon_sym_AT_AT_DOT] = ACTIONS(296),
    [anon_sym_AT_AT_EQ] = ACTIONS(296),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(296),
    [anon_sym_AT_AT] = ACTIONS(298),
    [anon_sym_AT_ATc_COLON] = ACTIONS(296),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(296),
    [anon_sym_AT_ATC] = ACTIONS(296),
    [anon_sym_AT_ATdbt] = ACTIONS(298),
    [anon_sym_AT_ATdbta] = ACTIONS(296),
    [anon_sym_AT_ATdbtb] = ACTIONS(296),
    [anon_sym_AT_ATdbts] = ACTIONS(296),
    [anon_sym_AT_ATt] = ACTIONS(296),
    [anon_sym_AT_ATb] = ACTIONS(296),
    [anon_sym_AT_ATi] = ACTIONS(298),
    [anon_sym_AT_ATii] = ACTIONS(296),
    [anon_sym_AT_ATiS] = ACTIONS(298),
    [anon_sym_AT_ATiSS] = ACTIONS(296),
    [anon_sym_AT_ATis] = ACTIONS(296),
    [anon_sym_AT_ATiz] = ACTIONS(296),
    [anon_sym_AT_ATf] = ACTIONS(296),
    [anon_sym_AT_ATF] = ACTIONS(296),
    [anon_sym_AT_ATom] = ACTIONS(296),
    [anon_sym_AT_ATdm] = ACTIONS(296),
    [anon_sym_AT_ATr] = ACTIONS(296),
    [anon_sym_AT_ATs_COLON] = ACTIONS(296),
    [anon_sym_AT] = ACTIONS(296),
    [anon_sym_AT_BANG] = ACTIONS(296),
    [anon_sym_AT_LPAREN] = ACTIONS(296),
    [anon_sym_RPAREN] = ACTIONS(296),
    [anon_sym_ATa_COLON] = ACTIONS(296),
    [anon_sym_ATb_COLON] = ACTIONS(296),
    [anon_sym_ATB_COLON] = ACTIONS(296),
    [anon_sym_ATe_COLON] = ACTIONS(296),
    [anon_sym_ATF_COLON] = ACTIONS(296),
    [anon_sym_ATi_COLON] = ACTIONS(296),
    [anon_sym_ATk_COLON] = ACTIONS(296),
    [anon_sym_ATo_COLON] = ACTIONS(296),
    [anon_sym_ATr_COLON] = ACTIONS(296),
    [anon_sym_ATf_COLON] = ACTIONS(296),
    [anon_sym_ATs_COLON] = ACTIONS(296),
    [anon_sym_ATv_COLON] = ACTIONS(296),
    [anon_sym_ATx_COLON] = ACTIONS(296),
    [anon_sym_SEMI] = ACTIONS(296),
    [anon_sym_LPAREN] = ACTIONS(296),
    [anon_sym_PIPE_DOT] = ACTIONS(296),
    [anon_sym_DOLLAR] = ACTIONS(298),
    [anon_sym_GT] = ACTIONS(298),
    [anon_sym_GT_GT] = ACTIONS(296),
    [sym_html_redirect_operator] = ACTIONS(298),
    [sym_html_append_operator] = ACTIONS(296),
    [anon_sym_COMMA] = ACTIONS(296),
    [aux_sym_arg_identifier_token1] = ACTIONS(298),
    [anon_sym_SQUOTE] = ACTIONS(296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(296),
    [anon_sym_BQUOTE] = ACTIONS(296),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(296),
    [anon_sym_CR] = ACTIONS(296),
    [sym_file_descriptor] = ACTIONS(296),
    [sym__concat] = ACTIONS(296),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(280),
    [anon_sym_DQUOTE] = ACTIONS(280),
    [anon_sym_TILDE] = ACTIONS(280),
    [anon_sym_PIPE] = ACTIONS(282),
    [anon_sym_PIPEH] = ACTIONS(280),
    [anon_sym_AT_AT_DOT] = ACTIONS(280),
    [anon_sym_AT_AT_EQ] = ACTIONS(280),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(280),
    [anon_sym_AT_AT] = ACTIONS(282),
    [anon_sym_AT_ATc_COLON] = ACTIONS(280),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(280),
    [anon_sym_AT_ATC] = ACTIONS(280),
    [anon_sym_AT_ATdbt] = ACTIONS(282),
    [anon_sym_AT_ATdbta] = ACTIONS(280),
    [anon_sym_AT_ATdbtb] = ACTIONS(280),
    [anon_sym_AT_ATdbts] = ACTIONS(280),
    [anon_sym_AT_ATt] = ACTIONS(280),
    [anon_sym_AT_ATb] = ACTIONS(280),
    [anon_sym_AT_ATi] = ACTIONS(282),
    [anon_sym_AT_ATii] = ACTIONS(280),
    [anon_sym_AT_ATiS] = ACTIONS(282),
    [anon_sym_AT_ATiSS] = ACTIONS(280),
    [anon_sym_AT_ATis] = ACTIONS(280),
    [anon_sym_AT_ATiz] = ACTIONS(280),
    [anon_sym_AT_ATf] = ACTIONS(280),
    [anon_sym_AT_ATF] = ACTIONS(280),
    [anon_sym_AT_ATom] = ACTIONS(280),
    [anon_sym_AT_ATdm] = ACTIONS(280),
    [anon_sym_AT_ATr] = ACTIONS(280),
    [anon_sym_AT_ATs_COLON] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(280),
    [anon_sym_AT_BANG] = ACTIONS(280),
    [anon_sym_AT_LPAREN] = ACTIONS(280),
    [anon_sym_RPAREN] = ACTIONS(280),
    [anon_sym_ATa_COLON] = ACTIONS(280),
    [anon_sym_ATb_COLON] = ACTIONS(280),
    [anon_sym_ATB_COLON] = ACTIONS(280),
    [anon_sym_ATe_COLON] = ACTIONS(280),
    [anon_sym_ATF_COLON] = ACTIONS(280),
    [anon_sym_ATi_COLON] = ACTIONS(280),
    [anon_sym_ATk_COLON] = ACTIONS(280),
    [anon_sym_ATo_COLON] = ACTIONS(280),
    [anon_sym_ATr_COLON] = ACTIONS(280),
    [anon_sym_ATf_COLON] = ACTIONS(280),
    [anon_sym_ATs_COLON] = ACTIONS(280),
    [anon_sym_ATv_COLON] = ACTIONS(280),
    [anon_sym_ATx_COLON] = ACTIONS(280),
    [anon_sym_SEMI] = ACTIONS(280),
    [anon_sym_LPAREN] = ACTIONS(280),
    [anon_sym_PIPE_DOT] = ACTIONS(280),
    [anon_sym_DOLLAR] = ACTIONS(282),
    [anon_sym_GT] = ACTIONS(282),
    [anon_sym_GT_GT] = ACTIONS(280),
    [sym_html_redirect_operator] = ACTIONS(282),
    [sym_html_append_operator] = ACTIONS(280),
    [anon_sym_COMMA] = ACTIONS(280),
    [aux_sym_arg_identifier_token1] = ACTIONS(282),
    [anon_sym_SQUOTE] = ACTIONS(280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(280),
    [anon_sym_BQUOTE] = ACTIONS(280),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(280),
    [anon_sym_CR] = ACTIONS(280),
    [sym_file_descriptor] = ACTIONS(280),
    [sym__concat] = ACTIONS(280),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(265),
    [anon_sym_DQUOTE] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_PIPE] = ACTIONS(267),
    [anon_sym_PIPEH] = ACTIONS(265),
    [anon_sym_AT_AT_DOT] = ACTIONS(265),
    [anon_sym_AT_AT_EQ] = ACTIONS(265),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(265),
    [anon_sym_AT_AT] = ACTIONS(267),
    [anon_sym_AT_ATc_COLON] = ACTIONS(265),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(265),
    [anon_sym_AT_ATC] = ACTIONS(265),
    [anon_sym_AT_ATdbt] = ACTIONS(267),
    [anon_sym_AT_ATdbta] = ACTIONS(265),
    [anon_sym_AT_ATdbtb] = ACTIONS(265),
    [anon_sym_AT_ATdbts] = ACTIONS(265),
    [anon_sym_AT_ATt] = ACTIONS(265),
    [anon_sym_AT_ATb] = ACTIONS(265),
    [anon_sym_AT_ATi] = ACTIONS(267),
    [anon_sym_AT_ATii] = ACTIONS(265),
    [anon_sym_AT_ATiS] = ACTIONS(267),
    [anon_sym_AT_ATiSS] = ACTIONS(265),
    [anon_sym_AT_ATis] = ACTIONS(265),
    [anon_sym_AT_ATiz] = ACTIONS(265),
    [anon_sym_AT_ATf] = ACTIONS(265),
    [anon_sym_AT_ATF] = ACTIONS(265),
    [anon_sym_AT_ATom] = ACTIONS(265),
    [anon_sym_AT_ATdm] = ACTIONS(265),
    [anon_sym_AT_ATr] = ACTIONS(265),
    [anon_sym_AT_ATs_COLON] = ACTIONS(265),
    [anon_sym_AT] = ACTIONS(265),
    [anon_sym_AT_BANG] = ACTIONS(265),
    [anon_sym_AT_LPAREN] = ACTIONS(265),
    [anon_sym_RPAREN] = ACTIONS(265),
    [anon_sym_ATa_COLON] = ACTIONS(265),
    [anon_sym_ATb_COLON] = ACTIONS(265),
    [anon_sym_ATB_COLON] = ACTIONS(265),
    [anon_sym_ATe_COLON] = ACTIONS(265),
    [anon_sym_ATF_COLON] = ACTIONS(265),
    [anon_sym_ATi_COLON] = ACTIONS(265),
    [anon_sym_ATk_COLON] = ACTIONS(265),
    [anon_sym_ATo_COLON] = ACTIONS(265),
    [anon_sym_ATr_COLON] = ACTIONS(265),
    [anon_sym_ATf_COLON] = ACTIONS(265),
    [anon_sym_ATs_COLON] = ACTIONS(265),
    [anon_sym_ATv_COLON] = ACTIONS(265),
    [anon_sym_ATx_COLON] = ACTIONS(265),
    [anon_sym_SEMI] = ACTIONS(265),
    [anon_sym_LPAREN] = ACTIONS(265),
    [anon_sym_PIPE_DOT] = ACTIONS(265),
    [anon_sym_DOLLAR] = ACTIONS(267),
    [anon_sym_GT] = ACTIONS(267),
    [anon_sym_GT_GT] = ACTIONS(265),
    [sym_html_redirect_operator] = ACTIONS(267),
    [sym_html_append_operator] = ACTIONS(265),
    [anon_sym_COMMA] = ACTIONS(265),
    [aux_sym_arg_identifier_token1] = ACTIONS(267),
    [anon_sym_SQUOTE] = ACTIONS(265),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_BQUOTE] = ACTIONS(265),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(265),
    [anon_sym_CR] = ACTIONS(265),
    [sym_file_descriptor] = ACTIONS(265),
    [sym__concat] = ACTIONS(265),
  },
  [84] = {
    [ts_builtin_sym_end] = ACTIONS(300),
    [anon_sym_DQUOTE] = ACTIONS(300),
    [anon_sym_TILDE] = ACTIONS(300),
    [anon_sym_PIPE] = ACTIONS(302),
    [anon_sym_PIPEH] = ACTIONS(300),
    [anon_sym_AT_AT_DOT] = ACTIONS(300),
    [anon_sym_AT_AT_EQ] = ACTIONS(300),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(300),
    [anon_sym_AT_AT] = ACTIONS(302),
    [anon_sym_AT_ATc_COLON] = ACTIONS(300),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(300),
    [anon_sym_AT_ATC] = ACTIONS(300),
    [anon_sym_AT_ATdbt] = ACTIONS(302),
    [anon_sym_AT_ATdbta] = ACTIONS(300),
    [anon_sym_AT_ATdbtb] = ACTIONS(300),
    [anon_sym_AT_ATdbts] = ACTIONS(300),
    [anon_sym_AT_ATt] = ACTIONS(300),
    [anon_sym_AT_ATb] = ACTIONS(300),
    [anon_sym_AT_ATi] = ACTIONS(302),
    [anon_sym_AT_ATii] = ACTIONS(300),
    [anon_sym_AT_ATiS] = ACTIONS(302),
    [anon_sym_AT_ATiSS] = ACTIONS(300),
    [anon_sym_AT_ATis] = ACTIONS(300),
    [anon_sym_AT_ATiz] = ACTIONS(300),
    [anon_sym_AT_ATf] = ACTIONS(300),
    [anon_sym_AT_ATF] = ACTIONS(300),
    [anon_sym_AT_ATom] = ACTIONS(300),
    [anon_sym_AT_ATdm] = ACTIONS(300),
    [anon_sym_AT_ATr] = ACTIONS(300),
    [anon_sym_AT_ATs_COLON] = ACTIONS(300),
    [anon_sym_AT] = ACTIONS(300),
    [anon_sym_AT_BANG] = ACTIONS(300),
    [anon_sym_AT_LPAREN] = ACTIONS(300),
    [anon_sym_RPAREN] = ACTIONS(300),
    [anon_sym_ATa_COLON] = ACTIONS(300),
    [anon_sym_ATb_COLON] = ACTIONS(300),
    [anon_sym_ATB_COLON] = ACTIONS(300),
    [anon_sym_ATe_COLON] = ACTIONS(300),
    [anon_sym_ATF_COLON] = ACTIONS(300),
    [anon_sym_ATi_COLON] = ACTIONS(300),
    [anon_sym_ATk_COLON] = ACTIONS(300),
    [anon_sym_ATo_COLON] = ACTIONS(300),
    [anon_sym_ATr_COLON] = ACTIONS(300),
    [anon_sym_ATf_COLON] = ACTIONS(300),
    [anon_sym_ATs_COLON] = ACTIONS(300),
    [anon_sym_ATv_COLON] = ACTIONS(300),
    [anon_sym_ATx_COLON] = ACTIONS(300),
    [anon_sym_SEMI] = ACTIONS(300),
    [anon_sym_LPAREN] = ACTIONS(300),
    [anon_sym_PIPE_DOT] = ACTIONS(300),
    [anon_sym_DOLLAR] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(302),
    [anon_sym_GT_GT] = ACTIONS(300),
    [sym_html_redirect_operator] = ACTIONS(302),
    [sym_html_append_operator] = ACTIONS(300),
    [anon_sym_COMMA] = ACTIONS(300),
    [aux_sym_arg_identifier_token1] = ACTIONS(302),
    [anon_sym_SQUOTE] = ACTIONS(300),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(300),
    [anon_sym_BQUOTE] = ACTIONS(300),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(300),
    [anon_sym_CR] = ACTIONS(300),
    [sym_file_descriptor] = ACTIONS(300),
    [sym__spec_sep] = ACTIONS(300),
  },
  [85] = {
    [ts_builtin_sym_end] = ACTIONS(304),
    [anon_sym_DQUOTE] = ACTIONS(304),
    [anon_sym_TILDE] = ACTIONS(304),
    [anon_sym_PIPE] = ACTIONS(306),
    [anon_sym_PIPEH] = ACTIONS(304),
    [anon_sym_AT_AT_DOT] = ACTIONS(304),
    [anon_sym_AT_AT_EQ] = ACTIONS(304),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(304),
    [anon_sym_AT_AT] = ACTIONS(306),
    [anon_sym_AT_ATc_COLON] = ACTIONS(304),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(304),
    [anon_sym_AT_ATC] = ACTIONS(304),
    [anon_sym_AT_ATdbt] = ACTIONS(306),
    [anon_sym_AT_ATdbta] = ACTIONS(304),
    [anon_sym_AT_ATdbtb] = ACTIONS(304),
    [anon_sym_AT_ATdbts] = ACTIONS(304),
    [anon_sym_AT_ATt] = ACTIONS(304),
    [anon_sym_AT_ATb] = ACTIONS(304),
    [anon_sym_AT_ATi] = ACTIONS(306),
    [anon_sym_AT_ATii] = ACTIONS(304),
    [anon_sym_AT_ATiS] = ACTIONS(306),
    [anon_sym_AT_ATiSS] = ACTIONS(304),
    [anon_sym_AT_ATis] = ACTIONS(304),
    [anon_sym_AT_ATiz] = ACTIONS(304),
    [anon_sym_AT_ATf] = ACTIONS(304),
    [anon_sym_AT_ATF] = ACTIONS(304),
    [anon_sym_AT_ATom] = ACTIONS(304),
    [anon_sym_AT_ATdm] = ACTIONS(304),
    [anon_sym_AT_ATr] = ACTIONS(304),
    [anon_sym_AT_ATs_COLON] = ACTIONS(304),
    [anon_sym_AT] = ACTIONS(304),
    [anon_sym_AT_BANG] = ACTIONS(304),
    [anon_sym_AT_LPAREN] = ACTIONS(304),
    [anon_sym_RPAREN] = ACTIONS(304),
    [anon_sym_ATa_COLON] = ACTIONS(304),
    [anon_sym_ATb_COLON] = ACTIONS(304),
    [anon_sym_ATB_COLON] = ACTIONS(304),
    [anon_sym_ATe_COLON] = ACTIONS(304),
    [anon_sym_ATF_COLON] = ACTIONS(304),
    [anon_sym_ATi_COLON] = ACTIONS(304),
    [anon_sym_ATk_COLON] = ACTIONS(304),
    [anon_sym_ATo_COLON] = ACTIONS(304),
    [anon_sym_ATr_COLON] = ACTIONS(304),
    [anon_sym_ATf_COLON] = ACTIONS(304),
    [anon_sym_ATs_COLON] = ACTIONS(304),
    [anon_sym_ATv_COLON] = ACTIONS(304),
    [anon_sym_ATx_COLON] = ACTIONS(304),
    [anon_sym_SEMI] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(304),
    [anon_sym_PIPE_DOT] = ACTIONS(304),
    [anon_sym_DOLLAR] = ACTIONS(306),
    [anon_sym_GT] = ACTIONS(306),
    [anon_sym_GT_GT] = ACTIONS(304),
    [sym_html_redirect_operator] = ACTIONS(306),
    [sym_html_append_operator] = ACTIONS(304),
    [anon_sym_COMMA] = ACTIONS(304),
    [aux_sym_arg_identifier_token1] = ACTIONS(306),
    [anon_sym_SQUOTE] = ACTIONS(304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(304),
    [anon_sym_BQUOTE] = ACTIONS(304),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(304),
    [anon_sym_CR] = ACTIONS(304),
    [sym_file_descriptor] = ACTIONS(304),
    [sym__spec_sep] = ACTIONS(304),
  },
  [86] = {
    [ts_builtin_sym_end] = ACTIONS(308),
    [anon_sym_DQUOTE] = ACTIONS(308),
    [anon_sym_TILDE] = ACTIONS(308),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_PIPEH] = ACTIONS(308),
    [anon_sym_AT_AT_DOT] = ACTIONS(308),
    [anon_sym_AT_AT_EQ] = ACTIONS(308),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(308),
    [anon_sym_AT_AT] = ACTIONS(310),
    [anon_sym_AT_ATc_COLON] = ACTIONS(308),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(308),
    [anon_sym_AT_ATC] = ACTIONS(308),
    [anon_sym_AT_ATdbt] = ACTIONS(310),
    [anon_sym_AT_ATdbta] = ACTIONS(308),
    [anon_sym_AT_ATdbtb] = ACTIONS(308),
    [anon_sym_AT_ATdbts] = ACTIONS(308),
    [anon_sym_AT_ATt] = ACTIONS(308),
    [anon_sym_AT_ATb] = ACTIONS(308),
    [anon_sym_AT_ATi] = ACTIONS(310),
    [anon_sym_AT_ATii] = ACTIONS(308),
    [anon_sym_AT_ATiS] = ACTIONS(310),
    [anon_sym_AT_ATiSS] = ACTIONS(308),
    [anon_sym_AT_ATis] = ACTIONS(308),
    [anon_sym_AT_ATiz] = ACTIONS(308),
    [anon_sym_AT_ATf] = ACTIONS(308),
    [anon_sym_AT_ATF] = ACTIONS(308),
    [anon_sym_AT_ATom] = ACTIONS(308),
    [anon_sym_AT_ATdm] = ACTIONS(308),
    [anon_sym_AT_ATr] = ACTIONS(308),
    [anon_sym_AT_ATs_COLON] = ACTIONS(308),
    [anon_sym_AT] = ACTIONS(308),
    [anon_sym_AT_BANG] = ACTIONS(308),
    [anon_sym_AT_LPAREN] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(308),
    [anon_sym_ATa_COLON] = ACTIONS(308),
    [anon_sym_ATb_COLON] = ACTIONS(308),
    [anon_sym_ATB_COLON] = ACTIONS(308),
    [anon_sym_ATe_COLON] = ACTIONS(308),
    [anon_sym_ATF_COLON] = ACTIONS(308),
    [anon_sym_ATi_COLON] = ACTIONS(308),
    [anon_sym_ATk_COLON] = ACTIONS(308),
    [anon_sym_ATo_COLON] = ACTIONS(308),
    [anon_sym_ATr_COLON] = ACTIONS(308),
    [anon_sym_ATf_COLON] = ACTIONS(308),
    [anon_sym_ATs_COLON] = ACTIONS(308),
    [anon_sym_ATv_COLON] = ACTIONS(308),
    [anon_sym_ATx_COLON] = ACTIONS(308),
    [anon_sym_SEMI] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(308),
    [anon_sym_PIPE_DOT] = ACTIONS(308),
    [anon_sym_DOLLAR] = ACTIONS(310),
    [anon_sym_GT] = ACTIONS(310),
    [anon_sym_GT_GT] = ACTIONS(308),
    [sym_html_redirect_operator] = ACTIONS(310),
    [sym_html_append_operator] = ACTIONS(308),
    [anon_sym_COMMA] = ACTIONS(308),
    [aux_sym_arg_identifier_token1] = ACTIONS(310),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(308),
    [anon_sym_BQUOTE] = ACTIONS(308),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(308),
    [anon_sym_CR] = ACTIONS(308),
    [sym_file_descriptor] = ACTIONS(308),
    [sym__concat] = ACTIONS(308),
  },
  [87] = {
    [ts_builtin_sym_end] = ACTIONS(312),
    [anon_sym_DQUOTE] = ACTIONS(312),
    [anon_sym_TILDE] = ACTIONS(312),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_PIPEH] = ACTIONS(312),
    [anon_sym_AT_AT_DOT] = ACTIONS(312),
    [anon_sym_AT_AT_EQ] = ACTIONS(312),
    [anon_sym_AT_AT_AT_EQ] = ACTIONS(312),
    [anon_sym_AT_AT] = ACTIONS(314),
    [anon_sym_AT_ATc_COLON] = ACTIONS(312),
    [anon_sym_AT_AT_ATc_COLON] = ACTIONS(312),
    [anon_sym_AT_ATC] = ACTIONS(312),
    [anon_sym_AT_ATdbt] = ACTIONS(314),
    [anon_sym_AT_ATdbta] = ACTIONS(312),
    [anon_sym_AT_ATdbtb] = ACTIONS(312),
    [anon_sym_AT_ATdbts] = ACTIONS(312),
    [anon_sym_AT_ATt] = ACTIONS(312),
    [anon_sym_AT_ATb] = ACTIONS(312),
    [anon_sym_AT_ATi] = ACTIONS(314),
    [anon_sym_AT_ATii] = ACTIONS(312),
    [anon_sym_AT_ATiS] = ACTIONS(314),
    [anon_sym_AT_ATiSS] = ACTIONS(312),
    [anon_sym_AT_ATis] = ACTIONS(312),
    [anon_sym_AT_ATiz] = ACTIONS(312),
    [anon_sym_AT_ATf] = ACTIONS(312),
    [anon_sym_AT_ATF] = ACTIONS(312),
    [anon_sym_AT_ATom] = ACTIONS(312),
    [anon_sym_AT_ATdm] = ACTIONS(312),
    [anon_sym_AT_ATr] = ACTIONS(312),
    [anon_sym_AT_ATs_COLON] = ACTIONS(312),
    [anon_sym_AT] = ACTIONS(312),
    [anon_sym_AT_BANG] = ACTIONS(312),
    [anon_sym_AT_LPAREN] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(312),
    [anon_sym_ATa_COLON] = ACTIONS(312),
    [anon_sym_ATb_COLON] = ACTIONS(312),
    [anon_sym_ATB_COLON] = ACTIONS(312),
    [anon_sym_ATe_COLON] = ACTIONS(312),
    [anon_sym_ATF_COLON] = ACTIONS(312),
    [anon_sym_ATi_COLON] = ACTIONS(312),
    [anon_sym_ATk_COLON] = ACTIONS(312),
    [anon_sym_ATo_COLON] = ACTIONS(312),
    [anon_sym_ATr_COLON] = ACTIONS(312),
    [anon_sym_ATf_COLON] = ACTIONS(312),
    [anon_sym_ATs_COLON] = ACTIONS(312),
    [anon_sym_ATv_COLON] = ACTIONS(312),
    [anon_sym_ATx_COLON] = ACTIONS(312),
    [anon_sym_SEMI] = ACTIONS(312),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_PIPE_DOT] = ACTIONS(312),
    [anon_sym_DOLLAR] = ACTIONS(314),
    [anon_sym_GT] = ACTIONS(314),
    [anon_sym_GT_GT] = ACTIONS(312),
    [sym_html_redirect_operator] = ACTIONS(314),
    [sym_html_append_operator] = ACTIONS(312),
    [anon_sym_COMMA] = ACTIONS(312),
    [aux_sym_arg_identifier_token1] = ACTIONS(314),
    [anon_sym_SQUOTE] = ACTIONS(312),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(312),
    [anon_sym_BQUOTE] = ACTIONS(312),
    [sym__comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(312),
    [anon_sym_CR] = ACTIONS(312),
    [sym_file_descriptor] = ACTIONS(312),
    [sym__concat] = ACTIONS(312),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(214), 1,
      sym__eq_sep_key_identifier,
    ACTIONS(216), 1,
      anon_sym_SQUOTE,
    ACTIONS(218), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(164), 1,
      sym__eq_sep_key_concatenation,
    STATE(166), 1,
      sym__eq_sep_key,
    STATE(250), 1,
      sym_eq_sep_args,
    STATE(118), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
    ACTIONS(212), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(208), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [87] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(320), 1,
      sym__concat_pf_dot,
    STATE(89), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(318), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(316), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [162] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(94), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(325), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(323), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [235] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(263), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(261), 54,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [306] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(329), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_arg_identifier_token1,
    ACTIONS(327), 54,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [377] = 9,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(109), 1,
      sym_pf_concatenation,
    ACTIONS(200), 2,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
    STATE(68), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
    ACTIONS(240), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(238), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [460] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(335), 1,
      sym__concat_pf_dot,
    STATE(89), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(333), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(331), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [535] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(339), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(337), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [605] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(345), 1,
      sym__concat,
    STATE(101), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(343), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(341), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [679] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(351), 1,
      sym__concat,
    STATE(97), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(349), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [753] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [823] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(318), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(316), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [893] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [963] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(345), 1,
      sym__concat,
    STATE(97), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(356), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(354), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1037] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(325), 10,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_EQ,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(323), 52,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1107] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1176] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1245] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(360), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(358), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1314] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(347), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1383] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(364), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(362), 52,
      sym_file_descriptor,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1452] = 8,
    ACTIONS(370), 1,
      sym_grep_specifier_identifier,
    ACTIONS(372), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(374), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(376), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(366), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(110), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(368), 52,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1530] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(343), 9,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_DOLLAR,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(341), 51,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1598] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(384), 1,
      sym_grep_specifier_identifier,
    ACTIONS(387), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(390), 1,
      anon_sym_BQUOTE,
    ACTIONS(380), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    STATE(110), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(382), 53,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [1674] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(261), 1,
      sym__eq_sep_concat,
    ACTIONS(397), 1,
      sym__concat,
    STATE(439), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(395), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(393), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1747] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(403), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(119), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(401), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(399), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1818] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(409), 1,
      sym__eq_sep_concat,
    STATE(120), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(407), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(405), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1889] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(206), 1,
      sym__concat_pf_dot,
    STATE(124), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(413), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(411), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [1960] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(415), 1,
      sym__concat,
    STATE(115), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(267), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(265), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2031] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(206), 1,
      sym__concat_pf_dot,
    STATE(114), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(196), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(194), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2102] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(418), 1,
      sym__concat,
    STATE(115), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(250), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(248), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2173] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(409), 1,
      sym__eq_sep_concat,
    STATE(113), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(422), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(420), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2244] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(428), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(119), 1,
      aux_sym_tmp_eval_arg_repeat1,
    ACTIONS(426), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(424), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2315] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(435), 1,
      sym__eq_sep_concat,
    STATE(120), 1,
      aux_sym__eq_sep_key_concatenation_repeat1,
    ACTIONS(433), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(431), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2386] = 4,
    ACTIONS(3), 1,
      sym__comment,
    STATE(122), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(325), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(323), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2455] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(438), 1,
      sym__concat_pf_dot,
    STATE(123), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(333), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(331), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2526] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(440), 1,
      sym__concat_pf_dot,
    STATE(123), 1,
      aux_sym_pf_dot_concatenation_repeat1,
    ACTIONS(318), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(316), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2597] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(447), 1,
      sym__concat_pf_dot,
    STATE(124), 1,
      aux_sym_pf_dot_args_repeat1,
    ACTIONS(445), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(443), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2668] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(418), 1,
      sym__concat,
    STATE(117), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(263), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(261), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2739] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(308), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2805] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(286), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(284), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2871] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(312), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [2937] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3003] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(454), 1,
      sym__eq_sep_concat,
    STATE(130), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(452), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(450), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3073] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3139] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(461), 1,
      anon_sym_COMMA,
    STATE(132), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(459), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(457), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3209] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(267), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(265), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3275] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym__eq_sep_concat,
    STATE(130), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
    ACTIONS(466), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(464), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3345] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(296), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3411] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(472), 8,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
      aux_sym_tmp_eval_arg_token1,
    ACTIONS(470), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3477] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(478), 1,
      anon_sym_COMMA,
    STATE(132), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(476), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(474), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3547] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3613] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(433), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(431), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3679] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(339), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(337), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3745] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(484), 1,
      anon_sym_LPAREN,
    STATE(256), 1,
      sym_macro_call,
    ACTIONS(482), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(480), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3815] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(325), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(323), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3881] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [3947] = 8,
    ACTIONS(366), 1,
      sym_file_descriptor,
    ACTIONS(372), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(486), 1,
      sym_grep_specifier_identifier,
    ACTIONS(488), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(490), 1,
      anon_sym_BQUOTE,
    STATE(146), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(368), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [4023] = 3,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(280), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(282), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4089] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(380), 1,
      sym_file_descriptor,
    ACTIONS(492), 1,
      sym_grep_specifier_identifier,
    ACTIONS(495), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(498), 1,
      anon_sym_BQUOTE,
    STATE(146), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(382), 52,
      anon_sym_TILDE,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
  [4163] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(318), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(316), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4229] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(503), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(501), 51,
      sym_file_descriptor,
      sym__concat_pf_dot,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4295] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(292), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4361] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(290), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(288), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4427] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(296), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4493] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(312), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4559] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(278), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(276), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4625] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(286), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(284), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4691] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(308), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4757] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(478), 1,
      anon_sym_COMMA,
    STATE(137), 1,
      aux_sym_tmp_eval_args_repeat1,
    ACTIONS(507), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(505), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4827] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4893] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(280), 51,
      sym_file_descriptor,
      sym__eq_sep_concat,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [4959] = 3,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(280), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(282), 56,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5025] = 7,
    ACTIONS(366), 1,
      sym_file_descriptor,
    ACTIONS(372), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(486), 1,
      sym_grep_specifier_identifier,
    ACTIONS(488), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(146), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
    ACTIONS(368), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [5098] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(513), 1,
      anon_sym_COLON,
    ACTIONS(511), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(509), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5165] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(519), 1,
      anon_sym_COLON,
    ACTIONS(517), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(515), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5232] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(525), 1,
      anon_sym_COLON,
    ACTIONS(523), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(521), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5299] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(422), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(420), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_EQ,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5364] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(263), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(261), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5429] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(531), 1,
      anon_sym_EQ,
    ACTIONS(529), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(527), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5496] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(459), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(457), 50,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_COMMA,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5561] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(452), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(450), 50,
      sym_file_descriptor,
      sym__eq_sep_concat,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5626] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(535), 1,
      anon_sym_TILDE,
    ACTIONS(537), 1,
      anon_sym_PIPE,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(543), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(545), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(547), 1,
      anon_sym_AT_AT,
    ACTIONS(549), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(551), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(589), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(591), 1,
      anon_sym_AT,
    ACTIONS(593), 1,
      anon_sym_AT_BANG,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(599), 1,
      anon_sym_ATb_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(607), 1,
      anon_sym_ATi_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(611), 1,
      anon_sym_ATo_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(625), 1,
      anon_sym_GT,
    ACTIONS(627), 1,
      anon_sym_GT_GT,
    ACTIONS(629), 1,
      sym_html_redirect_operator,
    ACTIONS(631), 1,
      sym_html_append_operator,
    ACTIONS(633), 1,
      sym_file_descriptor,
    STATE(304), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
    ACTIONS(533), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [5791] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(639), 1,
      sym__concat,
    ACTIONS(637), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(635), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5858] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(643), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(641), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5922] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(647), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(645), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [5986] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(651), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(649), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6050] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(655), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(653), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6114] = 3,
    ACTIONS(280), 1,
      sym_file_descriptor,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(282), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [6178] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(659), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(657), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6242] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(663), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(661), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6306] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(669), 1,
      anon_sym_EQ,
    ACTIONS(667), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(665), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [6372] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6436] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6500] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(677), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(675), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6564] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(681), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(679), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6628] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(368), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(366), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6692] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(685), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(683), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6756] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(689), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(687), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6820] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(693), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(691), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6884] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(697), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(695), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [6948] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(701), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(699), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7012] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(705), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(703), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7076] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(709), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(707), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7140] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(713), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(711), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7204] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(717), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(715), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7268] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(721), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(719), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7332] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(725), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(723), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7396] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(729), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(727), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7460] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(733), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(731), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7524] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(737), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(735), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7588] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(741), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(739), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7652] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(745), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(743), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7716] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(749), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(747), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7780] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(753), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(751), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7844] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(757), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(755), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7908] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(761), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(759), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [7972] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(765), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(763), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8036] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(769), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(767), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8100] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(637), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(635), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8164] = 3,
    ACTIONS(280), 1,
      sym_file_descriptor,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(282), 55,
      anon_sym_TILDE,
      sym_grep_specifier_identifier,
      aux_sym_grep_specifier_token1,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [8228] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(773), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(771), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8292] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(777), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(775), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8356] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(781), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(779), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8420] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(785), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(783), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8484] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(789), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(787), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8548] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(793), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(791), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8612] = 4,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(795), 1,
      aux_sym__interpret_stmt_token2,
    ACTIONS(135), 2,
      sym_file_descriptor,
      ts_builtin_sym_end,
    ACTIONS(137), 53,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [8678] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(799), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(797), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8742] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(805), 1,
      sym__concat_pf_dot,
    ACTIONS(803), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(801), 48,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [8808] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(647), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(645), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8872] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(809), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(807), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [8936] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(813), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(811), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9000] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(817), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(815), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9064] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(821), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(819), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9128] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(825), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(823), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9192] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(829), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(827), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9256] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(145), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(143), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9320] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9384] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9448] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9512] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(833), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(831), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9576] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(837), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(835), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9640] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(841), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(839), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9704] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(845), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(843), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9768] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(849), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(847), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9832] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(853), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(851), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9896] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(857), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(855), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [9960] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(861), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(859), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10024] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10088] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(865), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(863), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10152] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(869), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(867), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10216] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(873), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(871), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10280] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(395), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(393), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10344] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(877), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(875), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10408] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(881), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(879), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10472] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(885), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(883), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10536] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10600] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(889), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(887), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10664] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(893), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(891), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10728] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(897), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(895), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10792] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(901), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(899), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10856] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(905), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(903), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10920] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(909), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(907), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [10984] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(673), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(671), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11048] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(913), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(911), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11112] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(129), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(127), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11176] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(917), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(915), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11240] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(921), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(919), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11304] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(925), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(923), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11368] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(929), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(927), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11432] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(933), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(931), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11496] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(57), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(55), 49,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_RPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [11560] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(537), 1,
      anon_sym_PIPE,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(543), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(545), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(547), 1,
      anon_sym_AT_AT,
    ACTIONS(549), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(551), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(589), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(591), 1,
      anon_sym_AT,
    ACTIONS(593), 1,
      anon_sym_AT_BANG,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(599), 1,
      anon_sym_ATb_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(607), 1,
      anon_sym_ATi_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(611), 1,
      anon_sym_ATo_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(625), 1,
      anon_sym_GT,
    ACTIONS(627), 1,
      anon_sym_GT_GT,
    ACTIONS(629), 1,
      sym_html_redirect_operator,
    ACTIONS(631), 1,
      sym_html_append_operator,
    ACTIONS(633), 1,
      sym_file_descriptor,
    ACTIONS(935), 1,
      anon_sym_TILDE,
    ACTIONS(533), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(304), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [11723] = 53,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(625), 1,
      anon_sym_GT,
    ACTIONS(627), 1,
      anon_sym_GT_GT,
    ACTIONS(629), 1,
      sym_html_redirect_operator,
    ACTIONS(631), 1,
      sym_html_append_operator,
    ACTIONS(633), 1,
      sym_file_descriptor,
    ACTIONS(937), 1,
      anon_sym_TILDE,
    ACTIONS(939), 1,
      anon_sym_PIPE,
    ACTIONS(941), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(943), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(945), 1,
      anon_sym_AT_AT,
    ACTIONS(947), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(949), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(951), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(953), 1,
      anon_sym_AT,
    ACTIONS(955), 1,
      anon_sym_AT_BANG,
    ACTIONS(957), 1,
      anon_sym_ATb_COLON,
    ACTIONS(959), 1,
      anon_sym_ATi_COLON,
    ACTIONS(961), 1,
      anon_sym_ATo_COLON,
    ACTIONS(533), 2,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
    STATE(304), 3,
      sym__redirect_operator,
      sym_fdn_redirect_operator,
      sym_fdn_append_operator,
  [11886] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(543), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(545), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(547), 1,
      anon_sym_AT_AT,
    ACTIONS(549), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(551), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(589), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(591), 1,
      anon_sym_AT,
    ACTIONS(593), 1,
      anon_sym_AT_BANG,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(599), 1,
      anon_sym_ATb_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(607), 1,
      anon_sym_ATi_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(611), 1,
      anon_sym_ATo_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(965), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(963), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12035] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(543), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(545), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(547), 1,
      anon_sym_AT_AT,
    ACTIONS(549), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(551), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(589), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(591), 1,
      anon_sym_AT,
    ACTIONS(593), 1,
      anon_sym_AT_BANG,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(599), 1,
      anon_sym_ATb_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(607), 1,
      anon_sym_ATi_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(611), 1,
      anon_sym_ATo_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(969), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(967), 9,
      sym_file_descriptor,
      ts_builtin_sym_end,
      anon_sym_TILDE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_LF,
      anon_sym_CR,
  [12184] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(971), 1,
      anon_sym_EQ,
    ACTIONS(667), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(665), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12247] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(973), 1,
      sym__concat_pf_dot,
    ACTIONS(803), 7,
      anon_sym_PIPE,
      anon_sym_AT_AT,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATi,
      anon_sym_AT_ATiS,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(801), 45,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12310] = 4,
    ACTIONS(135), 1,
      sym_file_descriptor,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(975), 1,
      aux_sym__interpret_stmt_token2,
    ACTIONS(137), 51,
      anon_sym_TILDE,
      anon_sym_PIPE,
      anon_sym_PIPEH,
      anon_sym_AT_AT_DOT,
      anon_sym_AT_AT_EQ,
      anon_sym_AT_AT_AT_EQ,
      anon_sym_AT_AT,
      anon_sym_AT_ATc_COLON,
      anon_sym_AT_AT_ATc_COLON,
      anon_sym_AT_ATC,
      anon_sym_AT_ATdbt,
      anon_sym_AT_ATdbta,
      anon_sym_AT_ATdbtb,
      anon_sym_AT_ATdbts,
      anon_sym_AT_ATt,
      anon_sym_AT_ATb,
      anon_sym_AT_ATi,
      anon_sym_AT_ATii,
      anon_sym_AT_ATiS,
      anon_sym_AT_ATiSS,
      anon_sym_AT_ATis,
      anon_sym_AT_ATiz,
      anon_sym_AT_ATf,
      anon_sym_AT_ATF,
      anon_sym_AT_ATom,
      anon_sym_AT_ATdm,
      anon_sym_AT_ATr,
      anon_sym_AT_ATs_COLON,
      anon_sym_AT,
      anon_sym_AT_BANG,
      anon_sym_AT_LPAREN,
      anon_sym_ATa_COLON,
      anon_sym_ATb_COLON,
      anon_sym_ATB_COLON,
      anon_sym_ATe_COLON,
      anon_sym_ATF_COLON,
      anon_sym_ATi_COLON,
      anon_sym_ATk_COLON,
      anon_sym_ATo_COLON,
      anon_sym_ATr_COLON,
      anon_sym_ATf_COLON,
      anon_sym_ATs_COLON,
      anon_sym_ATv_COLON,
      anon_sym_ATx_COLON,
      anon_sym_SEMI,
      anon_sym_PIPE_DOT,
      anon_sym_GT,
      anon_sym_GT_GT,
      sym_html_redirect_operator,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12373] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(941), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(943), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(945), 1,
      anon_sym_AT_AT,
    ACTIONS(947), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(949), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(951), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(953), 1,
      anon_sym_AT,
    ACTIONS(955), 1,
      anon_sym_AT_BANG,
    ACTIONS(957), 1,
      anon_sym_ATb_COLON,
    ACTIONS(959), 1,
      anon_sym_ATi_COLON,
    ACTIONS(961), 1,
      anon_sym_ATo_COLON,
    ACTIONS(969), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(967), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12519] = 46,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(539), 1,
      anon_sym_PIPEH,
    ACTIONS(541), 1,
      anon_sym_AT_AT_DOT,
    ACTIONS(553), 1,
      anon_sym_AT_ATC,
    ACTIONS(555), 1,
      anon_sym_AT_ATdbt,
    ACTIONS(557), 1,
      anon_sym_AT_ATdbta,
    ACTIONS(559), 1,
      anon_sym_AT_ATdbtb,
    ACTIONS(561), 1,
      anon_sym_AT_ATdbts,
    ACTIONS(563), 1,
      anon_sym_AT_ATt,
    ACTIONS(565), 1,
      anon_sym_AT_ATb,
    ACTIONS(567), 1,
      anon_sym_AT_ATi,
    ACTIONS(569), 1,
      anon_sym_AT_ATii,
    ACTIONS(571), 1,
      anon_sym_AT_ATiS,
    ACTIONS(573), 1,
      anon_sym_AT_ATiSS,
    ACTIONS(575), 1,
      anon_sym_AT_ATis,
    ACTIONS(577), 1,
      anon_sym_AT_ATiz,
    ACTIONS(579), 1,
      anon_sym_AT_ATf,
    ACTIONS(581), 1,
      anon_sym_AT_ATF,
    ACTIONS(583), 1,
      anon_sym_AT_ATom,
    ACTIONS(585), 1,
      anon_sym_AT_ATdm,
    ACTIONS(587), 1,
      anon_sym_AT_ATr,
    ACTIONS(595), 1,
      anon_sym_AT_LPAREN,
    ACTIONS(597), 1,
      anon_sym_ATa_COLON,
    ACTIONS(601), 1,
      anon_sym_ATB_COLON,
    ACTIONS(603), 1,
      anon_sym_ATe_COLON,
    ACTIONS(605), 1,
      anon_sym_ATF_COLON,
    ACTIONS(609), 1,
      anon_sym_ATk_COLON,
    ACTIONS(613), 1,
      anon_sym_ATr_COLON,
    ACTIONS(615), 1,
      anon_sym_ATf_COLON,
    ACTIONS(617), 1,
      anon_sym_ATs_COLON,
    ACTIONS(619), 1,
      anon_sym_ATv_COLON,
    ACTIONS(621), 1,
      anon_sym_ATx_COLON,
    ACTIONS(623), 1,
      anon_sym_PIPE_DOT,
    ACTIONS(941), 1,
      anon_sym_AT_AT_EQ,
    ACTIONS(943), 1,
      anon_sym_AT_AT_AT_EQ,
    ACTIONS(945), 1,
      anon_sym_AT_AT,
    ACTIONS(947), 1,
      anon_sym_AT_ATc_COLON,
    ACTIONS(949), 1,
      anon_sym_AT_AT_ATc_COLON,
    ACTIONS(951), 1,
      anon_sym_AT_ATs_COLON,
    ACTIONS(953), 1,
      anon_sym_AT,
    ACTIONS(955), 1,
      anon_sym_AT_BANG,
    ACTIONS(957), 1,
      anon_sym_ATb_COLON,
    ACTIONS(959), 1,
      anon_sym_ATi_COLON,
    ACTIONS(961), 1,
      anon_sym_ATo_COLON,
    ACTIONS(965), 3,
      anon_sym_PIPE,
      anon_sym_GT,
      sym_html_redirect_operator,
    ACTIONS(963), 6,
      sym_file_descriptor,
      anon_sym_TILDE,
      anon_sym_SEMI,
      anon_sym_GT_GT,
      sym_html_append_operator,
      anon_sym_BQUOTE,
  [12665] = 5,
    ACTIONS(3), 1,
      sym__comment,
    STATE(269), 1,
      aux_sym_statements_repeat1,
    ACTIONS(979), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
    ACTIONS(982), 7,
      anon_sym_LPAREN,
      anon_sym_LPAREN_DASH,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(977), 18,
      sym__cmd_identifier,
      sym__help_stmt,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_LPAREN_DASH_STAR,
      anon_sym_LPAREN_STAR,
      aux_sym__interpret_stmt_token3,
      aux_sym__interpret_stmt_token4,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      sym__env_stmt_identifier,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      aux_sym__dec_number_token1,
  [12706] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(986), 1,
      anon_sym_SEMI,
    STATE(270), 1,
      aux_sym__statements_singleline_repeat1,
    ACTIONS(989), 7,
      anon_sym_LPAREN,
      anon_sym_LPAREN_DASH,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(984), 17,
      sym__cmd_identifier,
      sym__help_stmt,
      anon_sym_DQUOTE,
      anon_sym_LPAREN_DASH_STAR,
      anon_sym_LPAREN_STAR,
      aux_sym__interpret_stmt_token3,
      aux_sym__interpret_stmt_token4,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      sym__env_stmt_identifier,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      aux_sym__dec_number_token1,
  [12744] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(993), 7,
      anon_sym_LPAREN,
      anon_sym_LPAREN_DASH,
      anon_sym_DOT,
      aux_sym__interpret_stmt_token1,
      aux_sym_pf_cmd_token1,
      anon_sym_DOT_DOT_DOT,
      aux_sym__dec_number_token2,
    ACTIONS(991), 17,
      sym__cmd_identifier,
      sym__help_stmt,
      anon_sym_DQUOTE,
      anon_sym_LPAREN_DASH_STAR,
      anon_sym_LPAREN_STAR,
      aux_sym__interpret_stmt_token3,
      aux_sym__interpret_stmt_token4,
      anon_sym_DOT_SLASH,
      anon_sym_pfo,
      anon_sym_Cf,
      sym_pf_dot_cmd_identifier,
      sym_pf_dot_full_cmd_identifier,
      sym__env_stmt_identifier,
      sym_system_identifier,
      sym_question_mark_identifier,
      sym_pointer_identifier,
      aux_sym__dec_number_token1,
  [12776] = 15,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(997), 1,
      anon_sym_SEMI,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(446), 1,
      sym_args,
    STATE(493), 1,
      sym_macro_body,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [12828] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1013), 1,
      anon_sym_DQUOTE,
    ACTIONS(1016), 1,
      anon_sym_LPAREN,
    ACTIONS(1019), 1,
      anon_sym_DOLLAR,
    ACTIONS(1022), 1,
      anon_sym_COMMA,
    ACTIONS(1025), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1028), 1,
      anon_sym_SQUOTE,
    ACTIONS(1031), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1034), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    ACTIONS(147), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(273), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [12875] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    ACTIONS(190), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
    STATE(273), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [12922] = 14,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    ACTIONS(1037), 1,
      anon_sym_RPAREN,
    STATE(344), 1,
      sym_concatenation,
    STATE(502), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [12971] = 14,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    ACTIONS(1039), 1,
      anon_sym_RPAREN,
    STATE(344), 1,
      sym_concatenation,
    STATE(496), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13020] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(193), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13066] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(198), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13112] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(503), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13158] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(200), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13204] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(472), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13250] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(198), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13296] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(195), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13342] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(229), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13388] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(192), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13434] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(487), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13480] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(191), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13526] = 14,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1043), 1,
      anon_sym_DQUOTE,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1047), 1,
      anon_sym_DOLLAR,
    ACTIONS(1049), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1053), 1,
      anon_sym_SQUOTE,
    ACTIONS(1055), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_BQUOTE,
    STATE(240), 1,
      sym__eq_sep_val_concatenation,
    STATE(241), 1,
      sym__eq_sep_val,
    STATE(445), 1,
      sym_arg,
    STATE(489), 1,
      sym_concatenation,
    STATE(111), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13574] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(195), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13620] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(211), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13666] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(193), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13712] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(200), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13758] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(485), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13804] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(191), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13850] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(477), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13896] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(172), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13942] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(211), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [13988] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(229), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14034] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(486), 1,
      sym_args,
    STATE(274), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14080] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(172), 1,
      sym_args,
    STATE(65), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14126] = 13,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(192), 1,
      sym_args,
    STATE(53), 2,
      sym_arg,
      aux_sym_args_repeat1,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14172] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(199), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14214] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(201), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14256] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(344), 1,
      sym_concatenation,
    STATE(394), 1,
      sym_arg,
    STATE(318), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14298] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(204), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14340] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(248), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14382] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(203), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14424] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1043), 1,
      anon_sym_DQUOTE,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1047), 1,
      anon_sym_DOLLAR,
    ACTIONS(1049), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1053), 1,
      anon_sym_SQUOTE,
    ACTIONS(1055), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_BQUOTE,
    STATE(165), 1,
      sym_concatenation,
    STATE(168), 1,
      sym_arg,
    STATE(125), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14466] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(247), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14508] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(205), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14550] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(186), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14592] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(246), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14634] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(194), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14676] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(196), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14718] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(171), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14760] = 12,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(91), 1,
      sym_concatenation,
    STATE(202), 1,
      sym_arg,
    STATE(73), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14802] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(267), 1,
      anon_sym_DOLLAR,
    ACTIONS(1059), 1,
      sym__concat,
    STATE(317), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(265), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14829] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(263), 1,
      anon_sym_DOLLAR,
    ACTIONS(1062), 1,
      sym__concat,
    STATE(319), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(261), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14856] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(250), 1,
      anon_sym_DOLLAR,
    ACTIONS(1062), 1,
      sym__concat,
    STATE(317), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(248), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14883] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1043), 1,
      anon_sym_DQUOTE,
    ACTIONS(1045), 1,
      anon_sym_LPAREN,
    ACTIONS(1047), 1,
      anon_sym_DOLLAR,
    ACTIONS(1049), 1,
      anon_sym_COMMA,
    ACTIONS(1051), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1053), 1,
      anon_sym_SQUOTE,
    ACTIONS(1055), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1057), 1,
      anon_sym_BQUOTE,
    STATE(133), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [14919] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(284), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14941] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 1,
      anon_sym_DOLLAR,
    ACTIONS(308), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14963] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(278), 1,
      anon_sym_DOLLAR,
    ACTIONS(276), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [14985] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 1,
      anon_sym_DOLLAR,
    ACTIONS(312), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15007] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 1,
      anon_sym_DOLLAR,
    ACTIONS(280), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15029] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 1,
      anon_sym_DOLLAR,
    ACTIONS(296), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15051] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 1,
      anon_sym_DOLLAR,
    ACTIONS(280), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15073] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(267), 1,
      anon_sym_DOLLAR,
    ACTIONS(265), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15095] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1064), 1,
      anon_sym_DQUOTE,
    ACTIONS(1066), 1,
      anon_sym_LPAREN,
    ACTIONS(1068), 1,
      anon_sym_DOLLAR,
    ACTIONS(1070), 1,
      anon_sym_COMMA,
    ACTIONS(1072), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1074), 1,
      anon_sym_SQUOTE,
    ACTIONS(1076), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1078), 1,
      anon_sym_BQUOTE,
    STATE(448), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15131] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(174), 1,
      anon_sym_DQUOTE,
    ACTIONS(178), 1,
      anon_sym_LPAREN,
    ACTIONS(180), 1,
      anon_sym_DOLLAR,
    ACTIONS(182), 1,
      anon_sym_COMMA,
    ACTIONS(184), 1,
      anon_sym_SQUOTE,
    ACTIONS(186), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(188), 1,
      anon_sym_BQUOTE,
    ACTIONS(1080), 1,
      aux_sym_arg_identifier_token1,
    STATE(393), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15167] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(99), 1,
      anon_sym_DQUOTE,
    ACTIONS(103), 1,
      anon_sym_LPAREN,
    ACTIONS(105), 1,
      anon_sym_DOLLAR,
    ACTIONS(107), 1,
      anon_sym_COMMA,
    ACTIONS(109), 1,
      anon_sym_SQUOTE,
    ACTIONS(111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(113), 1,
      anon_sym_BQUOTE,
    ACTIONS(1041), 1,
      aux_sym_arg_identifier_token1,
    STATE(83), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15203] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(995), 1,
      anon_sym_DQUOTE,
    ACTIONS(999), 1,
      anon_sym_LPAREN,
    ACTIONS(1001), 1,
      anon_sym_DOLLAR,
    ACTIONS(1003), 1,
      anon_sym_COMMA,
    ACTIONS(1005), 1,
      aux_sym_arg_identifier_token1,
    ACTIONS(1007), 1,
      anon_sym_SQUOTE,
    ACTIONS(1009), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1011), 1,
      anon_sym_BQUOTE,
    STATE(328), 6,
      sym__arg_with_paren,
      sym__arg,
      sym_arg_identifier,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15239] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(290), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15261] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 1,
      anon_sym_DOLLAR,
    ACTIONS(292), 13,
      sym__concat,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15283] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(188), 1,
      anon_sym_BQUOTE,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1084), 1,
      anon_sym_DOLLAR,
    ACTIONS(1086), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(389), 1,
      sym_pf_concatenation,
    STATE(501), 1,
      sym_pf_args,
    STATE(341), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(359), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15318] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(222), 1,
      anon_sym_RPAREN,
    ACTIONS(1088), 1,
      anon_sym_LPAREN,
    ACTIONS(1091), 1,
      anon_sym_DOLLAR,
    ACTIONS(1094), 1,
      aux_sym_pf_arg_identifier_token1,
    ACTIONS(1097), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1100), 1,
      anon_sym_BQUOTE,
    STATE(389), 1,
      sym_pf_concatenation,
    STATE(336), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(359), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15353] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(239), 1,
      sym_pf_args,
    STATE(93), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15388] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(188), 1,
      anon_sym_BQUOTE,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1084), 1,
      anon_sym_DOLLAR,
    ACTIONS(1086), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(389), 1,
      sym_pf_concatenation,
    STATE(491), 1,
      sym_pf_args,
    STATE(341), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(359), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15423] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(239), 1,
      sym_pf_args,
    STATE(69), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15458] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(258), 1,
      sym_pf_args,
    STATE(93), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15493] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(188), 1,
      anon_sym_BQUOTE,
    ACTIONS(238), 1,
      anon_sym_RPAREN,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1084), 1,
      anon_sym_DOLLAR,
    ACTIONS(1086), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(389), 1,
      sym_pf_concatenation,
    STATE(336), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(359), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15528] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(258), 1,
      sym_pf_args,
    STATE(69), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15563] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(174), 1,
      sym_pf_args,
    STATE(93), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15598] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(263), 1,
      anon_sym_DOLLAR,
    ACTIONS(261), 12,
      ts_builtin_sym_end,
      anon_sym_DQUOTE,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [15619] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(109), 1,
      sym_pf_concatenation,
    STATE(174), 1,
      sym_pf_args,
    STATE(69), 2,
      sym_pf_arg,
      aux_sym_pf_args_repeat1,
    STATE(96), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15654] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(216), 1,
      anon_sym_SQUOTE,
    ACTIONS(218), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(220), 1,
      anon_sym_BQUOTE,
    ACTIONS(1105), 1,
      sym__eq_sep_key_identifier,
    STATE(164), 1,
      sym__eq_sep_key_concatenation,
    STATE(166), 1,
      sym__eq_sep_key,
    STATE(255), 1,
      sym_eq_sep_args,
    STATE(118), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15688] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1107), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1109), 1,
      anon_sym_DOLLAR,
    ACTIONS(1111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_BQUOTE,
    STATE(67), 1,
      sym_pf_dot_arg,
    STATE(102), 1,
      sym_pf_dot_concatenation,
    STATE(176), 1,
      sym_pf_new_args,
    STATE(177), 1,
      sym_pf_dot_cmd_args,
    STATE(264), 1,
      sym_pf_dot_args,
    STATE(90), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15724] = 11,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1107), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1109), 1,
      anon_sym_DOLLAR,
    ACTIONS(1111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_BQUOTE,
    STATE(54), 1,
      sym_pf_dot_arg,
    STATE(102), 1,
      sym_pf_dot_concatenation,
    STATE(176), 1,
      sym_pf_new_args,
    STATE(177), 1,
      sym_pf_dot_cmd_args,
    STATE(178), 1,
      sym_pf_dot_args,
    STATE(90), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15760] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1115), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1117), 1,
      anon_sym_DOLLAR,
    ACTIONS(1119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_BQUOTE,
    STATE(116), 1,
      sym_pf_dot_arg,
    STATE(142), 1,
      sym_pf_dot_concatenation,
    STATE(177), 1,
      sym_pf_dot_cmd_args,
    STATE(264), 1,
      sym_pf_dot_args,
    STATE(121), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15793] = 10,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1115), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1117), 1,
      anon_sym_DOLLAR,
    ACTIONS(1119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_BQUOTE,
    STATE(116), 1,
      sym_pf_dot_arg,
    STATE(142), 1,
      sym_pf_dot_concatenation,
    STATE(177), 1,
      sym_pf_dot_cmd_args,
    STATE(178), 1,
      sym_pf_dot_args,
    STATE(121), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15826] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(186), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(188), 1,
      anon_sym_BQUOTE,
    ACTIONS(1082), 1,
      anon_sym_LPAREN,
    ACTIONS(1084), 1,
      anon_sym_DOLLAR,
    ACTIONS(1086), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(386), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15851] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(198), 1,
      anon_sym_LPAREN,
    ACTIONS(200), 1,
      anon_sym_DOLLAR,
    ACTIONS(202), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(204), 1,
      anon_sym_BQUOTE,
    ACTIONS(1103), 1,
      aux_sym_pf_arg_identifier_token1,
    STATE(106), 4,
      sym__pf_arg_parentheses,
      sym_pf_arg_identifier,
      sym__pf_arg,
      sym_cmd_substitution_arg,
  [15876] = 8,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1115), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1117), 1,
      anon_sym_DOLLAR,
    ACTIONS(1119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_BQUOTE,
    STATE(142), 1,
      sym_pf_dot_concatenation,
    STATE(148), 1,
      sym_pf_dot_arg,
    STATE(121), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [15903] = 7,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(210), 1,
      anon_sym_DQUOTE,
    ACTIONS(216), 1,
      anon_sym_SQUOTE,
    ACTIONS(218), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(220), 1,
      anon_sym_BQUOTE,
    ACTIONS(1123), 1,
      sym__eq_sep_key_identifier,
    STATE(139), 4,
      sym__eq_sep_key_single,
      sym_double_quoted_arg,
      sym_single_quoted_arg,
      sym_cmd_substitution_arg,
  [15928] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1127), 1,
      anon_sym_DOLLAR,
    ACTIONS(1125), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [15944] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1129), 1,
      anon_sym_DQUOTE,
    ACTIONS(1131), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1133), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [15968] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1139), 1,
      anon_sym_DQUOTE,
    ACTIONS(1141), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1143), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(356), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [15992] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1131), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1145), 1,
      anon_sym_DQUOTE,
    ACTIONS(1133), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16016] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(343), 1,
      anon_sym_DOLLAR,
    ACTIONS(1147), 1,
      sym__concat,
    STATE(362), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(341), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16036] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1151), 1,
      anon_sym_DOLLAR,
    ACTIONS(1149), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16052] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1153), 1,
      anon_sym_DQUOTE,
    ACTIONS(1155), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1157), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(358), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16076] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(356), 1,
      anon_sym_DOLLAR,
    ACTIONS(1147), 1,
      sym__concat,
    STATE(367), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(354), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16096] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1131), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1159), 1,
      anon_sym_DQUOTE,
    ACTIONS(1133), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16120] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1161), 1,
      anon_sym_DQUOTE,
    ACTIONS(1163), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1169), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1172), 1,
      anon_sym_BQUOTE,
    ACTIONS(1166), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16144] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1131), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1175), 1,
      anon_sym_DQUOTE,
    ACTIONS(1133), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16168] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1177), 1,
      anon_sym_DQUOTE,
    ACTIONS(1179), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1181), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(365), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16192] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 1,
      anon_sym_DOLLAR,
    ACTIONS(1183), 1,
      sym__concat,
    STATE(367), 1,
      aux_sym_pf_concatenation_repeat1,
    ACTIONS(347), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16212] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1186), 1,
      anon_sym_DQUOTE,
    ACTIONS(1188), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1190), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(371), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16236] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1192), 1,
      anon_sym_DQUOTE,
    ACTIONS(1194), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1196), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(363), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16260] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1200), 1,
      anon_sym_DOLLAR,
    ACTIONS(1198), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16276] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1131), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1202), 1,
      anon_sym_DQUOTE,
    ACTIONS(1133), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16300] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1131), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1204), 1,
      anon_sym_DQUOTE,
    ACTIONS(1133), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(364), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16324] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1208), 1,
      anon_sym_DOLLAR,
    ACTIONS(1206), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16340] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1135), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1137), 1,
      anon_sym_BQUOTE,
    ACTIONS(1210), 1,
      anon_sym_DQUOTE,
    ACTIONS(1212), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(1214), 2,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
    STATE(372), 2,
      sym_cmd_substitution_arg,
      aux_sym_double_quoted_arg_repeat1,
  [16364] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1218), 1,
      anon_sym_DOLLAR,
    ACTIONS(1216), 7,
      anon_sym_DQUOTE,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      aux_sym_arg_identifier_token1,
      anon_sym_SQUOTE,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16380] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(263), 1,
      anon_sym_DOLLAR,
    ACTIONS(1220), 1,
      sym__concat,
    STATE(378), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(261), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16399] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1115), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1117), 1,
      anon_sym_DOLLAR,
    ACTIONS(1119), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1121), 1,
      anon_sym_BQUOTE,
    STATE(147), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16420] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(250), 1,
      anon_sym_DOLLAR,
    ACTIONS(1220), 1,
      sym__concat,
    STATE(382), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(248), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16439] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 1,
      anon_sym_DOLLAR,
    ACTIONS(280), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16454] = 6,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1107), 1,
      aux_sym__pf_dot_arg_identifier_token1,
    ACTIONS(1109), 1,
      anon_sym_DOLLAR,
    ACTIONS(1111), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(1113), 1,
      anon_sym_BQUOTE,
    STATE(99), 3,
      sym__pf_dot_arg_identifier,
      sym__pf_dot_arg,
      sym_cmd_substitution_arg,
  [16475] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(360), 1,
      anon_sym_DOLLAR,
    ACTIONS(358), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16490] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(267), 1,
      anon_sym_DOLLAR,
    ACTIONS(1222), 1,
      sym__concat,
    STATE(382), 1,
      aux_sym_concatenation_repeat1,
    ACTIONS(265), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16509] = 7,
    ACTIONS(374), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(376), 1,
      anon_sym_BQUOTE,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1225), 1,
      sym_grep_specifier_identifier,
    ACTIONS(1227), 1,
      aux_sym_grep_specifier_token1,
    STATE(184), 1,
      sym_grep_specifier,
    STATE(108), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16532] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(488), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(490), 1,
      anon_sym_BQUOTE,
    ACTIONS(1227), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1229), 1,
      sym_grep_specifier_identifier,
    STATE(184), 1,
      sym_grep_specifier,
    STATE(160), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16555] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(364), 1,
      anon_sym_DOLLAR,
    ACTIONS(362), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16570] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(349), 1,
      anon_sym_DOLLAR,
    ACTIONS(347), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16585] = 7,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(488), 1,
      anon_sym_DOLLAR_LPAREN,
    ACTIONS(490), 1,
      anon_sym_BQUOTE,
    ACTIONS(1227), 1,
      aux_sym_grep_specifier_token1,
    ACTIONS(1231), 1,
      sym_grep_specifier_identifier,
    STATE(184), 1,
      sym_grep_specifier,
    STATE(144), 2,
      sym_cmd_substitution_arg,
      aux_sym_grep_specifier_repeat1,
  [16608] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(282), 1,
      anon_sym_DOLLAR,
    ACTIONS(280), 6,
      sym__concat,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16623] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(343), 1,
      anon_sym_DOLLAR,
    ACTIONS(341), 5,
      anon_sym_RPAREN,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16637] = 3,
    ACTIONS(280), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(282), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16651] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(286), 1,
      anon_sym_DOLLAR,
    ACTIONS(284), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16665] = 3,
    ACTIONS(280), 1,
      aux_sym_double_quoted_arg_token1,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(282), 5,
      anon_sym_DQUOTE,
      aux_sym_double_quoted_arg_token2,
      aux_sym_double_quoted_arg_token3,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16679] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(267), 1,
      anon_sym_DOLLAR,
    ACTIONS(265), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16693] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1233), 6,
      ts_builtin_sym_end,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
      anon_sym_LF,
      anon_sym_CR,
  [16705] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(294), 1,
      anon_sym_DOLLAR,
    ACTIONS(292), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16719] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(314), 1,
      anon_sym_DOLLAR,
    ACTIONS(312), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16733] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(298), 1,
      anon_sym_DOLLAR,
    ACTIONS(296), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16747] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(290), 1,
      anon_sym_DOLLAR,
    ACTIONS(288), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16761] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(278), 1,
      anon_sym_DOLLAR,
    ACTIONS(276), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16775] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(310), 1,
      anon_sym_DOLLAR,
    ACTIONS(308), 5,
      sym__concat,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16789] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1235), 1,
      ts_builtin_sym_end,
    STATE(405), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1237), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16804] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(83), 1,
      ts_builtin_sym_end,
    STATE(404), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1237), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16819] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(263), 1,
      anon_sym_DOLLAR,
    ACTIONS(261), 4,
      anon_sym_LPAREN,
      aux_sym_pf_arg_identifier_token1,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_BQUOTE,
  [16832] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1235), 1,
      ts_builtin_sym_end,
    STATE(406), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1237), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16847] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1239), 1,
      ts_builtin_sym_end,
    STATE(406), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1237), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16862] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1241), 1,
      ts_builtin_sym_end,
    STATE(406), 1,
      aux_sym_statements_repeat2,
    ACTIONS(1243), 3,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [16877] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1246), 1,
      anon_sym_SQUOTE,
    ACTIONS(1248), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1250), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [16893] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1252), 1,
      anon_sym_SQUOTE,
    ACTIONS(1254), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1256), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(413), 1,
      aux_sym_single_quoted_arg_repeat1,
  [16909] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1258), 1,
      anon_sym_SQUOTE,
    ACTIONS(1260), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1262), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(410), 1,
      aux_sym_single_quoted_arg_repeat1,
  [16925] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1248), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1250), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1264), 1,
      anon_sym_SQUOTE,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [16941] = 5,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1266), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(112), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(156), 1,
      sym_tmp_eval_arg,
    STATE(197), 1,
      sym_tmp_eval_args,
  [16957] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1268), 1,
      anon_sym_SQUOTE,
    ACTIONS(1270), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1272), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(407), 1,
      aux_sym_single_quoted_arg_repeat1,
  [16973] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1248), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1250), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1274), 1,
      anon_sym_SQUOTE,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [16989] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1276), 1,
      anon_sym_SQUOTE,
    ACTIONS(1278), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1280), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(417), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17005] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1282), 1,
      anon_sym_SQUOTE,
    ACTIONS(1284), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1287), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17021] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1241), 4,
      ts_builtin_sym_end,
      anon_sym_SEMI,
      anon_sym_LF,
      anon_sym_CR,
  [17031] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1248), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1250), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1290), 1,
      anon_sym_SQUOTE,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17047] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1292), 1,
      anon_sym_SQUOTE,
    ACTIONS(1294), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1296), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(420), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17063] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1298), 1,
      anon_sym_SQUOTE,
    ACTIONS(1300), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1302), 1,
      aux_sym_single_quoted_arg_token2,
    STATE(421), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17079] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1248), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1250), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1304), 1,
      anon_sym_SQUOTE,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17095] = 5,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1248), 1,
      aux_sym_single_quoted_arg_token1,
    ACTIONS(1250), 1,
      aux_sym_single_quoted_arg_token2,
    ACTIONS(1306), 1,
      anon_sym_SQUOTE,
    STATE(415), 1,
      aux_sym_single_quoted_arg_repeat1,
  [17111] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1308), 1,
      anon_sym_SEMI,
    ACTIONS(1310), 1,
      anon_sym_BQUOTE,
    STATE(437), 1,
      aux_sym__statements_singleline_repeat2,
  [17124] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1312), 3,
      anon_sym_RPAREN,
      anon_sym_SEMI,
      anon_sym_BQUOTE,
  [17133] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1308), 1,
      anon_sym_SEMI,
    ACTIONS(1314), 1,
      anon_sym_BQUOTE,
    STATE(431), 1,
      aux_sym__statements_singleline_repeat2,
  [17146] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1316), 1,
      anon_sym_RPAREN,
    ACTIONS(1318), 1,
      anon_sym_SEMI,
    STATE(430), 1,
      aux_sym_macro_body_repeat1,
  [17159] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1312), 1,
      anon_sym_RPAREN,
    ACTIONS(1320), 1,
      anon_sym_SEMI,
    STATE(426), 1,
      aux_sym__statements_singleline_repeat2,
  [17172] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1323), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 1,
      anon_sym_SEMI,
    STATE(426), 1,
      aux_sym__statements_singleline_repeat2,
  [17185] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1327), 1,
      anon_sym_DOLLAR,
    ACTIONS(1329), 1,
      aux_sym_spec_arg_identifier_token1,
    STATE(85), 1,
      sym_spec_arg_identifier,
  [17198] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1266), 1,
      aux_sym_tmp_eval_arg_token1,
    STATE(112), 1,
      aux_sym_tmp_eval_arg_repeat1,
    STATE(167), 1,
      sym_tmp_eval_arg,
  [17211] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1318), 1,
      anon_sym_SEMI,
    ACTIONS(1331), 1,
      anon_sym_RPAREN,
    STATE(436), 1,
      aux_sym_macro_body_repeat1,
  [17224] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1308), 1,
      anon_sym_SEMI,
    ACTIONS(1310), 1,
      anon_sym_BQUOTE,
    STATE(435), 1,
      aux_sym__statements_singleline_repeat2,
  [17237] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 1,
      anon_sym_SEMI,
    STATE(427), 1,
      aux_sym__statements_singleline_repeat2,
  [17250] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1310), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 1,
      anon_sym_SEMI,
    STATE(426), 1,
      aux_sym__statements_singleline_repeat2,
  [17263] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1314), 1,
      anon_sym_RPAREN,
    ACTIONS(1325), 1,
      anon_sym_SEMI,
    STATE(433), 1,
      aux_sym__statements_singleline_repeat2,
  [17276] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1312), 1,
      anon_sym_BQUOTE,
    ACTIONS(1333), 1,
      anon_sym_SEMI,
    STATE(435), 1,
      aux_sym__statements_singleline_repeat2,
  [17289] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 1,
      anon_sym_RPAREN,
    ACTIONS(1338), 1,
      anon_sym_SEMI,
    STATE(436), 1,
      aux_sym_macro_body_repeat1,
  [17302] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1308), 1,
      anon_sym_SEMI,
    ACTIONS(1323), 1,
      anon_sym_BQUOTE,
    STATE(435), 1,
      aux_sym__statements_singleline_repeat2,
  [17315] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(265), 1,
      sym__eq_sep_concat,
    ACTIONS(1341), 1,
      sym__concat,
    STATE(438), 1,
      aux_sym_concatenation_repeat1,
  [17328] = 4,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(248), 1,
      sym__eq_sep_concat,
    ACTIONS(397), 1,
      sym__concat,
    STATE(438), 1,
      aux_sym_concatenation_repeat1,
  [17341] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(284), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17349] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(312), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17357] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1344), 1,
      anon_sym_GT,
    ACTIONS(1346), 1,
      anon_sym_GT_GT,
  [17367] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1336), 2,
      anon_sym_RPAREN,
      anon_sym_SEMI,
  [17375] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1348), 1,
      aux_sym__search_stmt_token1,
    STATE(245), 1,
      sym__search_stmt,
  [17385] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(468), 1,
      sym__eq_sep_concat,
    STATE(134), 1,
      aux_sym__eq_sep_val_concatenation_repeat1,
  [17395] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(997), 1,
      anon_sym_SEMI,
    STATE(457), 1,
      sym_macro_body,
  [17405] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1350), 1,
      sym_macro_name,
    STATE(458), 1,
      sym_macro_content,
  [17415] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(265), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17423] = 3,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1352), 1,
      aux_sym__search_stmt_token1,
    STATE(245), 1,
      sym__search_stmt,
  [17433] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(292), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17441] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17449] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(288), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17457] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(276), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17465] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(280), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17473] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(308), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17481] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(296), 2,
      sym__eq_sep_concat,
      sym__concat,
  [17489] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1354), 1,
      anon_sym_RPAREN,
  [17496] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1356), 1,
      anon_sym_RPAREN,
  [17503] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1358), 1,
      anon_sym_BQUOTE,
  [17510] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1360), 1,
      anon_sym_RPAREN,
  [17517] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1362), 1,
      anon_sym_BQUOTE,
  [17524] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1364), 1,
      anon_sym_RPAREN,
  [17531] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1366), 1,
      anon_sym_BQUOTE,
  [17538] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1368), 1,
      anon_sym_RPAREN,
  [17545] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1370), 1,
      anon_sym_BQUOTE,
  [17552] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1372), 1,
      anon_sym_RPAREN,
  [17559] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1374), 1,
      anon_sym_BQUOTE,
  [17566] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1376), 1,
      anon_sym_RPAREN,
  [17573] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1378), 1,
      anon_sym_BQUOTE,
  [17580] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1380), 1,
      anon_sym_RPAREN,
  [17587] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1382), 1,
      anon_sym_BQUOTE,
  [17594] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1384), 1,
      anon_sym_RPAREN,
  [17601] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1386), 1,
      anon_sym_RPAREN,
  [17608] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1388), 1,
      anon_sym_RPAREN,
  [17615] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1390), 1,
      anon_sym_BQUOTE,
  [17622] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1392), 1,
      anon_sym_BQUOTE,
  [17629] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1394), 1,
      anon_sym_RPAREN,
  [17636] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1396), 1,
      sym__concat,
  [17643] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1398), 1,
      sym__concat_pf_dot,
  [17650] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1400), 1,
      anon_sym_RPAREN,
  [17657] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1402), 1,
      anon_sym_RPAREN,
  [17664] = 2,
    ACTIONS(378), 1,
      sym__comment,
    ACTIONS(1404), 1,
      aux_sym_legacy_quoted_stmt_token1,
  [17671] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1406), 1,
      anon_sym_BQUOTE,
  [17678] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1408), 1,
      anon_sym_RPAREN,
  [17685] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1410), 1,
      anon_sym_RPAREN,
  [17692] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1412), 1,
      anon_sym_RPAREN,
  [17699] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1414), 1,
      anon_sym_RPAREN,
  [17706] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1416), 1,
      ts_builtin_sym_end,
  [17713] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(261), 1,
      sym__eq_sep_concat,
  [17720] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1418), 1,
      anon_sym_DQUOTE,
  [17727] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1420), 1,
      anon_sym_RPAREN,
  [17734] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1422), 1,
      sym__concat,
  [17741] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1424), 1,
      anon_sym_RPAREN,
  [17748] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1426), 1,
      sym__concat_pf_dot,
  [17755] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1428), 1,
      anon_sym_BQUOTE,
  [17762] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1430), 1,
      anon_sym_RPAREN,
  [17769] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1432), 1,
      anon_sym_DOT,
  [17776] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1434), 1,
      anon_sym_BQUOTE,
  [17783] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1436), 1,
      sym__concat,
  [17790] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1438), 1,
      anon_sym_RPAREN,
  [17797] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1440), 1,
      anon_sym_RPAREN,
  [17804] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1442), 1,
      anon_sym_RPAREN,
  [17811] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1444), 1,
      anon_sym_RPAREN,
  [17818] = 2,
    ACTIONS(3), 1,
      sym__comment,
    ACTIONS(1446), 1,
      sym__concat_pf_dot,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(88)] = 0,
  [SMALL_STATE(89)] = 87,
  [SMALL_STATE(90)] = 162,
  [SMALL_STATE(91)] = 235,
  [SMALL_STATE(92)] = 306,
  [SMALL_STATE(93)] = 377,
  [SMALL_STATE(94)] = 460,
  [SMALL_STATE(95)] = 535,
  [SMALL_STATE(96)] = 605,
  [SMALL_STATE(97)] = 679,
  [SMALL_STATE(98)] = 753,
  [SMALL_STATE(99)] = 823,
  [SMALL_STATE(100)] = 893,
  [SMALL_STATE(101)] = 963,
  [SMALL_STATE(102)] = 1037,
  [SMALL_STATE(103)] = 1107,
  [SMALL_STATE(104)] = 1176,
  [SMALL_STATE(105)] = 1245,
  [SMALL_STATE(106)] = 1314,
  [SMALL_STATE(107)] = 1383,
  [SMALL_STATE(108)] = 1452,
  [SMALL_STATE(109)] = 1530,
  [SMALL_STATE(110)] = 1598,
  [SMALL_STATE(111)] = 1674,
  [SMALL_STATE(112)] = 1747,
  [SMALL_STATE(113)] = 1818,
  [SMALL_STATE(114)] = 1889,
  [SMALL_STATE(115)] = 1960,
  [SMALL_STATE(116)] = 2031,
  [SMALL_STATE(117)] = 2102,
  [SMALL_STATE(118)] = 2173,
  [SMALL_STATE(119)] = 2244,
  [SMALL_STATE(120)] = 2315,
  [SMALL_STATE(121)] = 2386,
  [SMALL_STATE(122)] = 2455,
  [SMALL_STATE(123)] = 2526,
  [SMALL_STATE(124)] = 2597,
  [SMALL_STATE(125)] = 2668,
  [SMALL_STATE(126)] = 2739,
  [SMALL_STATE(127)] = 2805,
  [SMALL_STATE(128)] = 2871,
  [SMALL_STATE(129)] = 2937,
  [SMALL_STATE(130)] = 3003,
  [SMALL_STATE(131)] = 3073,
  [SMALL_STATE(132)] = 3139,
  [SMALL_STATE(133)] = 3209,
  [SMALL_STATE(134)] = 3275,
  [SMALL_STATE(135)] = 3345,
  [SMALL_STATE(136)] = 3411,
  [SMALL_STATE(137)] = 3477,
  [SMALL_STATE(138)] = 3547,
  [SMALL_STATE(139)] = 3613,
  [SMALL_STATE(140)] = 3679,
  [SMALL_STATE(141)] = 3745,
  [SMALL_STATE(142)] = 3815,
  [SMALL_STATE(143)] = 3881,
  [SMALL_STATE(144)] = 3947,
  [SMALL_STATE(145)] = 4023,
  [SMALL_STATE(146)] = 4089,
  [SMALL_STATE(147)] = 4163,
  [SMALL_STATE(148)] = 4229,
  [SMALL_STATE(149)] = 4295,
  [SMALL_STATE(150)] = 4361,
  [SMALL_STATE(151)] = 4427,
  [SMALL_STATE(152)] = 4493,
  [SMALL_STATE(153)] = 4559,
  [SMALL_STATE(154)] = 4625,
  [SMALL_STATE(155)] = 4691,
  [SMALL_STATE(156)] = 4757,
  [SMALL_STATE(157)] = 4827,
  [SMALL_STATE(158)] = 4893,
  [SMALL_STATE(159)] = 4959,
  [SMALL_STATE(160)] = 5025,
  [SMALL_STATE(161)] = 5098,
  [SMALL_STATE(162)] = 5165,
  [SMALL_STATE(163)] = 5232,
  [SMALL_STATE(164)] = 5299,
  [SMALL_STATE(165)] = 5364,
  [SMALL_STATE(166)] = 5429,
  [SMALL_STATE(167)] = 5496,
  [SMALL_STATE(168)] = 5561,
  [SMALL_STATE(169)] = 5626,
  [SMALL_STATE(170)] = 5791,
  [SMALL_STATE(171)] = 5858,
  [SMALL_STATE(172)] = 5922,
  [SMALL_STATE(173)] = 5986,
  [SMALL_STATE(174)] = 6050,
  [SMALL_STATE(175)] = 6114,
  [SMALL_STATE(176)] = 6178,
  [SMALL_STATE(177)] = 6242,
  [SMALL_STATE(178)] = 6306,
  [SMALL_STATE(179)] = 6372,
  [SMALL_STATE(180)] = 6436,
  [SMALL_STATE(181)] = 6500,
  [SMALL_STATE(182)] = 6564,
  [SMALL_STATE(183)] = 6628,
  [SMALL_STATE(184)] = 6692,
  [SMALL_STATE(185)] = 6756,
  [SMALL_STATE(186)] = 6820,
  [SMALL_STATE(187)] = 6884,
  [SMALL_STATE(188)] = 6948,
  [SMALL_STATE(189)] = 7012,
  [SMALL_STATE(190)] = 7076,
  [SMALL_STATE(191)] = 7140,
  [SMALL_STATE(192)] = 7204,
  [SMALL_STATE(193)] = 7268,
  [SMALL_STATE(194)] = 7332,
  [SMALL_STATE(195)] = 7396,
  [SMALL_STATE(196)] = 7460,
  [SMALL_STATE(197)] = 7524,
  [SMALL_STATE(198)] = 7588,
  [SMALL_STATE(199)] = 7652,
  [SMALL_STATE(200)] = 7716,
  [SMALL_STATE(201)] = 7780,
  [SMALL_STATE(202)] = 7844,
  [SMALL_STATE(203)] = 7908,
  [SMALL_STATE(204)] = 7972,
  [SMALL_STATE(205)] = 8036,
  [SMALL_STATE(206)] = 8100,
  [SMALL_STATE(207)] = 8164,
  [SMALL_STATE(208)] = 8228,
  [SMALL_STATE(209)] = 8292,
  [SMALL_STATE(210)] = 8356,
  [SMALL_STATE(211)] = 8420,
  [SMALL_STATE(212)] = 8484,
  [SMALL_STATE(213)] = 8548,
  [SMALL_STATE(214)] = 8612,
  [SMALL_STATE(215)] = 8678,
  [SMALL_STATE(216)] = 8742,
  [SMALL_STATE(217)] = 8808,
  [SMALL_STATE(218)] = 8872,
  [SMALL_STATE(219)] = 8936,
  [SMALL_STATE(220)] = 9000,
  [SMALL_STATE(221)] = 9064,
  [SMALL_STATE(222)] = 9128,
  [SMALL_STATE(223)] = 9192,
  [SMALL_STATE(224)] = 9256,
  [SMALL_STATE(225)] = 9320,
  [SMALL_STATE(226)] = 9384,
  [SMALL_STATE(227)] = 9448,
  [SMALL_STATE(228)] = 9512,
  [SMALL_STATE(229)] = 9576,
  [SMALL_STATE(230)] = 9640,
  [SMALL_STATE(231)] = 9704,
  [SMALL_STATE(232)] = 9768,
  [SMALL_STATE(233)] = 9832,
  [SMALL_STATE(234)] = 9896,
  [SMALL_STATE(235)] = 9960,
  [SMALL_STATE(236)] = 10024,
  [SMALL_STATE(237)] = 10088,
  [SMALL_STATE(238)] = 10152,
  [SMALL_STATE(239)] = 10216,
  [SMALL_STATE(240)] = 10280,
  [SMALL_STATE(241)] = 10344,
  [SMALL_STATE(242)] = 10408,
  [SMALL_STATE(243)] = 10472,
  [SMALL_STATE(244)] = 10536,
  [SMALL_STATE(245)] = 10600,
  [SMALL_STATE(246)] = 10664,
  [SMALL_STATE(247)] = 10728,
  [SMALL_STATE(248)] = 10792,
  [SMALL_STATE(249)] = 10856,
  [SMALL_STATE(250)] = 10920,
  [SMALL_STATE(251)] = 10984,
  [SMALL_STATE(252)] = 11048,
  [SMALL_STATE(253)] = 11112,
  [SMALL_STATE(254)] = 11176,
  [SMALL_STATE(255)] = 11240,
  [SMALL_STATE(256)] = 11304,
  [SMALL_STATE(257)] = 11368,
  [SMALL_STATE(258)] = 11432,
  [SMALL_STATE(259)] = 11496,
  [SMALL_STATE(260)] = 11560,
  [SMALL_STATE(261)] = 11723,
  [SMALL_STATE(262)] = 11886,
  [SMALL_STATE(263)] = 12035,
  [SMALL_STATE(264)] = 12184,
  [SMALL_STATE(265)] = 12247,
  [SMALL_STATE(266)] = 12310,
  [SMALL_STATE(267)] = 12373,
  [SMALL_STATE(268)] = 12519,
  [SMALL_STATE(269)] = 12665,
  [SMALL_STATE(270)] = 12706,
  [SMALL_STATE(271)] = 12744,
  [SMALL_STATE(272)] = 12776,
  [SMALL_STATE(273)] = 12828,
  [SMALL_STATE(274)] = 12875,
  [SMALL_STATE(275)] = 12922,
  [SMALL_STATE(276)] = 12971,
  [SMALL_STATE(277)] = 13020,
  [SMALL_STATE(278)] = 13066,
  [SMALL_STATE(279)] = 13112,
  [SMALL_STATE(280)] = 13158,
  [SMALL_STATE(281)] = 13204,
  [SMALL_STATE(282)] = 13250,
  [SMALL_STATE(283)] = 13296,
  [SMALL_STATE(284)] = 13342,
  [SMALL_STATE(285)] = 13388,
  [SMALL_STATE(286)] = 13434,
  [SMALL_STATE(287)] = 13480,
  [SMALL_STATE(288)] = 13526,
  [SMALL_STATE(289)] = 13574,
  [SMALL_STATE(290)] = 13620,
  [SMALL_STATE(291)] = 13666,
  [SMALL_STATE(292)] = 13712,
  [SMALL_STATE(293)] = 13758,
  [SMALL_STATE(294)] = 13804,
  [SMALL_STATE(295)] = 13850,
  [SMALL_STATE(296)] = 13896,
  [SMALL_STATE(297)] = 13942,
  [SMALL_STATE(298)] = 13988,
  [SMALL_STATE(299)] = 14034,
  [SMALL_STATE(300)] = 14080,
  [SMALL_STATE(301)] = 14126,
  [SMALL_STATE(302)] = 14172,
  [SMALL_STATE(303)] = 14214,
  [SMALL_STATE(304)] = 14256,
  [SMALL_STATE(305)] = 14298,
  [SMALL_STATE(306)] = 14340,
  [SMALL_STATE(307)] = 14382,
  [SMALL_STATE(308)] = 14424,
  [SMALL_STATE(309)] = 14466,
  [SMALL_STATE(310)] = 14508,
  [SMALL_STATE(311)] = 14550,
  [SMALL_STATE(312)] = 14592,
  [SMALL_STATE(313)] = 14634,
  [SMALL_STATE(314)] = 14676,
  [SMALL_STATE(315)] = 14718,
  [SMALL_STATE(316)] = 14760,
  [SMALL_STATE(317)] = 14802,
  [SMALL_STATE(318)] = 14829,
  [SMALL_STATE(319)] = 14856,
  [SMALL_STATE(320)] = 14883,
  [SMALL_STATE(321)] = 14919,
  [SMALL_STATE(322)] = 14941,
  [SMALL_STATE(323)] = 14963,
  [SMALL_STATE(324)] = 14985,
  [SMALL_STATE(325)] = 15007,
  [SMALL_STATE(326)] = 15029,
  [SMALL_STATE(327)] = 15051,
  [SMALL_STATE(328)] = 15073,
  [SMALL_STATE(329)] = 15095,
  [SMALL_STATE(330)] = 15131,
  [SMALL_STATE(331)] = 15167,
  [SMALL_STATE(332)] = 15203,
  [SMALL_STATE(333)] = 15239,
  [SMALL_STATE(334)] = 15261,
  [SMALL_STATE(335)] = 15283,
  [SMALL_STATE(336)] = 15318,
  [SMALL_STATE(337)] = 15353,
  [SMALL_STATE(338)] = 15388,
  [SMALL_STATE(339)] = 15423,
  [SMALL_STATE(340)] = 15458,
  [SMALL_STATE(341)] = 15493,
  [SMALL_STATE(342)] = 15528,
  [SMALL_STATE(343)] = 15563,
  [SMALL_STATE(344)] = 15598,
  [SMALL_STATE(345)] = 15619,
  [SMALL_STATE(346)] = 15654,
  [SMALL_STATE(347)] = 15688,
  [SMALL_STATE(348)] = 15724,
  [SMALL_STATE(349)] = 15760,
  [SMALL_STATE(350)] = 15793,
  [SMALL_STATE(351)] = 15826,
  [SMALL_STATE(352)] = 15851,
  [SMALL_STATE(353)] = 15876,
  [SMALL_STATE(354)] = 15903,
  [SMALL_STATE(355)] = 15928,
  [SMALL_STATE(356)] = 15944,
  [SMALL_STATE(357)] = 15968,
  [SMALL_STATE(358)] = 15992,
  [SMALL_STATE(359)] = 16016,
  [SMALL_STATE(360)] = 16036,
  [SMALL_STATE(361)] = 16052,
  [SMALL_STATE(362)] = 16076,
  [SMALL_STATE(363)] = 16096,
  [SMALL_STATE(364)] = 16120,
  [SMALL_STATE(365)] = 16144,
  [SMALL_STATE(366)] = 16168,
  [SMALL_STATE(367)] = 16192,
  [SMALL_STATE(368)] = 16212,
  [SMALL_STATE(369)] = 16236,
  [SMALL_STATE(370)] = 16260,
  [SMALL_STATE(371)] = 16276,
  [SMALL_STATE(372)] = 16300,
  [SMALL_STATE(373)] = 16324,
  [SMALL_STATE(374)] = 16340,
  [SMALL_STATE(375)] = 16364,
  [SMALL_STATE(376)] = 16380,
  [SMALL_STATE(377)] = 16399,
  [SMALL_STATE(378)] = 16420,
  [SMALL_STATE(379)] = 16439,
  [SMALL_STATE(380)] = 16454,
  [SMALL_STATE(381)] = 16475,
  [SMALL_STATE(382)] = 16490,
  [SMALL_STATE(383)] = 16509,
  [SMALL_STATE(384)] = 16532,
  [SMALL_STATE(385)] = 16555,
  [SMALL_STATE(386)] = 16570,
  [SMALL_STATE(387)] = 16585,
  [SMALL_STATE(388)] = 16608,
  [SMALL_STATE(389)] = 16623,
  [SMALL_STATE(390)] = 16637,
  [SMALL_STATE(391)] = 16651,
  [SMALL_STATE(392)] = 16665,
  [SMALL_STATE(393)] = 16679,
  [SMALL_STATE(394)] = 16693,
  [SMALL_STATE(395)] = 16705,
  [SMALL_STATE(396)] = 16719,
  [SMALL_STATE(397)] = 16733,
  [SMALL_STATE(398)] = 16747,
  [SMALL_STATE(399)] = 16761,
  [SMALL_STATE(400)] = 16775,
  [SMALL_STATE(401)] = 16789,
  [SMALL_STATE(402)] = 16804,
  [SMALL_STATE(403)] = 16819,
  [SMALL_STATE(404)] = 16832,
  [SMALL_STATE(405)] = 16847,
  [SMALL_STATE(406)] = 16862,
  [SMALL_STATE(407)] = 16877,
  [SMALL_STATE(408)] = 16893,
  [SMALL_STATE(409)] = 16909,
  [SMALL_STATE(410)] = 16925,
  [SMALL_STATE(411)] = 16941,
  [SMALL_STATE(412)] = 16957,
  [SMALL_STATE(413)] = 16973,
  [SMALL_STATE(414)] = 16989,
  [SMALL_STATE(415)] = 17005,
  [SMALL_STATE(416)] = 17021,
  [SMALL_STATE(417)] = 17031,
  [SMALL_STATE(418)] = 17047,
  [SMALL_STATE(419)] = 17063,
  [SMALL_STATE(420)] = 17079,
  [SMALL_STATE(421)] = 17095,
  [SMALL_STATE(422)] = 17111,
  [SMALL_STATE(423)] = 17124,
  [SMALL_STATE(424)] = 17133,
  [SMALL_STATE(425)] = 17146,
  [SMALL_STATE(426)] = 17159,
  [SMALL_STATE(427)] = 17172,
  [SMALL_STATE(428)] = 17185,
  [SMALL_STATE(429)] = 17198,
  [SMALL_STATE(430)] = 17211,
  [SMALL_STATE(431)] = 17224,
  [SMALL_STATE(432)] = 17237,
  [SMALL_STATE(433)] = 17250,
  [SMALL_STATE(434)] = 17263,
  [SMALL_STATE(435)] = 17276,
  [SMALL_STATE(436)] = 17289,
  [SMALL_STATE(437)] = 17302,
  [SMALL_STATE(438)] = 17315,
  [SMALL_STATE(439)] = 17328,
  [SMALL_STATE(440)] = 17341,
  [SMALL_STATE(441)] = 17349,
  [SMALL_STATE(442)] = 17357,
  [SMALL_STATE(443)] = 17367,
  [SMALL_STATE(444)] = 17375,
  [SMALL_STATE(445)] = 17385,
  [SMALL_STATE(446)] = 17395,
  [SMALL_STATE(447)] = 17405,
  [SMALL_STATE(448)] = 17415,
  [SMALL_STATE(449)] = 17423,
  [SMALL_STATE(450)] = 17433,
  [SMALL_STATE(451)] = 17441,
  [SMALL_STATE(452)] = 17449,
  [SMALL_STATE(453)] = 17457,
  [SMALL_STATE(454)] = 17465,
  [SMALL_STATE(455)] = 17473,
  [SMALL_STATE(456)] = 17481,
  [SMALL_STATE(457)] = 17489,
  [SMALL_STATE(458)] = 17496,
  [SMALL_STATE(459)] = 17503,
  [SMALL_STATE(460)] = 17510,
  [SMALL_STATE(461)] = 17517,
  [SMALL_STATE(462)] = 17524,
  [SMALL_STATE(463)] = 17531,
  [SMALL_STATE(464)] = 17538,
  [SMALL_STATE(465)] = 17545,
  [SMALL_STATE(466)] = 17552,
  [SMALL_STATE(467)] = 17559,
  [SMALL_STATE(468)] = 17566,
  [SMALL_STATE(469)] = 17573,
  [SMALL_STATE(470)] = 17580,
  [SMALL_STATE(471)] = 17587,
  [SMALL_STATE(472)] = 17594,
  [SMALL_STATE(473)] = 17601,
  [SMALL_STATE(474)] = 17608,
  [SMALL_STATE(475)] = 17615,
  [SMALL_STATE(476)] = 17622,
  [SMALL_STATE(477)] = 17629,
  [SMALL_STATE(478)] = 17636,
  [SMALL_STATE(479)] = 17643,
  [SMALL_STATE(480)] = 17650,
  [SMALL_STATE(481)] = 17657,
  [SMALL_STATE(482)] = 17664,
  [SMALL_STATE(483)] = 17671,
  [SMALL_STATE(484)] = 17678,
  [SMALL_STATE(485)] = 17685,
  [SMALL_STATE(486)] = 17692,
  [SMALL_STATE(487)] = 17699,
  [SMALL_STATE(488)] = 17706,
  [SMALL_STATE(489)] = 17713,
  [SMALL_STATE(490)] = 17720,
  [SMALL_STATE(491)] = 17727,
  [SMALL_STATE(492)] = 17734,
  [SMALL_STATE(493)] = 17741,
  [SMALL_STATE(494)] = 17748,
  [SMALL_STATE(495)] = 17755,
  [SMALL_STATE(496)] = 17762,
  [SMALL_STATE(497)] = 17769,
  [SMALL_STATE(498)] = 17776,
  [SMALL_STATE(499)] = 17783,
  [SMALL_STATE(500)] = 17790,
  [SMALL_STATE(501)] = 17797,
  [SMALL_STATE(502)] = 17804,
  [SMALL_STATE(503)] = 17811,
  [SMALL_STATE(504)] = 17818,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [9] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(170),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(214),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(339),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(259),
  [41] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [43] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(271),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [53] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [55] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_stmt_identifier, 1),
  [57] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_last_stmt_identifier, 1),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(297),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [65] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [67] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [69] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [73] = {.entry = {.count = 1, .reusable = true}}, SHIFT(504),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 1),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [87] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 1),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [93] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 1),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [97] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_disable_stmt, 2, .production_id = 2),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [101] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_disable_stmt, 2, .production_id = 2),
  [103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(80),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [115] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt, 1, .production_id = 2),
  [117] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt, 1, .production_id = 2),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_stmt, 1, .production_id = 2),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_stmt, 1, .production_id = 2),
  [123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_stmt, 2),
  [125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_stmt, 2),
  [127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_help_stmt, 1, .production_id = 2),
  [129] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_help_stmt, 1, .production_id = 2),
  [131] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_stmt, 2),
  [133] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_stmt, 2),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 1, .production_id = 3),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 1, .production_id = 3),
  [139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_stmt, 1, .production_id = 2),
  [141] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_stmt, 1, .production_id = 2),
  [143] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 3),
  [145] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 3),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2),
  [149] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(369),
  [152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2),
  [154] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(293),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(80),
  [160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(79),
  [163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(412),
  [166] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(20),
  [169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(18),
  [172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 1, .production_id = 2),
  [174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 1, .production_id = 2),
  [178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(281),
  [180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_args, 1),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_args, 1),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 1),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 1),
  [198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(107),
  [202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt, 1, .production_id = 2),
  [210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(368),
  [212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt, 1, .production_id = 2),
  [214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(118),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2),
  [226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(335),
  [229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(107),
  [232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(6),
  [235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(25),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_args, 1),
  [240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_args, 1),
  [242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_identifier, 1, .production_id = 1),
  [244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_identifier, 1, .production_id = 1),
  [246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_concatenation, 2),
  [250] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_concatenation, 2),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 2),
  [256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_specifiers_repeat1, 2),
  [258] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 2), SHIFT_REPEAT(499),
  [261] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg, 1),
  [263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg, 1),
  [265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [267] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [269] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(331),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_specifiers, 1),
  [274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_specifiers, 1),
  [276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg_with_paren, 3, .production_id = 17),
  [278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg_with_paren, 3, .production_id = 17),
  [280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_substitution_arg, 3),
  [282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_substitution_arg, 3),
  [284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 2),
  [286] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 2),
  [288] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arg, 1, .production_id = 7),
  [290] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arg, 1, .production_id = 7),
  [292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arg_identifier, 1),
  [294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arg_identifier, 1),
  [296] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 2),
  [298] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 2),
  [300] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_spec_arg_identifier, 1),
  [302] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_spec_arg_identifier, 1),
  [304] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_specifiers_repeat1, 3),
  [306] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_specifiers_repeat1, 3),
  [308] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_double_quoted_arg, 3),
  [310] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_double_quoted_arg, 3),
  [312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_single_quoted_arg, 3),
  [314] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_single_quoted_arg, 3),
  [316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2),
  [320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(380),
  [323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_arg, 1),
  [325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_arg, 1),
  [327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cmd_identifier, 2, .production_id = 6),
  [329] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cmd_identifier, 2, .production_id = 6),
  [331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_concatenation, 2),
  [333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_concatenation, 2),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_dot_arg_identifier, 1),
  [341] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg, 1),
  [343] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg, 1),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [349] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2),
  [351] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(352),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_concatenation, 2),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_concatenation, 2),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 19),
  [360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arg_parentheses, 3, .production_id = 19),
  [362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_arg_identifier, 1),
  [364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_arg_identifier, 1),
  [366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 1),
  [368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 1),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(12),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2),
  [384] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(110),
  [387] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(13),
  [390] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(12),
  [393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val, 1),
  [395] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val, 1),
  [397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_arg, 1, .production_id = 7),
  [401] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_arg, 1, .production_id = 7),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [405] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [407] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key_concatenation, 2),
  [409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_args, 2),
  [413] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_args, 2),
  [415] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(320),
  [418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_key, 1),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_key, 1),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2),
  [428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 2), SHIFT_REPEAT(136),
  [431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [433] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_key_concatenation_repeat1, 2), SHIFT_REPEAT(354),
  [438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_concatenation_repeat1, 2), SHIFT_REPEAT(377),
  [443] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [445] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2),
  [447] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 2), SHIFT_REPEAT(497),
  [450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2),
  [454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__eq_sep_val_concatenation_repeat1, 2), SHIFT_REPEAT(308),
  [457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [459] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2),
  [461] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tmp_eval_args_repeat1, 2), SHIFT_REPEAT(429),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__eq_sep_val_concatenation, 2),
  [468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 1),
  [472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_tmp_eval_arg_repeat1, 1),
  [474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 2),
  [476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 2),
  [478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_stmt, 4, .production_id = 3),
  [482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_stmt, 4, .production_id = 3),
  [484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(8),
  [490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(14),
  [492] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(146),
  [495] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(8),
  [498] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_grep_specifier_repeat1, 2), SHIFT_REPEAT(14),
  [501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [503] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_pf_dot_args_repeat1, 4),
  [505] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_args, 1),
  [507] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_args, 1),
  [509] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_stmt, 2),
  [511] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_stmt, 2),
  [513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [515] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_stmt, 2),
  [517] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_stmt, 2),
  [519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_stmt, 2),
  [523] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_stmt, 2),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 1),
  [529] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 1),
  [531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(492),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(243),
  [557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(238),
  [561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(228),
  [573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(355),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [635] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_stmt, 1, .production_id = 3),
  [637] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_stmt, 1, .production_id = 3),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [641] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fs_stmt, 3),
  [643] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fs_stmt, 3),
  [645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 9),
  [647] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 9),
  [649] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 3, .production_id = 9),
  [651] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 3, .production_id = 9),
  [653] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__Cf_args, 2),
  [655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__Cf_args, 2),
  [657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 14),
  [659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_cmd, 3, .production_id = 14),
  [661] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 14),
  [663] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd, 3, .production_id = 14),
  [665] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [667] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 1),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_stmt, 1, .production_id = 4),
  [673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_stmt, 1, .production_id = 4),
  [675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arged_stmt, 1, .production_id = 5),
  [677] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arged_stmt, 1, .production_id = 5),
  [679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__last_stmt, 1, .production_id = 2),
  [681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__last_stmt, 1, .production_id = 2),
  [683] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_stmt, 3, .production_id = 15),
  [685] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_stmt, 3, .production_id = 15),
  [687] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipe_stmt, 3),
  [689] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipe_stmt, 3),
  [691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_file_lines_stmt, 3),
  [693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_file_lines_stmt, 3),
  [695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsets_stmt, 3),
  [697] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsets_stmt, 3),
  [699] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_offsetssizes_stmt, 3),
  [701] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_offsetssizes_stmt, 3),
  [703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call, 3, .production_id = 23),
  [705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call, 3, .production_id = 23),
  [707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_repeat_stmt, 2, .production_id = 11),
  [709] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_repeat_stmt, 2, .production_id = 11),
  [711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_step_stmt, 3),
  [713] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_step_stmt, 3),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_seek_stmt, 3),
  [717] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_seek_stmt, 3),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_blksz_stmt, 3),
  [721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_blksz_stmt, 3),
  [723] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_arch_stmt, 3),
  [725] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_arch_stmt, 3),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_bits_stmt, 3),
  [729] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_bits_stmt, 3),
  [731] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_nthi_stmt, 3),
  [733] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_nthi_stmt, 3),
  [735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_eval_stmt, 3),
  [737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_eval_stmt, 3),
  [739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reli_stmt, 3),
  [741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reli_stmt, 3),
  [743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_kuery_stmt, 3),
  [745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_kuery_stmt, 3),
  [747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fd_stmt, 3),
  [749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fd_stmt, 3),
  [751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_reg_stmt, 3),
  [753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_reg_stmt, 3),
  [755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_file_stmt, 3),
  [757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_file_stmt, 3),
  [759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_string_stmt, 3),
  [761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_string_stmt, 3),
  [763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_value_stmt, 3),
  [765] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_value_stmt, 3),
  [767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_hex_stmt, 3),
  [769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_hex_stmt, 3),
  [771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt, 2, .production_id = 8),
  [773] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt, 2, .production_id = 8),
  [775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_arged_stmt_question, 2, .production_id = 8),
  [777] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_arged_stmt_question, 2, .production_id = 8),
  [779] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_call, 2),
  [781] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_call, 2),
  [783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__macro_arged_stmt, 2, .production_id = 9),
  [785] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__macro_arged_stmt, 2, .production_id = 9),
  [787] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_register_stmt, 2),
  [789] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_register_stmt, 2),
  [791] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbgmap_stmt, 2),
  [793] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbgmap_stmt, 2),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [797] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_iomap_stmt, 2),
  [799] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_iomap_stmt, 2),
  [801] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_stmt, 1, .production_id = 2),
  [803] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_stmt, 1, .production_id = 2),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 3, .production_id = 13),
  [809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 3, .production_id = 13),
  [811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__search_stmt, 2, .production_id = 8),
  [813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__search_stmt, 2, .production_id = 8),
  [815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_legacy_quoted_stmt, 3, .production_id = 12),
  [817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_legacy_quoted_stmt, 3, .production_id = 12),
  [819] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_string_stmt, 2),
  [821] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_string_stmt, 2),
  [823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_symbol_stmt, 2),
  [825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_symbol_stmt, 2),
  [827] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_segments_stmt, 2),
  [829] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_segments_stmt, 2),
  [831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_sections_stmt, 2),
  [833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_sections_stmt, 2),
  [835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pf_arged_stmt, 2, .production_id = 8),
  [837] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pf_arged_stmt, 2, .production_id = 8),
  [839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_new_args, 2),
  [841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_new_args, 2),
  [843] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_import_stmt, 2),
  [845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_import_stmt, 2),
  [847] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_Cf_cmd, 2, .production_id = 8),
  [849] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_Cf_cmd, 2, .production_id = 8),
  [851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_instrs_stmt, 2),
  [853] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_instrs_stmt, 2),
  [855] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_bbs_stmt, 2),
  [857] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_bbs_stmt, 2),
  [859] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_threads_stmt, 2),
  [861] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_threads_stmt, 2),
  [863] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbts_stmt, 2),
  [865] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbts_stmt, 2),
  [867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbtb_stmt, 2),
  [869] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbtb_stmt, 2),
  [871] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_cmd, 2, .production_id = 8),
  [873] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_cmd, 2, .production_id = 8),
  [875] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_eq_sep_args, 3),
  [877] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_eq_sep_args, 3),
  [879] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_grep_specifier, 2),
  [881] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_grep_specifier, 2),
  [883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_dbta_stmt, 2),
  [885] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_dbta_stmt, 2),
  [887] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_hit_stmt, 4, .production_id = 20),
  [889] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_hit_stmt, 4, .production_id = 20),
  [891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_comment_stmt, 4),
  [893] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_comment_stmt, 4),
  [895] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_flags_stmt, 4),
  [897] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_flags_stmt, 4),
  [899] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_function_stmt, 4),
  [901] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_function_stmt, 4),
  [903] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tmp_fromto_stmt, 4),
  [905] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tmp_fromto_stmt, 4),
  [907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__env_stmt, 2, .production_id = 8),
  [909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__env_stmt, 2, .production_id = 8),
  [911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_stmt, 2, .production_id = 10),
  [913] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_stmt, 2, .production_id = 10),
  [915] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__system_stmt, 2, .production_id = 8),
  [917] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__system_stmt, 2, .production_id = 8),
  [919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pointer_arged_stmt, 2, .production_id = 8),
  [921] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pointer_arged_stmt, 2, .production_id = 8),
  [923] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_stmt, 5, .production_id = 3),
  [925] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_macro_stmt, 5, .production_id = 3),
  [927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_html_enable_stmt, 2, .production_id = 2),
  [929] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_html_enable_stmt, 2, .production_id = 2),
  [931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 22),
  [933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pf_dot_cmd_args, 3, .production_id = 22),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(58),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(41),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_offsetssizes_stmt, 3),
  [965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_offsetssizes_stmt, 3),
  [967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_iter_interpret_stmt, 3),
  [969] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_iter_interpret_stmt, 3),
  [971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat1, 2),
  [979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statements_repeat1, 2), SHIFT_REPEAT(269),
  [982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_statements_repeat1, 2),
  [984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat1, 2),
  [986] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat1, 2), SHIFT_REPEAT(270),
  [989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__statements_singleline_repeat1, 2),
  [991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__dec_number, 1),
  [993] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__dec_number, 1),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(334),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [1013] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(361),
  [1016] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(295),
  [1019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(334),
  [1022] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(333),
  [1025] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(334),
  [1028] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(408),
  [1031] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(26),
  [1034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_args_repeat1, 2), SHIFT_REPEAT(29),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(149),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [1059] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(332),
  [1062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [1066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [1068] = {.entry = {.count = 1, .reusable = false}}, SHIFT(450),
  [1070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [1072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [1074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [1078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(385),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [1088] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(338),
  [1091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(385),
  [1094] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(385),
  [1097] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(28),
  [1100] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_args_repeat1, 2), SHIFT_REPEAT(27),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [1109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(95),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1125] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1127] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 1),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(364),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(22),
  [1137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpret_search_identifier, 1),
  [1151] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpret_search_identifier, 1),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [1161] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2),
  [1163] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(364),
  [1166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(364),
  [1169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(22),
  [1172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_double_quoted_arg_repeat1, 2), SHIFT_REPEAT(21),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(126),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(154),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(365),
  [1183] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pf_concatenation_repeat1, 2), SHIFT_REPEAT(351),
  [1186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [1190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(371),
  [1192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(78),
  [1194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [1198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_redirect_operator, 2),
  [1202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [1204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(455),
  [1206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 2),
  [1208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 2),
  [1210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [1212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [1214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [1216] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fdn_append_operator, 1),
  [1218] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fdn_append_operator, 1),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(330),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_redirect_stmt, 3, .production_id = 16),
  [1235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 2),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [1239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_statements, 3),
  [1241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 2),
  [1243] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_statements_repeat2, 2), SHIFT_REPEAT(5),
  [1246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [1248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [1252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [1254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [1258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [1260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [1262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(410),
  [1264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [1266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [1268] = {.entry = {.count = 1, .reusable = false}}, SHIFT(81),
  [1270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(407),
  [1274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(324),
  [1276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [1278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(417),
  [1282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2),
  [1284] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(415),
  [1287] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_single_quoted_arg_repeat1, 2), SHIFT_REPEAT(415),
  [1290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(396),
  [1292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(135),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1296] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [1298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(456),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1302] = {.entry = {.count = 1, .reusable = false}}, SHIFT(421),
  [1304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(152),
  [1306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(441),
  [1308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 2),
  [1312] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2),
  [1314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 1),
  [1316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_body, 2),
  [1318] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [1320] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2), SHIFT_REPEAT(31),
  [1323] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statements_singleline, 3),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [1331] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_body, 3),
  [1333] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__statements_singleline_repeat2, 2), SHIFT_REPEAT(30),
  [1336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_macro_body_repeat1, 2),
  [1338] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_macro_body_repeat1, 2), SHIFT_REPEAT(35),
  [1341] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(329),
  [1344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [1346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [1352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [1354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 3, .production_id = 21),
  [1356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [1362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [1368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1374] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [1378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [1382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [1384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [1388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [1390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [1392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [1394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [1396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [1398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [1400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [1402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [1404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [1406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [1408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [1410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [1412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1416] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [1422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [1424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_macro_content, 2, .production_id = 18),
  [1426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [1428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [1430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [1432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [1434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [1438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [1440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [1442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [1444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_rzcmd_external_scanner_create(void);
void tree_sitter_rzcmd_external_scanner_destroy(void *);
bool tree_sitter_rzcmd_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_rzcmd_external_scanner_serialize(void *, char *);
void tree_sitter_rzcmd_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_rzcmd(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_rzcmd_external_scanner_create,
      tree_sitter_rzcmd_external_scanner_destroy,
      tree_sitter_rzcmd_external_scanner_scan,
      tree_sitter_rzcmd_external_scanner_serialize,
      tree_sitter_rzcmd_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
